/* ==================================
     ZMS->ZMD common track compile
   ================================== */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "switch.h"
#include "parsesub.h"
#include "etc.h"
#include "68lib.h"
#include "structs.h"
enum {
#define ZMSCOMMAND(c,s) c,
#include "zmscmd.h"
#undef ZMSCOMMAND
	END_OF_ZMSCMD
};
TRKCHINF *makeZmdCommon(TRKCHINF *trkdata,UBYTE *zms, UBYTE **zms2,COMMONINF *cominf);
void compressCommonTrkExclusive(TRKCHINF *trkdata,UBYTE **bpr1,UBYTE *bpr2);
UBYTE *macroExclusive0(UBYTE *zms, BYTE e[], const DWORD elen,
						int idflag, int roland, UBYTE **ex_b,TRKCHINF *trkdata);
UBYTE *macroExclusiveN(UBYTE *zms, BYTE e[], const DWORD elen,const DWORD zmdlen,
						int idflag, int roland, const UBYTE mdl,const int warnlvl,
						UBYTE *warn, UBYTE **ex_b, TRKCHINF *trkdata);
UBYTE *getDevice(UBYTE *zms, DWORD *ch, COMMONINF *cominf);
UBYTE *setTempo(UBYTE *zms, UBYTE **ex_b, char *endchar,
					TRKCHINF *trkdata,COMMONINF *cominf);
UBYTE *initializeZMD(UBYTE *zms, UBYTE **ex_b, char *endchar);
UBYTE *setMasterClock(UBYTE *zms, UBYTE **ex_b, char *endchar,
						TRKCHINF *trkdata,COMMONINF *cominf);
extern LINEDATA *ld;
extern char *linebuf;
/* (BEGIN FM/ADPCMsupport by Mamiya */
typedef struct {
	WORD note;
	WORD pitchpara;
	WORD volumepara;
	WORD mixdelay;
	WORD mixnote;
	WORD cutofs;
	WORD cutsize;
	BYTE revsw;
	WORD fadeofs;
	BYTE fadedir;
	BYTE fadelevel;
	WORD srcnote;
} REGISTER_PCM;
UBYTE *makeZmdCommonRegPcm(UBYTE *zms,TRKCHINF *trkdata,DWORD note, DWORD bank)
{
	const REGISTER_PCM initreg = {
		0, -333, -333, 0,-1, 0,0, 0, 0,0,0 ,-333
	};
	DWORD tmpDWORD;
	UBYTE *strstart = NULL;
	int err, srclen;
	REGISTER_PCM *rp;
	rp = emalloc(sizeof(REGISTER_PCM), "rp");
	*rp = initreg;	/* memcpy(rp, initreg, sizeof(REGISTER_PCM)); */
	rp->note = note;
	if (bank) rp->note += bank << 7;
	zms = skipSpc(zms);
	if (*zms == '=') zms = skipSpc(zms + 1);
	if (('0' <= *zms && *zms <= '9') || *zms == '$' || *zms == '%') {
		zms = getnum3(zms, &tmpDWORD, &err);
		rp->srcnote = tmpDWORD;
		srclen = 0;
	} else if (*zms == '\"' || *zms == '\'') {
		UBYTE endc;
		endc = *zms++;
		strstart = zms;
		while (*zms >= ' ' && *zms != endc && *zms != 0xff) zms++;
		srclen = zms - strstart;
		if (*zms == endc) zms++;
	} else {
		strstart = zms;
		while (*zms > ' ' && *zms != ',' && *zms != '/' && *zms != 0xff) zms++;
		srclen = zms - strstart;
	}
	zms = skipSpc(zms);
	while (1) {
		if (*zms == ',') zms = skipSpc(zms + 1);
		switch (*zms) {
			case 'p':	case 'P':
				zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
				rp->pitchpara = tmpDWORD + 12;
				if (rp->volumepara == -333) rp->volumepara = 100;
				continue;
			case 'v':	case 'V':
				zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
				rp->volumepara = tmpDWORD;
				if (rp->pitchpara == -333) rp->pitchpara = 12;
				continue;
			case 'm':	case 'M':
				zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
				rp->mixnote = tmpDWORD;
				/* if (bank) rp->mixnote += bank << 7; */
				if (*zms == ',') {
					zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
					rp->mixdelay = tmpDWORD;
				}
				continue;
			case 'c':	case 'C':
				zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
				rp->cutofs = tmpDWORD;
				if (*zms == ',') {
					zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
					rp->cutsize = tmpDWORD;
				}
				continue;
			case 'r':	case 'R':
				rp->revsw = -1;
				zms++;
				continue;
			case 'f':	case 'F':
				zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
				if (tmpDWORD < 0) {
					rp->fadeofs = -tmpDWORD;
					rp->fadedir = -1;
				} else {
					rp->fadeofs = tmpDWORD;
					rp->fadedir = 1;
				}
				if (*zms == ',') {
					zms = skipSpc(getnum3(zms + 1, &tmpDWORD, &err));
					rp->fadelevel = tmpDWORD;
				}
				continue;
			default:
				break;
		}
		break;
	}
	if (rp->pitchpara == -333) rp->pitchpara = 0;
	if (rp->volumepara == -333) rp->volumepara = 0;
	*trkdata[0].zmd++ = 0x40;
	putWord(trkdata[0].zmd, rp->note);
	trkdata[0].zmd += 2;
	putWord(trkdata[0].zmd, rp->pitchpara);
	trkdata[0].zmd += 2;
	putWord(trkdata[0].zmd, rp->volumepara);
	trkdata[0].zmd += 2;
	putWord(trkdata[0].zmd, rp->mixdelay);
	trkdata[0].zmd += 2;
	putWord(trkdata[0].zmd, rp->mixnote);
	trkdata[0].zmd += 2;
	putWord(trkdata[0].zmd, rp->cutofs);
	trkdata[0].zmd += 2;
	putWord(trkdata[0].zmd, rp->cutsize);
	trkdata[0].zmd += 2;
	*trkdata[0].zmd++ = rp->revsw;
	putWord(trkdata[0].zmd, rp->fadeofs);
	trkdata[0].zmd += 2;
	*trkdata[0].zmd++ = rp->fadedir;
	*trkdata[0].zmd++ = rp->fadelevel;
	if (rp->srcnote != -333) {
		putWord(trkdata[0].zmd, 0);
		trkdata[0].zmd += 2;
		putWord(trkdata[0].zmd, rp->srcnote);
		trkdata[0].zmd += 2;
	} else {
		int i;
		for (i = 0; i < srclen; i++) *trkdata[0].zmd++ = strstart[i];
		*trkdata[0].zmd++ = 0;
	}
	efree(rp, "rp");
	return zms;
}
/* FM/ADPCMsupport by Mamiya END) */
/* (BEGIN U220/M1support by Mamiya */
UBYTE *makeZmdCommonU220Setup(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD var, dev;
	int i, pnum, err;
	UBYTE *expara;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	const UBYTE ed[11] = { 0xf0,0x41,0x10,0x2b,0x12,0x00,0x00,0x00,0x0e,0x07,0x0a };
	expara = emalloc(sizeof(ed) + sizeof(UBYTE) * (40 + 7), "expara_u220setup");
	memcpy(expara, ed, sizeof(ed));
	zms = getnum2(zms,&dev,&err);
	if (err < 0) {
		dev = cominf->u220id;
	} else if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (dev < 0) {
		/* It is not to be error in V2, but.... */
	}
	expara[2] = cominf->u220id = dev;
	zms = skiptochr(zms,"{") + 1;
	for (pnum = 0; pnum < 7; pnum++) {
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		expara[11 + 40 + pnum] = var;
	}
	for (i = pnum; i < 7; i++) expara[11 + 40 + i] = 0;
	i = 11;
#define PARA(a) ((UDWORD)expara[11 + 40 + a])
	expara[i++] = (PARA(0) << 1) | PARA(1);
	if (pnum > 2) {
		expara[i++] = 0;
		expara[i++] = 0;
		expara[i++] = 0;
		expara[i++] = 0;
		var = (PARA(2) < 1 || 16 < PARA(2)) ? 0x10 : (PARA(2) - 1);
		expara[i++] = var & 0xf;
		expara[i++] = (var >> 4) & 0xf;
		if (pnum > 3) {
			int j;
			expara[i++] = 0;
			expara[i++] = 0;
			for (j = 3; j < pnum; j++) {
				expara[i++] = PARA(j);
			}
		}
	}
#undef PARA
	zms = skiptochr(zms,"}") + 1;
	*trkdata[0].zmd++ = 0x18;
	putWord(ex_b0, i + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	efree(expara, "expara_u220setup");
	return zms;
}
UBYTE *makeZmdCommonU220PartSetup(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD var, dev;
	int i, err;
	UBYTE *expara;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	const UBYTE ed[8] = { 0xf0,0x41,0x10,0x2b,0x12,0x00,0x00,0x00 };
	expara = emalloc(sizeof(ed) + sizeof(UBYTE) * (40 + 13), "expara_u220partsetup");
	memcpy(expara, ed, sizeof(ed));
	zms = getnum2(zms,&var,&err);
	if (err) {
		zmserror(".u220_part_setup must be followed to its parameter.",linebuf,zms,0,1);
	} else if (var < 1 || 6 < var) {
		zmserror("part number is out of range(1-6).",linebuf,zms,0,1);
	}
	var = (0x3c + ((var - 1) << 4)) | 0x300;
	expara[6] = (var >> 7) & 0x7f;
	expara[7] = var & 0x7f;
	zms = skipchr(zms,", \t\x0d\x0a");
	zms = getnum2(zms,&dev,&err);
	if (err < 0) {
		dev = cominf->u220id;
	} else if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (dev < 0) {
		/* It is not to be error in V2, but.... */
	}
	expara[2] = cominf->u220id = dev;
	zms = skiptochr(zms,"{") + 1;
	for (i = 0; i < 13; i++) {
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		expara[8 + 40 + i] = var;
	}
	for (; i < 13; i++) expara[8 + 40 + i] = 0;
	i = 8;
#define PARA(a) ((UDWORD)expara[8 + 40 + a])
	var = (PARA(10) << 7) | (PARA(0) - 1);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(7) << 5) | PARA(1);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(2) < 1 || 16 < PARA(2)) ? 0x10 : (PARA(2) - 1);
	var = (PARA(9) << 12) | (PARA(8) << 5) | var;
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(12) << 7) | PARA(3);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(11) << 7) | PARA(4);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(5);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(6);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
#undef PARA
	zms = skiptochr(zms,"}") + 1;
	*trkdata[0].zmd++ = 0x18;
	putWord(ex_b0, i + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	efree(expara, "expara_u220partsetup");
	return zms;
}
UBYTE *makeZmdCommonU220Common(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD var, dev;
	int i, err;
	UBYTE *expara;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	const UBYTE ed[8] = { 0xf0,0x41,0x10,0x2b,0x12,0x00,0x06,0x18 };
	expara = emalloc(sizeof(ed) + sizeof(UBYTE) * (40 + 18), "expara_u220common");
	memcpy(expara, ed, sizeof(ed));
	zms = getnum2(zms,&dev,&err);
	if (err < 0) {
		dev = cominf->u220id;
	} else if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (dev < 0) {
		/* It is not to be error in V2, but.... */
	}
	expara[2] = cominf->u220id = dev;
	zms = skiptochr(zms,"{") + 1;
	for (i = 0; i < 18; i++) {
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		expara[8 + 40 + i] = var;
	}
	for (; i < 18; i++) expara[8 + 40 + i] = 0;
	i = 8;
#define PARA(a) ((UDWORD)expara[8 + 40 + a])
	var = (PARA(5) << 11) | (PARA(2) << 6) | PARA(4);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(0) << 13) | (PARA(6) << 7) | PARA(8);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(10) << 11) | PARA(3);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(1) << 15) | (((PARA(7) << 12) | (PARA(11) << 6) | PARA(9)) & 0x7fff);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(13) << 8) | PARA(12);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(15) << 8) | PARA(14);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(17) << 8) | PARA(16);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
#undef PARA
	zms = skiptochr(zms,"}") + 1;
	*trkdata[0].zmd++ = 0x18;
	putWord(ex_b0, i + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	efree(expara, "expara_u220common");
	return zms;
}
UBYTE *makeZmdCommonU220Timber(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD var, dev;
	int i, err;
	UBYTE *expara;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	const UBYTE ed[8] = { 0xf0,0x41,0x10,0x2b,0x12,0x02,0x00,0x00 };
	expara = emalloc(sizeof(ed) + sizeof(UBYTE) * (24 + 40 + 26), "expara_u220timber");
	memcpy(expara, ed, sizeof(ed));
	zms = getnum2(zms,&var,&err);
	if (err) {
		zmserror(".u220_timbre must be followed to its parameter.",linebuf,zms,0,1);
	} else if (var < 1 || 128 < var) {
		zmserror("program number is out of range(1-128).",linebuf,zms,0,1);
	}
	var = (var - 1) << 6;
	expara[6] = (var >> 7) & 0x7f;
	expara[7] = var & 0x7f;
	zms = skipchr(zms,", \t\x0d\x0a");
	zms = getnum2(zms,&dev,&err);
	if (err < 0) {
		dev = cominf->u220id;
	} else if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (dev < 0) {
		/* It is not to be error in V2, but.... */
	}
	expara[2] = cominf->u220id = dev;
	zms = skiptochr(zms,"{") + 1;
	zms = skiptochr(zms,"\"") + 1;
	for (i = 8; i < 8 + 24;) {
		if (*zms == '\"') break;
		expara[i++] = *zms & 0xf;
		expara[i++] = (*(zms++) >> 4) & 0xf;
	}
	while (i < 8 + 24) {
		expara[i++] = 0;
		expara[i++] = 2;
	}
	zms = skiptochr(zms,"\"") + 1;
	zms = skipchr(zms,", \t\x0d\x0a");
	for (i = 0; i < 26; i++) {
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		expara[8 + 24 + 40 + i] = var;
	}
	for (; i < 26; i++) expara[8 + 24 + 40 + i] = 0;
	i = 8 + 24;
#define PARA(a) ((UDWORD)expara[8 + 24 + 40 + a])
	var = (PARA(17) << 12) | (PARA(0) << 7) | (PARA(1) - 1);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(4) << 4) | PARA(3);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(2);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(6) << 4) | PARA(5);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(8) << 4) | PARA(7);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(10);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(9);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(15) << 9) | (PARA(12) << 5) | PARA(11);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = (PARA(16) << 10) | (PARA(13) << 5) | PARA(14);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = (var >> 8) & 0xf;
	expara[i++] = (var >> 12) & 0xf;
	var = PARA(23) << 4;
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(20) << 4) | PARA(21);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(18);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(19);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = PARA(22);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	var = (PARA(25) << 4) | PARA(24);
	expara[i++] = var & 0xf;
	expara[i++] = (var >> 4) & 0xf;
	expara[i++] = 0;
	expara[i++] = 0;
	expara[i++] = 0;
	expara[i++] = 0;
#undef PARA
	zms = skiptochr(zms,"}") + 1;
	*trkdata[0].zmd++ = 0x18;
	putWord(ex_b0, i + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	efree(expara, "expara_u220timber");
	return zms;
}
UBYTE *makeZmdCommonU220DrumSetup(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD dev;
	int i, err;
	UBYTE *expara;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	const UBYTE ed[8] = { 0xf0,0x41,0x10,0x2b,0x12,0x00,0x06,0x34 };
	expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 8, "expara_u220drumsetup");
	memcpy(expara, ed, sizeof(ed));
	zms = getnum2(zms,&dev,&err);
	if (err < 0) {
		dev = cominf->u220id;
	} else if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (dev < 0) {
		/* It is not to be error in V2, but.... */
	}
	expara[2] = cominf->u220id = dev;
	zms = skiptochr(zms,"{") + 1;
	for (i = 8; i < 8 + 7; i++) {
		DWORD var;
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		expara[i] = var;
	}
	for (; i < 8 + 7; i++) {
		expara[i] = 0;
	}
	if (expara[10] < 1 || 16 < expara[10])
		expara[10] = 0x10;
	else
		expara[10]--;
	expara[8] = (expara[8] << 5) | expara[9];
	expara[10] |= (expara[13] << 6) | (expara[14] << 5);
	expara[12] = expara[11] | (expara[12] << 7);
	expara[9] = (expara[8] >> 4) & 0xf;
	expara[8] &= 0xf;
	expara[11] = (expara[10] >> 4) & 0xf;
	expara[10] &= 0xf;
	expara[13] = (expara[12] >> 4) & 0xf;
	expara[12] &= 0xf;
	expara[15] = expara[14] = 0;
	zms = skiptochr(zms,"}") + 1;
	*trkdata[0].zmd++ = 0x18;
	putWord(ex_b0, 16 + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, expara, 16, 1);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	efree(expara, "expara_u220drumsetup");
	return zms;
}
UBYTE *makeZmdCommonU220DrumInst(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD note, dev;
	int i, err;
	BYTE *expara;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	const UBYTE ed[8] = { 0xf0,0x41,0x10,0x2b,0x12,0x11,0x00,0x00 };
	expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 20, "expara_u220druminst");
	memcpy(expara, ed, sizeof(ed));
	zms = getnum2(zms,&note,&err);
	if (err) {
		zmserror(".u220_drum_inst must be followed to its parameter.",linebuf,zms,0,1);
	} else if (note < 35 || 99 < note) {
		zmserror(".u220_drum_inst parameter is out of range(35-99).",linebuf,zms,0,1);
	}
	expara[6] = note;
	zms = skipchr(zms,", \t\x0d\x0a");
	zms = getnum2(zms,&dev,&err);
	if (err < 0) {
		dev = cominf->u220id;
	} else if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (dev < 0) {
		/* It is not to be error in V2, but.... */
	}
	expara[2] = cominf->u220id = dev;
	zms = skiptochr(zms,"{") + 1;
	for (i = 8; i < 8 + 20; i++) {
		DWORD var;
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		if (i == 8 + 1) var--;
		expara[i] = var;
	}
	zms = skiptochr(zms,"}") + 1;
	*trkdata[0].zmd++ = 0x18;
	putWord(ex_b0, i + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	efree(expara, "expara_u220druminst");
	return zms;
}
UBYTE *makeZmdCommonU220Print(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD dev;
	int i, err;
	BYTE *expara;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	const int elen = 8 + 24;
	const UBYTE ed[8] = { 0xf0,0x41,0x10,0x2b,0x12,0x00,0x06,0x00 };
	expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 24, "expara_u220print");
	memcpy(expara, ed, sizeof(ed));
	zms = getnum2(zms,&dev,&err);
	if (err < 0) {
		dev = cominf->u220id;
	} else if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (dev < 0) {
		/* It is not to be error in V2, but.... */
	}
	expara[2] = cominf->u220id = dev;
	zms = skiptochr(zms,"\"") + 1;
	for (i = 0; i < 12; i++) {
		if (*zms == '\"') break;
		expara[8 + (i << 1)] = *zms & 0xf;
		expara[8 + (i << 1) + 1] = (*(zms++) >> 4) & 0xf;
	}
	for (; i < 12; i++) {
		expara[8 + (i << 1)] = 0;
		expara[8 + (i << 1) + 1] = 2;
	}
	zms = skiptochr(zms,"\"") + 1;
	*trkdata[0].zmd++ = 0x18;
	putWord(trkdata[0].zmd, elen + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, expara, elen, 1);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	efree(expara, "expara_u220print");
	return zms;
}
UBYTE *makeZmdCommonM1MidiCh(UBYTE *zms,COMMONINF *cominf)
{
	int i;
	zms = skiptochr(zms,"{") + 1;
	for (i = 0; i < 8; i++) {
		int err;
		DWORD var;
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		if (1 <= var && var <= 16) {
			cominf->m1setup[0x09 + i + (i > 6)] = var - 1;
			cominf->m1setup[0x12 + i + (i > 5)] = 3;
		} else {
			cominf->m1setup[0x09 + i + (i > 6)] = 0;
			cominf->m1setup[0x12 + i + (i > 5)] = 0;
		}
	}
	for (; i < 8; i++) {
		cominf->m1setup[0x09 + i + (i > 6)] = 0;
		cominf->m1setup[0x12 + i + (i > 5)] = 0;
	}
	zms = skiptochr(zms,"}") + 1;
	return zms;
}
UBYTE *makeZmdCommonM1PartSetup(UBYTE *zms,COMMONINF *cominf)
{
	int e;
	const int emax = 0x49 + 40 + 5;
	zms = skiptochr(zms,"{") + 1;
	for (e = 0x49; e < emax; e++) {
		int err;
		DWORD var;
		if ((e & 7) == 0) continue;
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		cominf->m1setup[e] = var;
	}
	for (; e < emax; e++) {
		if ((e & 7) == 0) continue;
		cominf->m1setup[e] = 0;
	}
	zms = skiptochr(zms,"}") + 1;
	return zms;
}
UBYTE *makeZmdCommonM1EffectSetup(UBYTE *zms,COMMONINF *cominf)
{
	int e;
	const int emax = 0x2c + 25 + 3;
	zms = skiptochr(zms,"{") + 1;
	for (e = 0x2c; e < emax; e++) {
		int err;
		DWORD var;
		if ((e & 7) == 0) continue;
		zms = getnum2(zms,&var,&err);
		if (err) break;
		zms = skipchr(zms,", \t\x0d\x0a");
		cominf->m1setup[e] = var;
	}
	for (; e < emax; e++) {
		if ((e & 7) == 0) continue;
		cominf->m1setup[e] = 0;
	}
	zms = skiptochr(zms,"}") + 1;
	return zms;
}
UBYTE *makeZmdCommonM1Print(UBYTE *zms,COMMONINF *cominf)
{
	int i;
	zms = skiptochr(zms,"\"") + 1;
	for (i = 0x1f; i < 0x1f + 10 + 2; i++) {
		if (*zms == '\"') break;
		if ((i & 7) == 0) continue;
		cominf->m1setup[i] = *(zms++) & 0x7f;
	}
	for (; i < 0x1f + 10 + 2; i++) {
		if ((i & 7) == 0) continue;
		cominf->m1setup[i] = ' ';
	}
	zms = skiptochr(zms,"\"") + 1;
	return zms;
}
UBYTE *makeZmdCommonM1Send(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp,COMMONINF *cominf)
{
	DWORD id;
	int err;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	zms = getnum3(zms,&id,&err);
	if (err > 0) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	} else if (!err) {
		cominf->m1setup[2] = cominf->m1setup[0x79] = id;
	}
	*trkdata[0].zmd++ = 0x18;
	putWord(trkdata[0].zmd, sizeof(cominf->m1setup));
	trkdata[0].zmd += 2;
	memcpy(trkdata[0].zmd, cominf->m1setup, sizeof(cominf->m1setup));
	trkdata[0].zmd += sizeof(cominf->m1setup);
	compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
	return zms;
}
/* U220M1support by Mamiya END) */
UBYTE *makeZmdCommonQuantizeMode(UBYTE *zms,COMMONINF *cominf) {
	DWORD var;
	int err;
	zms = getnum3(zms,&var,&err);
	if (err) {
		int i;
		const char *mode[4] = {"zmc2old","zmc2v117","v3", "zmc2"};
		for (i = 0; i < 4; i++) {
			if (!stricmp2(zms,mode[i])) {
				zms += strlen(mode[i]);
				var = i + 1;
				break;
			}
		}
		if (i == 4) {
			zmserror(".quanzite_mode must be followed to its parameter.",linebuf,zms,0,1);
		} else if (var == 4) {
			var = 1;
		}
	} else if (var < 1 || 3 < var) {
		zmserror(".quanzite_mode parameter is out of range(1-3).",linebuf,zms,0,1);
	}
	cominf->qmode = var;
	return zms;
}
UBYTE *makeZmdCommonGatetimeResolution(UBYTE *zms,COMMONINF *cominf) {
	DWORD var;
	int err;
	zms = getnum3(zms,&var,&err);
	if (err) {
		zmserror(".gatetime_resolution must be followed to its parameter.",linebuf,zms,0,1);
	} else if (var < 1) {
		zmserror(".gatetime_resolution parameter is out of range(8-128).",linebuf,zms,0,1);
	}
	switch (var) {
		case 8: case 16: case 32: case 64: 	case 128:
			break;
		default:
			zmserror(".gatetime_resolution parameter is out of range(8,16,32,64,128).",linebuf,zms,4,1);
			break;
	}
	cominf->gtreso = var;
	return zms;
}
UBYTE *makeZmdCommonDummy(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp)
{
	*ex_bp = NULL;
	*trkdata[0].zmd++ = 0x7e;
	return zms;
}
UBYTE *makeZmdCommonPrint(TRKCHINF *trkdata,UBYTE *zms,UBYTE **ex_bp)
{
	*ex_bp = NULL;
	*trkdata[0].zmd++ = 0x61;
	zms = skipSpcCr(zms);
	if (*zms == '\"' || *zms == '\'') {
		UBYTE endc = *zms++;
		while (*zms != endc && *zms != 0xff) {
			if (*zms & 0x80 && *(zms + 1) != 0xff) {
				*trkdata[0].zmd++ = *zms++;
			}
			*trkdata[0].zmd++ = *zms++;
		}
		if (*zms == endc) zms++;
		*trkdata[0].zmd++ = 0x0d;
		*trkdata[0].zmd++ = 0x0a;
	} else {
		UBYTE	*strstart;
		BYTE	cr;
		int		len;
		strstart = zms = skipSpc(zms);
		zms = skipComment(zms);
/* del v1.33 (as CR code is converted to single char)
		cr = (*(zms - 1) == 0x0a && *(zms - 2) == 0x0d) ? 2 : 1;
*/
		cr = 1;
		len = zms - cr - strstart;
		strncpy(trkdata[0].zmd, strstart, len);
		trkdata[0].zmd += len;
	}
	*trkdata[0].zmd++ = 0;
	return zms;
}
UBYTE *makeZmdCommonZmsCommand(TRKCHINF *trkdata,UBYTE *zms, BYTE *trksp,UBYTE **ex_bp,COMMONINF *cominf)
{
	int i;
	{
		const struct {
			int zmscmdcode;
			char *zmscmd;
		} comtbl1[] = {
#define ZMSCOMMAND(c,s) {c, s},
#include "zmscmd.h"
#undef ZMSCOMMAND
			{END_OF_ZMSCMD, NULL},
		};
		for (i = 0;;i++) {
			if (comtbl1[i].zmscmdcode == END_OF_ZMSCMD) break;
			if (!stricmp2(zms,comtbl1[i].zmscmd)) {
				zms += strlen(comtbl1[i].zmscmd);
				break;
			}
		}
		i = comtbl1[i].zmscmdcode;
	}
	switch (i) {
		/*
			ZMSCOMMAND(ZMSCMD_SC88_USER_INST,"SC88_USER_INST")
			ZMSCOMMAND(ZMSCMD_SC88_USER_DRUM,"SC88_USER_DRUM")
			ZMSCOMMAND(ZMSCMD_SC88_DRUM_NAME,"SC88_DRUM_NAME")
		*/
		case ZMSCMD_INCLUDE:			/* .include (V3 extention) */
			zms = skipSpc(zms);
			while (isgraph(*zms) && *zms != '/') {
				zms++;
			}
			break;
		case ZMSCMD_SC88_MODE_SET:		/* ,sc88_mode_set (V3 extention) */
		case ZMSCMD_SC88_MODE:			/* ,sc88_mode (V3 extention) */
						/* 41 id 42 12 00 00 7f xx */
			{
				DWORD mode,id;
				int err;
				const int elen = 9;
				BYTE e[9] = { 0xf0,0x41,0x10,0x42,0x12,0x00,0x00,0x7f,0x00 };
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				/* ex_b = trkdata[0].zmd + 1; */
				zms = getnum2(zms,&mode,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				e[8] = mode;
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&id,&err);
				if (err == -1) {
					id = 0x10;
				} else if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (id < 0) {
					/* It is not to be error in V2, but.... */
				}
				e[2] = id;
				*trkdata[0].zmd++ = 0x18;
				putWord(trkdata[0].zmd, (elen + 2) * 8);	/* +2: checksum,0xf7 */
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, e, elen, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
/*
				zmserror(".sc88_mode_set can use only on V3.",linebuf,zms,3,1);
*/
			}
			break;
		case ZMSCMD_MU100_BASIC_MAP:	/* .mu100_basic_map  (zmc2 extention) */
		case ZMSCMD_MU100_NATIVE_MAP:	/* .mu100_native_map (zmc2 extention) */
			{
				const DWORD elen = 8;
				BYTE e[8] = { 0xf0,0x43, 0x10, 0x49,
								0x00,0x00,0x12,0x00 };
				const int rolandchecksum = 0;
				const int idflag = 1;
				if (i == ZMSCMD_MU100_NATIVE_MAP) {
					e[7] = 0x01;
					zmserror(".mu100_native_map can use only for zmc2.",linebuf,zms,4,1);
				} else {
					zmserror(".mu100_basic_map can use only for zmc2.",linebuf,zms,4,1);
				}
				zms = macroExclusive0(zms, e, elen, idflag,
							rolandchecksum, ex_bp,trkdata);
			}
			break;
		case ZMSCMD_ASSIGN:		/* .assign (V3 extention) */
			*ex_bp = NULL;
			{
				DWORD ch, trk;
				int i, err;
				zms = getnum2(zms,&trk,&err);
				if (err) {
					zmserror("no track number is specified.",linebuf,zms,0,1);
				} else if (trk <= 0) {
					zmserror("illegal track number is specified.",linebuf,zms,0,1);
				}
				for (i = 0; i < *trksp; i++) {
					if (cominf->trkassign[i] == trk) {
						zmserror("The specified track# is already used.",linebuf,zms,0,1);
					}
				}
				zms = skiptochr(zms,"{");
				zms++;
				zms = getDevice(zms,&ch,cominf);
				zms = skiptochr(zms,"}");
				zms++;
				trkdata[trk].ch = trkdata[trk].ch_ = ch;
				cominf->trkassign[(*trksp)++] = trk;
				cominf->trkassign[*trksp] = -1;
/*
				zmserror(".assign can use only on V3.",linebuf,zms,3,1);
*/
			}
			break;
		case ZMSCMD_TEMPO:			/* .tempo (V3 extention) */
			zms = setTempo(zms, ex_bp, NULL, trkdata, cominf);
/*
			zmserror(".tempo can use only on V3.",linebuf,zms,3,1);
*/
			break;
		case ZMSCMD_INITIALIZE:		/* .initialize (V3 extention) */
			zms = initializeZMD(zms, ex_bp, NULL);
/*
			zmserror(".initialize can use only on V3.",linebuf,zms,3,1);
*/
			break;
		case ZMSCMD_MASTER_CLOCK:	/* .master_clock 'V3 extention) */
			zms = setMasterClock(zms, ex_bp, NULL, trkdata, cominf);
/*
			zmserror(".master_clock can use only on V3.",linebuf,zms,3,1);
*/
			break;
		case ZMSCMD_YAMAHA_EXCLUSIVE:
			{
				const UBYTE f0f7 = 1,roland = 2;
				DWORD dev,mdl;
				int err;
				DWORD zmsskip;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				/* ex_b = trkdata[0].zmd + 1; */
				zms = getnum2(zms,&dev,&err);
				if (err < 0) {
					dev = 0x10;
				}
				if (strchr(", \t",*zms)) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&mdl,&err);
#ifdef AAA
					if (err < 0) mdl = 0x16;	/* default:MT-32? */
#endif
				} else {
					mdl = 0x16;	/* default:MT-32? */
				}
				trkdata[0].zmd = exclusive(trkdata[0].zmd, zms, 
											f0f7, &zmsskip,roland,dev,mdl,
											0,"",
											"{","}, \t\x0d\x0a");
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				zms += zmsskip;
/*
				zmserror(".yamaha_exclusive can use only on V3.",linebuf,zms,3,1);
*/
			}
			break;
		case ZMSCMD_COMMENT:
			{
				UBYTE	*strstart;
				BYTE	cr;
				int		len;
				*ex_bp = NULL;
				*trkdata[0].zmd++ = 0x7F;
				zms = skipSpc(zms);
				strstart = zms;
				zms = skipComment(zms);
/* del v1.33 (as CR code is converted into single char)
				if (*(zms - 1) == 0x0a && *(zms - 2) == 0x0d) {
					cr = 2;
				} else {
					cr = 1;
				}
*/
				cr = 1;
				zms -= cr;
				len = zms - strstart;
				strncpy(trkdata[0].zmd , strstart, len);
				/* strstart = trkdata[0].zmd; */
				trkdata[0].zmd   += len;
				*trkdata[0].zmd++ = 0;					/* string end code */
				/* printf("TITLE:%s\n",strstart); */
				zms				+= cr;
			}
			break;
		case ZMSCMD_MIDI_DATA:
		case ZMSCMD_EXCLUSIVE:
			{
				const UBYTE f0f7 = (i == ZMSCMD_MIDI_DATA)? 0 : 1,roland = 0;
				DWORD zmsskip;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				trkdata[0].zmd = exclusive(trkdata[0].zmd, zms,
											f0f7, &zmsskip,roland,0,0,
											0,"",
											"{","}, \t\x0d\x0a");
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				zms += zmsskip;
			}
			break;
		case ZMSCMD_ROLAND_EXCLUSIVE:
			{
				const UBYTE f0f7 = 1,roland = 1;
				DWORD dev,mdl;
				int err;
				DWORD zmsskip;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				/* ex_b = trkdata[0].zmd + 1; */
				zms = getnum2(zms,&dev,&err);
				if (err < 0) {
					dev = 0x10;
				}
				if (strchr(", \t",*zms)) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&mdl,&err);
#ifdef AAA
					if (err < 0) mdl = 0x16;	/* default:MT-32? */
#endif
				} else {
					mdl = 0x16;	/* default:MT-32? */
				}
				trkdata[0].zmd = exclusive(trkdata[0].zmd, zms, 
											f0f7, &zmsskip,roland,dev,mdl,
											0,"",
											"{","}, \t\x0d\x0a");
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				zms += zmsskip;
			}
			break;
		case ZMSCMD_SC55_INIT:
		case ZMSCMD_SC55_RESET:
		case ZMSCMD_GS_INIT:
		case ZMSCMD_GS_RESET:
			/* 18 00 0b f0 41 10 42 12 40 00 7f 00 41 ff */
			{
				DWORD dev;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x42,0x12,0x40,0x00,0x7f};
				int sc88 = 0;
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 1, "expara_sc55_init");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum3(zms,&dev,&err);
				if (err < 0) {
					dev = (!sc88) ? cominf->sc55id : 0x10;
				} else if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (dev < 0) {
					/* It is not to be error in V2, but.... */
				}
				if (!sc88) cominf->sc55id = dev;
				expara[2] = dev;
				i = 8;
				expara[i++] = 0x00;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "expara_sc55_init");
			}
			break;
		case ZMSCMD_GM_SYSTEM_ON:
			/* 18 00 06 F0 7E 7F 09 01 F7 */
			{
				const DWORD elen = 5;
				BYTE e[5] = { 0xf0,0x7e,0x7f,0x09,0x01 };
				const int rolandchecksum = 0;
				const int idflag = 0;
				zms = macroExclusive0(zms, e, elen, idflag,
							rolandchecksum, ex_bp,trkdata);
				zmserror(".gm_system_on can use only on V3.",linebuf,zms,3,1);
			}
			break;
		case ZMSCMD_XG_SYSTEM_ON:	/* zmc2 extention */
			/* 18 00 09 F0 43 10 4C 00 00 7e 00 F7 */
			{
				const DWORD elen = 8;
				BYTE e[8] = { 0xf0,0x43, 0x10, 0x4c,
								0x00,0x00,0x7e,0x00 };
				const int rolandchecksum = 0;
				const int idflag = 1;
				zms = macroExclusive0(zms, e, elen, idflag,
							rolandchecksum, ex_bp,trkdata);
				zmserror(".xg_system_on can use only for zmc2.",linebuf,zms,4,1);
			}
			break;
		case ZMSCMD_SC55_V_RESERVE:
		case ZMSCMD_SC55_PARTIAL_RESERVE:
		case ZMSCMD_GS_V_RESERVE:
		case ZMSCMD_GS_PARTIAL_RESERVE:
		case ZMSCMD_SC55_REVERB:
		case ZMSCMD_GS_REVERB:
		case ZMSCMD_SC55_CHORUS:
		case ZMSCMD_GS_CHORUS:
		case ZMSCMD_SC88_REVERB:
		case ZMSCMD_SC88_CHORUS:
		case ZMSCMD_SC88_DELAY:
			/* 41 10 42 12  40 01 10 01   ... */
			{
				DWORD dev;
				int err;
				const int f0f7 = 1,roland = 1;
				const UBYTE mdl = 0x42;
				DWORD zmsskip;
				const int zmdlen[4] = { 29, 20, 21, 23 };
				BYTE e[4][3] = { 0x40,0x01,0x10,	/* v_reserve */
								 0x40,0x01,0x30,	/* reverb */
								 0x40,0x01,0x38,	/* chorus */
								 0x40,0x01,0x50 };	/* 88delay */
				int cmd;
				UBYTE *zmd_ = trkdata[0].zmd;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				int sc88 = (i == ZMSCMD_SC88_REVERB ||
							i == ZMSCMD_SC88_CHORUS ||
							i == ZMSCMD_SC88_DELAY);
				/* ex_b = trkdata[0].zmd + 1; */
				if (i == ZMSCMD_SC55_V_RESERVE ||
					i == ZMSCMD_SC55_PARTIAL_RESERVE ||
					i == ZMSCMD_GS_V_RESERVE ||
					i == ZMSCMD_GS_PARTIAL_RESERVE) {
					cmd = 0 ;
				} else  if (i == ZMSCMD_SC55_REVERB ||
							i == ZMSCMD_GS_REVERB ||
							i == ZMSCMD_SC88_REVERB) {
					cmd = 1 ;
				} else  if (i == ZMSCMD_SC55_CHORUS ||
							i == ZMSCMD_GS_CHORUS ||
							i == ZMSCMD_SC88_CHORUS) {
					cmd = 2 ;
				} else {
					cmd = 3 ;
				}
				zms = getnum2(zms,&dev,&err);
				if (err < 0) {
					dev = (!sc88) ? cominf->sc55id : 0x10;
				} else if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (dev < 0) {
					/* It is not to be error in V2 */
				}
				if (!sc88) cominf->sc55id = dev;
				trkdata[0].zmd = exclusive(trkdata[0].zmd, zms, 
											f0f7, &zmsskip,roland,dev,mdl,
											3,e[cmd],
											"{","}, \t\x0d\x0a");
				zms += zmsskip;
				if (trkdata[0].zmd - zmd_ != zmdlen[cmd]  + sc88 &&		/* non FULL parameters */
					(trkdata[0].zmd - zmd_ != 14 && cmd != 0) ) {
											/* non SINGLE parameter & non vreserve */
					const char *warn[7] = {
							".sc55_v_reserve must have just 16 parameters.",
							".sc55_reverb must have 1 or 7 parameter(s).",
							".sc55_chorus must have 1 or 8 parameter(s).",
							"",
							".sc88_reverb must have 1 or 8 parameter(s).",
							".sc88_chorus must have 1 or 9 parameter(s).",
							".sc88_delay must have 1 or 11 parameter(s)."
					};
					zmserror(warn[cmd + sc88 * 3],linebuf,zms,3,1);
				}
				if (cmd == 0) {
					int i, sum = 0;
					UBYTE tmp = *(zmd_ + 20);
					memmove(zmd_ + 12, zmd_ + 11, 9);	/* reorder */
					*(zmd_ + 11) = tmp;
					zmd_ = zmd_ + 3+1+4+3;
					for (i = 0; i < 16; i++) {
						sum += *zmd_++;
					}
					if (sum > 24) {
						zmserror("voices should be less than or equal to 24 in voice-reserve.",linebuf,zms,3,1);
					}
				}
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
			}
			break;
		case ZMSCMD_SC88_EQUALIZER:
			{
				const DWORD elen = 3;
				BYTE e[3] = { 0x40,0x02,0x00 };
				const int roland = 1, idflag = 1, zmdlen = 17, mdl = 0x42;
				const int warnlvl = 3;
				zms = macroExclusiveN(zms, e, elen, zmdlen,
										idflag, roland, mdl,warnlvl,
										".sc88_equalizer must have just 4 parameters.",
										ex_bp,trkdata);
				zmserror(".sc88_equalizer can use only on V3.",linebuf,zms,3,1);
			}
			break;
		case ZMSCMD_SC55_PART_SETUP:
		case ZMSCMD_SC55_PART_PARAMETER:
		case ZMSCMD_GS_PART_SETUP:
		case ZMSCMD_GS_PART_PARAMETER:
		case ZMSCMD_SC88_PART_SETUP:
		case ZMSCMD_SC88_PART_PARAMETER:
			{
				const UBYTE f0f7 = 1,roland = 1;
				const UBYTE mdl= 0x42;
				DWORD dev;
				int err;
				DWORD zmsskip,part;
				const DWORD elen = 3;
				BYTE e[3] = { 0x40,0x10,0x02 };
				int sc88 = (i == ZMSCMD_SC88_PART_SETUP ||
							i == ZMSCMD_SC88_PART_PARAMETER);
				int paras = sc88 ? 127 : 119;
				UBYTE *zmd_ = trkdata[0].zmd;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				UBYTE *psum = zmd_ + 11;
				zms = getnum2(zms,&part,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				zms = getnum2(zms,&dev,&err);
				if (err < 0) {
					dev = (!sc88) ? cominf->sc55id : 0x10;
				} else if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (dev < 0) {
					/* It is not to be error in V2, but.... */
				}
				if (!sc88) cominf->sc55id = dev;
				if (part == 10) {
					part = 0;
				} else if (part > 10) {
					part--;
				}
				e[1] = 0x10 + part;
				trkdata[0].zmd = exclusive(trkdata[0].zmd, zms, 
											f0f7, &zmsskip,roland,dev,mdl,
											elen,e,
											"{","}, \t\x0d\x0a");
				while (*++psum != 0xF7) {
				}
				psum--;		/* check sum */
				if ( (*(zmd_ + 11))-- == 0) {	/* rewrite Rx channel # */
					*(zmd_ + 11) = 0x10;
					*psum -= 15;
				} else {
					(*psum)++;
				}
				*psum &= 0x7F;
		
			if (trkdata[0].zmd - zmd_ > 13 + paras) {		/* non FULL parameters */
				/* 18 ll ll f0 41 10 42 12 40 1x 02 n1 n2 ... x127 sum f7 */
					if (paras == 119) {
						zmserror(".sc55_part_setup: too many parameters.",linebuf,zms,2,1);
					} else {
						zmserror(".sc88_part_setup: too many parameters.",linebuf,zms,3,1);
					}
				}
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				zms += zmsskip;
			}
			break;
		case ZMSCMD_SC55_DRUM_SETUP:
		case ZMSCMD_GS_DRUM_SETUP:
		case ZMSCMD_SC88_DRUM_SETUP:
			{
				DWORD map,key,dev;
				int j,err;
				const int elen = 9;
				BYTE e[9] = { 0xf0,0x41,0x10,0x42,0x12,0x41,0x00,0x00,0x00 };
				int sc88 = (i == ZMSCMD_SC88_DRUM_SETUP);
				int paras = sc88 ? 9 : 8;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				/* ex_b = trkdata[0].zmd + 1; */
				zms = getnum2(zms,&map,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&key,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&dev,&err);
				if (err < 0) {
					dev = (!sc88) ? cominf->sc55id : 0x10;
				} else if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (dev < 0) {
					/* It is not to be error in V2, but.... */
				}
				if (!sc88) cominf->sc55id = dev;
				e[2] = dev;
				*trkdata[0].zmd++ = 0x18;
				putWord(trkdata[0].zmd, (elen + 2) * 8);	/* +2: checksum,0xf7 */
				trkdata[0].zmd += 2;
				zms = skiptochr(zms,"{");
				zms++;
				for (j = 0; j < paras; j++) {
					DWORD var;
					zms = getnum2(zms,&var,&err);
					if (err) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					/* e[0] = 0x41; */
					e[6] = (map << 4) + (j + 1);
					e[7] = key;
					e[8] = var;
					trkdata[0].zmd = setex(trkdata[0].zmd, e, elen, 1);
					*trkdata[0].zmd++ = 0xf7;
					zms = skipchr(zms,", \t\x0d\x0a");
				}
				zms = skiptochr(zms,"}");
				zms++;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
			}
			break;
		case ZMSCMD_SC55_PRINT:
		case ZMSCMD_GS_PRINT:
			{
				DWORD dev;
				int err;
				const int f0f7 = 1,roland = 1;
				const UBYTE mdl = 0x45;
				int		elen = 3;
				UBYTE e[3] = {0x10,0x00,0x00};
				DWORD zmsskip;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				int sc88 = 0;
				/* ex_b = trkdata[0].zmd + 1; */
				zms = getnum2(zms,&dev,&err);
				if (err < 0) {
					dev = (!sc88) ? cominf->sc55id : 0x10;
				} else if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (dev < 0) {
					/* It is not to be error in V2, but.... */
				}
				if (!sc88) cominf->sc55id = dev;
				trkdata[0].zmd = exclusive(trkdata[0].zmd, zms, 
											f0f7, &zmsskip,roland,dev,mdl,
											elen,e,
											"\"","\"\x0d\x0a");
				if (trkdata[0].zmd - ex_b0 > 3+5+3+32+1) {
					zmserror("it must be under 32 characters in .sc55_print.",linebuf,zms,2,1);
				}
				zms = skipSpc(zms);
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				zms += zmsskip;
			}
			break;
		case ZMSCMD_SC55_DISPLAY:
		case ZMSCMD_GS_DISPLAY:
			{
				DWORD dev;
				int err,i;
				int		elen = 8;
				UBYTE e[8 + 64] = {0xF0,0x41,0x10,0x45,0x12,0x10,0x01,0x00};
							/*initialize; header part only */
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				UWORD buf[16];	/*, ebuf[64];*/
				int c = 0;
				int sc88 = 0;
				/* ex_b = trkdata[0].zmd + 1; */
				zms = getnum2(zms,&dev,&err);
				if (err < 0) {
					dev = (!sc88) ? cominf->sc55id : 0x10;
				} else if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (dev < 0) {
					/* It is not to be error in V2, but.... */
				}
				if (!sc88) cominf->sc55id = dev;
				e[2] = dev;
				zms--;
				do {
					zms = skipSpcCr(zms + 1);
				} while (*zms == ',');
				if (*zms != '{') {
					zmserror("SYNTAX ERROR.",linebuf,zms,0,1);
				}
				zms++;
				while (*zms != '}') {			/* Too weak the error check is! */
					DWORD tmpDWORD;
					zms = getnum2(zms,&tmpDWORD,&err);
					if (!err) {
						if (c > 15) {
							zmserror("too many parameters.",linebuf,zms,0,1);
						}
						buf[c++] = tmpDWORD;
					}
					zms = skipSpcCr(zms);
					if (*zms == ',') {
						zms++;
					} else if (*zms == '/') {
						zms = skipComment(zms);
					}
				}
				zms++;
				if (c != 16) {
					zmserror("too few parameters.",linebuf,zms,0,1);
				}
				for (i = 3; i >= 0; i--) {
					int j;
					for (j = 0; j < 16; j++) {
						e[i * 16 + j + elen] =
							(i == 3)? ((buf[j] & 1) << 4) : (buf[j] & 31);
						buf[j] >>= (i == 3)? 1 : 5;
					}
				}
				elen += 64;
				*trkdata[0].zmd++ = 0x18;
				putWord(trkdata[0].zmd, elen + 2);		/* +2: checksum,0xf7 */
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, e, elen, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
			}
			break;
		case ZMSCMD_WAVE_FORM:
		case ZMSCMD_WAVEFORM:
			/* 0x4a, size(.w), no(.b).looptype(.b),looppoint(.w),data(.w),.. */
			{
				DWORD waveno,looptype,looppoint = 0,num = 0;
				UBYTE *ws = trkdata[0].zmd + 1;
				int err;
				zms = getnum2(zms,&waveno,&err);
				if (err) {
					zmserror("wave# is not specified.",linebuf,zms,0,1);
				}
				zms = skipSpcCr(zms);
#ifdef A
				if (*zms != ',') {
					zmserror("looptype is not specified.",linebuf,zms,0,1);
				}
#endif
				if (*zms == ',') {
					zms++;
				}
				zms = getnum2(zms,&looptype,&err);
				if (err) {
					zmserror("looptype is not specified.",linebuf,zms,0,1);
				}
				zms = skipSpcCr(zms);
				if (*zms == ',') {
					zms++;
				}
					zms = getnum2(zms,&looppoint,&err);
#ifdef A
					if (err) {
						zmserror("looppoint is not specified.",linebuf,zms,2,1);
					}
#endif
#ifdef A
				}
#endif
				*trkdata[0].zmd++ = 0x4a;
				trkdata[0].zmd += 2;			/* size will be set */
				*trkdata[0].zmd++ = waveno;
				*trkdata[0].zmd++ = looptype;
				putWord(trkdata[0].zmd,looppoint);
				trkdata[0].zmd += 2;
				zms--;
				do {
					zms = skipSpcCr(zms + 1);
				} while (*zms == '=');
				if (*zms != '{') {
					zmserror("wave definition error.",linebuf,zms,0,1);
				}
				zms++;
				while (*zms != '}') {			/* Too weak the error check is! */
					DWORD tmpDWORD;
					zms = getnum2(zms,&tmpDWORD,&err);
					if (!err) {
						putWord(trkdata[0].zmd, tmpDWORD);
						trkdata[0].zmd += 2;
						num++;
					}
					zms = skipSpcCr(zms);
					if (*zms == ',') {
						zms++;
					} else if (*zms == '/') {
						zms = skipComment(zms);
					}
				}
				zms++;
				putWord(ws,num);
				cominf->usedwav[waveno - 8] = 1;
			}
			break;
		case ZMSCMD_RANDOMIZE_SEED:	/* zmc2 extention */
			{
				DWORD seed;
				int err;
				zms = getnum3(zms,&seed,&err);
				if (err) {
					srand(time(NULL));
					/* zmserror("random_seed error.",linebuf,zms,0,1); */
				} else {
					srand(seed);
				}
				zmserror(".randomize_seed can use only for zmc2.",linebuf,zms,4,1);
			}
			break;
		case ZMSCMD_LEGACY_1CLOCK_TIE:	/* zmc2 extention */
			{
				DWORD tie;
				int err;
				zms = getnum3(zms,&tie,&err);
				if (err) {
					cominf->l1tie = 1;
				} else {
					cominf->l1tie = tie;
				}
				zmserror(".legacy_*1_tie can use only for zmc2.",linebuf,zms,4,1);
			}
			break;
		case ZMSCMD_DEFINE:	/* V3 extention */
			/* {{ */
			{
				int bnest = 0;
				while (*zms != 0xFF) {
					if (*zms == '{') {
						bnest++;
					} else if (*zms == '}') {
						bnest--;
						if (bnest <= 0) {
							zms++;
							break;
						}
					}			/* macro expansion is already done */
					zms++;
				}
			}
/*
			zmserror(".define can use only on V3.",linebuf,zms,3,1);
*/
			break;
/* (BEGIN MT32/U220/M1support by Mamiya */
		case ZMSCMD_MT32_INIT:
		case ZMSCMD_MT32_RESET:
			{
				DWORD id;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x7f,0x00,0x00};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 1, "expara_mt32_init");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum3(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				i = 8;
				expara[i++] = 0x00;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "expara_mt32_init");
			}
			break;
		case ZMSCMD_MT32_P_RESERVE:
		case ZMSCMD_MT32_PARTIAL_RESERVE:
			{
				DWORD id,var;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x10,0x00,0x04};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 9, "expara_mt32_p_reserve");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"{") + 1;
				for (i = 8; i < 8 + 9; i++) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&var,&err);
					if (err < 0) break;
					if (err > 0) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					expara[i] = var;
				}
				zms = skiptochr(zms,"}") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "expara_mt32_p_reserve");
			}
			break;
		case ZMSCMD_MT32_REVERB:
			{
				DWORD id,var;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x10,0x00,0x01};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 3, "expara_mt32_reverb");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"{") + 1;
				for (i = 8; i < 8 + 3; i++) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&var,&err);
					if (err < 0) break;
					if (err > 0) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					expara[i] = var;
				}
				zms = skiptochr(zms,"}") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "expara_mt32_reverb");
			}
			break;
		case ZMSCMD_MT32_PART_SETUP:
			{
				DWORD id,var;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x10,0x00,0x0d};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 9, "expara_mt32_part");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"{") + 1;
				for (i = 8; i < 8 + 9; i++) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&var,&err);
					if (err < 0) break;
					if (err > 0) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					if (1 <= var && var <= 16)
						expara[i] = var-1;
					else
						expara[i] = 0x10;
				}
				zms = skiptochr(zms,"}") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "expara_mt32_part");
			}
			break;
		case ZMSCMD_MT32_DRUM_SETUP:
		case ZMSCMD_MT32_RHYTHM_SETUP:
			{
				DWORD nt,id,var;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x03,0,0};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 4, "exparam_mt32_drum_setup");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&nt,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				nt = 4 * (nt - 24) + 0x90;
				expara[6] = (nt >> 7) & 0x7f;
				expara[7] = nt & 0x7f;
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"{") + 1;
				for (i = 8; i < 8 + 4; i++) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&var,&err);
					if (err < 0) break;
					if (err > 0) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					expara[i] = var;
				}
				zms = skiptochr(zms,"}") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "exparam_mt32_drum_setup");
			}
			break;
		case ZMSCMD_MT32_COMMON:
			{
				DWORD ti,id,var;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x08,0,0x00};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 14, "exparam_mt32_common");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&ti,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				expara[6] = 2 * (ti - 1);
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"{") + 1;
				zms = skiptochr(zms,"\"") + 1;
				for (i = 8; *zms != '\"' && i < 8 + 10; i++) {
					expara[i] = *(zms++);
				}
				while (i < 8 + 10) expara[i++] = ' ';
				zms = skiptochr(zms,"\"") + 1;
				while (i < 8 + 10 + 4) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&var,&err);
					if (err < 0) break;
					if (err > 0) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					expara[i++] = var;
				}
				zms = skiptochr(zms,"}") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "exparam_mt32_common");
			}
			break;
		case ZMSCMD_MT32_PATCH:
			{
				DWORD pa,id,var;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x05,0,0};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 7, "exparam_mt32_patch");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&pa,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				pa = 8 * (pa - 1);
				expara[6] = (pa >> 7) & 0x7f;
				expara[7] = pa & 0x7f;
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"{") + 1;
				for (i = 8; i < 8 + 7; i++) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&var,&err);
					if (err < 0) break;
					if (err > 0) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					expara[i] = var;
				}
				zms = skiptochr(zms,"}") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "exparam_mt32_patch");
			}
			break;
		case ZMSCMD_MT32_PARTIAL:
			{
				DWORD ti,pa,id,var;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x08,0,0};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 58, "exparam_mt32_partial");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&ti,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				expara[6] = 2 * (ti - 1);
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&pa,&err);
				if (err) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				expara[7] = 0xe + (0x48 - 0xe) * (pa - 1);
				zms = skipchr(zms,", \t\x0d\x0a");
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"{") + 1;
				for (i = 8; i < 8 + 58; i++) {
					zms = skipchr(zms,", \t\x0d\x0a");
					zms = getnum2(zms,&var,&err);
					if (err < 0) break;
					if (err > 0) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					expara[i] = var;
				}
				zms = skiptochr(zms,"}") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "exparam_mt32_partial");
			}
			break;
		case ZMSCMD_MT32_PRINT:
			/* f0 41 id 16 12 20 00 00 ... */
			{
				DWORD id;
				int i,err;
				BYTE *expara;
				UBYTE *ex_b0 = trkdata[0].zmd + 1;
				const UBYTE ed[8] = { 0xf0,0x41,0,0x16,0x12,0x20,0x00,0x00};
				expara = emalloc(sizeof(ed) + sizeof(UBYTE) * 20, "exparam_mt32_print");
				memcpy(expara, ed, sizeof(ed));
				zms = getnum2(zms,&id,&err);
				if (err > 0) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				} else if (err < 0) {
					id = cominf->mt32id;
				} else {
					cominf->mt32id = id;
				}
				expara[2] = id;
				zms = skiptochr(zms,"\"") + 1;
				for (i = 8; *zms != '\"' && i < 8 + 20; i++) {
					expara[i] = *(zms++);
				}
				zms = skiptochr(zms,"\"") + 1;
				*trkdata[0].zmd++ = 0x18;
				putWord(ex_b0, i + 2);
				trkdata[0].zmd += 2;
				trkdata[0].zmd = setex(trkdata[0].zmd, expara, i, 1);
				*trkdata[0].zmd++ = 0xf7;
				compressCommonTrkExclusive(trkdata,ex_bp,ex_b0);
				efree(expara, "exparam_mt32_print");
			}
			break;
		case ZMSCMD_U220_SETUP:
			zms = makeZmdCommonU220Setup(trkdata, zms, ex_bp, cominf);
			break;
		case ZMSCMD_U220_PART_SETUP:
			zms = makeZmdCommonU220PartSetup(trkdata, zms, ex_bp, cominf);
			break;
		case ZMSCMD_U220_COMMON:
			zms = makeZmdCommonU220Common(trkdata, zms, ex_bp, cominf);
			break;
		case ZMSCMD_U220_TIMBRE:
			zms = makeZmdCommonU220Timber(trkdata, zms, ex_bp, cominf);
			break;
		case ZMSCMD_U220_DRUM_SETUP:
			zms = makeZmdCommonU220DrumSetup(trkdata, zms, ex_bp, cominf);
			break;
		case ZMSCMD_U220_DRUM_INST:
			zms = makeZmdCommonU220DrumInst(trkdata, zms, ex_bp, cominf);
			break;
		case ZMSCMD_U220_PRINT:
			zms = makeZmdCommonU220Print(trkdata, zms, ex_bp, cominf);
			break;
		case ZMSCMD_M1_MIDI_CH:
		case ZMSCMD_M1_SETUP:
			zms = makeZmdCommonM1MidiCh(zms, cominf);
			break;
		case ZMSCMD_M1_PART_SETUP:
			zms = makeZmdCommonM1PartSetup(zms, cominf);
			break;
		case ZMSCMD_M1_EFFECT_SETUP:
			zms = makeZmdCommonM1EffectSetup(zms, cominf);
			break;
		case ZMSCMD_M1_PRINT:
			zms = makeZmdCommonM1Print(zms, cominf);
			break;
		case ZMSCMD_SEND_TO_M1:
			zms = makeZmdCommonM1Send(trkdata, zms, ex_bp, cominf);
			break;
/* MT32/U220/M1support by Mamiya END) */
		case ZMSCMD_QUANTIZE_MODE:
			zms = makeZmdCommonQuantizeMode(zms, cominf);
			break;
		case ZMSCMD_GATETIME_RESOLUTION:
			zms = makeZmdCommonGatetimeResolution(zms, cominf);
			break;
		case ZMSCMD_DUMMY:
			zms = makeZmdCommonDummy(trkdata, zms, ex_bp);
			break;
		case ZMSCMD_PRINT:
			zms = makeZmdCommonPrint(trkdata, zms, ex_bp);
			break;
/* (BEGIN FM/ADPCMsupport by Mamiya */
		case ZMSCMD_MIDI_DUMP:
		case ZMSCMD_ADPCM_BLOCK_DATA:
		case ZMSCMD_ADPCM_LIST:
			{
				UBYTE	*strstart;
				BYTE	cr;
				int		len;
				*ex_bp = NULL;
				if (i == ZMSCMD_MIDI_DUMP) {
					*trkdata[0].zmd++ = 0x62;
				} else if (i == ZMSCMD_ADPCM_BLOCK_DATA) {
					*trkdata[0].zmd++ = 0x63;
				} else if (i == ZMSCMD_ADPCM_LIST) {
					*trkdata[0].zmd++ = 0x60;
				}
				zms = skipSpc(zms);
				if (*zms == '=') zms = skipSpc(zms + 1);
				strstart = zms;
				zms = skipComment(zms);
/* del v1.33 (as CR code is converted into single char)
				if (*(zms - 1) == 0x0a && *(zms - 2) == 0x0d) {
					cr = 2;
				} else {
					cr = 1;
				}
*/
				cr = 1;
				len = zms - cr - strstart;
				if (getSwitchVal('z') > 1) {
					int i;
					UBYTE c = 0;
					for (i = 0; i < len; i++) {
						if (c & 0x80)
							c = strstart[i];
						else if (isalpha(strstart[i]))
							c = toupper(strstart[i]);
						else if (strstart[i] <= ' ')
							break;
						else
							c = strstart[i];
						*trkdata[0].zmd++ = c;
					}
				} else {
					strncpy(trkdata[0].zmd, strstart, len);
					trkdata[0].zmd += len;
				}
				*trkdata[0].zmd++ = 0;
			}
			break;
		case ZMSCMD_FM_VSET:
			{
				const UBYTE default_opmtone2[9] = {
					15,3,0,0,0,0,0,0, 0
				};
				DWORD dat;
				int err, i;
				*ex_bp = NULL;
				zms = skipSpcCr(getnum2(zms,&dat,&err));
				if (*zms == '=') zms = skipSpcCr(zms + 1);
				if (err < 0 || *zms != '{') {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				zms++;
				memcpy(cominf->opmtone + 55 - 9, default_opmtone2, sizeof(UBYTE) * 9);
				*trkdata[0].zmd++ = 0x1B;
				*trkdata[0].zmd++ = dat;
				for (i = 0 ; i < 55 ; i++) {
					zms = skipchr(zms," ,\t");
					zms = getnum2(zms,&dat,&err);
					if (err < 0) break;
					cominf->opmtone[i] = dat;
				}
				memcpy(trkdata[0].zmd, cominf->opmtone, sizeof(cominf->opmtone));
				trkdata[0].zmd += sizeof(cominf->opmtone);
				zms = skipSpcCr(zms);
				if (*zms != '}') {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				zms++;
			}
			break;
		case ZMSCMD_ADPCM_BANK:
			{
				DWORD v;
				int err;
				zms = skipSpc(zms);
				if (*zms == '=') zms = skipSpc(zms + 1);
				zms = getnum3(zms, &v, &err);
				if (err) {
					zmserror(".adpcm_bank must be followed to its parameter.",linebuf,zms,0,1);
				} else if (v < 1 || 4 < v) {
					zmserror(".adpcm_bank parameter is out of range(1-4).",linebuf,zms,0,1);
				} else {
					cominf->adpcmbank = v - 1;
				}
			}
			break;
		case ZMSCMD_FM_MASTER_VOLUME:
			{
				DWORD v;
				int err;
				zms = skipSpc(zms);
				if (*zms == '=') zms = skipSpc(zms + 1);
				zms = getnum3(zms, &v, &err);
				if (err) {
					zmserror(".fm_master_volume must be followed to its parameter.",linebuf,zms,0,1);
				} else if (v < 0 || 255 < v) {
					zmserror(".fm_master_volume parameter is out of range(0-255).",linebuf,zms,0,1);
				} else {
					cominf->fmvol = v;
				}
			}
			break;
		case ZMSCMD_ERASE:
			{
				DWORD v;
				int err;
				zms = skipSpc(zms);
				if (*zms == '.') zms = skipSpc(zms + 1);
				if (*zms == 'o' || *zms == 'O') {
					UBYTE note;
					zms = skipSpc(getnum3(zms + 1, &v, &err));
					note = *zms | 0x20;
					if (note < 'a' || 'g' < note) {
						zmserror("SYNTAX ERROR",linebuf,zms,0,1);
					}
					do {
						zms = skipSpc(zms + 1);
					} while (*zms == '+' || *zms == '#' || *zms == '-');
				} else {
					zms = getnum3(zms, &v, &err);
				}
			}
			break;
		case ZMSCMD_O:
			{
				const BYTE ntbl[] = {9,11,0,2,4,5,7};
				DWORD oct;
				UBYTE note;
				int err;
				zms = skipSpc(getnum2(zms, &oct, &err));
				if (err) oct = 0;
				note = *zms | 0x20;
				if (note < 'a' || 'g' < note) {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				zms = skipSpc(zms + 1);
				note = 12 * (1 + oct) + ntbl[note - 'a'];
				while (*zms == '+' || *zms == '#' || *zms == '-') {
					note += (*zms == '-') ? -1 : 1;
					zms = skipSpc(zms + 1);
				}
				*ex_bp = NULL;
				zms = makeZmdCommonRegPcm(zms, trkdata, note, cominf->adpcmbank);
			}
			break;
/* FM/ADPCMsupport by Mamiya END) */
	}
	return zms;
}
TRKCHINF *makeZmdCommon(TRKCHINF *trkdata,UBYTE *zms, UBYTE **zms2,COMMONINF *cominf)
{
	int stat = 0;
	BYTE trks = 0;
	UBYTE	*ex_b = NULL;
	/* LINEDATA *ld_ = ld; */
/* (BEGIN FM/ADPCM/M1support by Mamiya */
	const UBYTE default_opmtone[55] = {
		0,0,0,0,0, 0,0,0,0,0, 0,
		0,0,0,0,0, 0,0,0,0,0, 0,
		0,0,0,0,0, 0,0,0,0,0, 0,
		0,0,0,0,0, 0,0,0,0,0, 0,
		0,0,15,3,0,0,0,0,0,0, 0
	};
	const UBYTE default_m1setup[127] = {
		0xF0, 0x42, 0x30, 0x19, 0x48, 0x00, 0x00, 0x00,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0, 0x04, 0x78, 0x00, 0x14,    0,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0, 0x00, 0x0B, 0x00, 0x1E, 0x1E,
		0x00, 0x19, 0x19, 0x00, 0x00, 0x1F, 0x3C, 0x09,
		0x00, 0x03, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x1A,
		0x00, 0x00, 0x28, 0x32, 0x1C, 0x00, 0x00, 0x00,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0,    0,    0,    0,    0,    0,
		0x00,    0,    0,    0,    0,    0, 0xF7, 0xF0,
		0x42, 0x30, 0x19, 0x4E, 0x06, 0x00, 0xF7
	};
	memcpy(cominf->opmtone, default_opmtone, sizeof(cominf->opmtone));
	memcpy(cominf->m1setup, default_m1setup, sizeof(cominf->m1setup));
	cominf->fmvol		= 255;
	cominf->adpcmbank	= 0;
	cominf->polpcm		= 0;
/* FM/ADPCM/M1support by Mamiya END) */
	linebuf = zms;
	cominf->div		= 192;
	cominf->tempo	= 120;
	cominf->basech	= 0;
	cominf->debug	= 0;
	cominf->l1tie	= 1;
	cominf->sc55id	= 0x10;
	cominf->mt32id	= 0x10;
	cominf->u220id	= 0x10;
	cominf->qmode	= 3;
	cominf->gtreso	= 8;
	strncpy(trkdata[0].zmd,"\x10ZmuSiC\x20",8);
	trkdata[0].zmd += 8;
	while (!stat) {
		const DWORD bs = trkdata[0].zmd - trkdata[0].zmdbuf;
		if (bs > trkdata[0].bufsize - MTRK_OVERFLOW_RANGE) {
			trkdata[0].bufsize += FIRST_MTRK_SIZE;
			trkdata[0].zmdbuf = (UBYTE*)erealloc(trkdata[0].zmdbuf,sizeof(UBYTE) * trkdata[0].bufsize, "trkdata[0].zmdbuf");
			trkdata[0].zmd = trkdata[0].zmdbuf + bs;
		}
		zms = skipSpcCr(zms);
/* (BEGIN FM/ADPCMsupport by Mamiya */
		{
			DWORD note;
			int err;
			zms = getnum2(zms, &note, &err);
			if (!err) {
				ex_b = NULL;
				zms = makeZmdCommonRegPcm(zms, trkdata, note, 0);
				continue;
			} else if (err > 0) {
				zmserror("SYNTAX ERROR",linebuf,zms,0,1);
			}
		}
/* FM/ADPCMsupport by Mamiya END) */
		switch(*zms++) {
			case 0xFF:									/* EOF */
				stat = -1;
				*trkdata[0].zmd++ = 0xFF;
				if ((trkdata[0].zmdbuf - trkdata[0].zmd) & 1) {
					*trkdata[0].zmd++ = 0xFF;
				}
				break;
			case '.':
				zms = makeZmdCommonZmsCommand(trkdata, zms, &trks, &ex_b, cominf);
				break;
			case '(':
				{
					char c;
					zms = skipSpc(zms);
					c  = *zms++;
					switch(c) {
						case 'i':	case 'I':					/* (i) */
							zms = initializeZMD(zms, &ex_b, ")");
							break;
						case 'x':	case 'X':					/* (X...) */
							{
								const UBYTE f0f7 = 0,roland = 0;
								DWORD zmsskip;
								UBYTE *ex_b0 = trkdata[0].zmd + 1;
								trkdata[0].zmd = exclusive(trkdata[0].zmd, zms,f0f7,&zmsskip,
													roland,0,0,0,"","","), \t\x0d\x0a");
								compressCommonTrkExclusive(trkdata,&ex_b,ex_b0);
								zms += zmsskip;
							}
							break;
						case 'm':	case 'M':					/* (M1,1000) */
							ex_b = NULL;
							{
								DWORD trk, bufsize;
								int err;
								/* zms = skipSpc(zms); */
								zms = getnum2(zms, &trk, &err);
								if (err) {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								zms = skipchr(zms,", \t");
								zms = getnum2(zms, &bufsize,&err);
								if (err) {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								zms = skiptochr(zms,")");
								zms++;
								trkdata[trk].buforgsize = bufsize;
							}
							break;
						case 'b':	case 'B':					/* (B0) (B1) */
							ex_b = NULL;
							{
								int err;
								DWORD basech;
								zms = getnum2(zms,&basech,&err);
								if (err || (basech != 0 && basech != 1)) {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								cominf->basech = basech;
								zms = skiptochr(zms,")");
								zms++;
							}
							break;
						case 'a':	case 'A':					/*(Ach,tr) */
							ex_b = NULL;
							{
								DWORD ch, trk;
								int i, err;
								zms = getDevice(zms,&ch,cominf);
								zms = skipchr(zms," ,\t");
								zms = getnum2(zms,&trk,&err);
								if (err) {
									zmserror("no track number is specified.",linebuf,zms,0,1);
								} else if (trk <= 0) {
									zmserror("illegal track number is specified.",linebuf,zms,0,1);
								}
								for (i = 0; i < trks; i++) {
									if (cominf->trkassign[i] == trk) {
										zmserror("The specified track# is already used.",linebuf,zms,0,1);
									}
								}
								trkdata[trk].ch = trkdata[trk].ch_ = ch;
								cominf->trkassign[trks++] = trk;
								cominf->trkassign[trks] = -1;
								zms = skipSpc(zms);
								if (*zms != ')') {
									zmserror("`)' is unbraced.",linebuf,zms,0,1);
								}
								zms++;
							}
							break;
						case 't':	case 'T':					/* (T...) */
							ex_b = NULL;
							stat = -1;
							*trkdata[0].zmd++ = 0xFF;
							if ((trkdata[0].zmdbuf - trkdata[0].zmd) & 1) {
								*trkdata[0].zmd++ = 0xFF;
							}
							while ( *zms != '(' ) {			/* '('܂Ŗ߂ */
								zms--;
							}
							break;
						case 'z':	case 'Z':
							zms = setMasterClock(zms, &ex_b, ")",trkdata,cominf);
							break;
						case 'o':	case 'O':				/* set tempo */
							zms = setTempo(zms, &ex_b, ")",trkdata,cominf);
							break;
						case 'd':	case 'D':
							ex_b = NULL;
							{
								int err;
								DWORD dbg;
								zms = getnum2(zms,&dbg,&err);
								if (err) {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								cominf->debug = dbg;
								zms = skiptochr(zms,")");
								zms++;
							}
							break;
						case 'f':	case 'F':
						case 'p':	case 'P':
						case 's':	case 'S':
						case 'c':	case 'C':
						case 'e':	case 'E':
						case 'q':	case 'Q':
						case 'r':	case 'R':
/* ignore: (Fn) (Pn1,n2,..) (Sn1,n2,...) (Cn1,n2,...) (Ech1,ch2,...) (Q) (R) */
							ex_b = NULL;
							zms = skiptochr(zms,")");
							zms++;
							break;
/* (BEGIN FM/ADPCMsupport by Mamiya */
						case 'v':	case 'V':
							{
								DWORD dat;
								int err, i;
								ex_b = NULL;
								zms = getnum2(zms,&dat,&err);
								if (err < 0) {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								*trkdata[0].zmd++ = 0x04;
								*trkdata[0].zmd++ = dat;
								zms = skipchr(zms," ,\t");
								zms = getnum2(zms,&dat,&err);
								if (err < 0 || dat != 0) {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								for (i = 0 ; i < 55 ; i++) {
									zms = skipchr(zms," ,\t");
									zms = getnum2(zms,&dat,&err);
									if (err < 0) break;
									cominf->opmtone[i] = dat;
								}
								memcpy(trkdata[0].zmd, cominf->opmtone, sizeof(cominf->opmtone));
								trkdata[0].zmd += sizeof(cominf->opmtone);
								zms = skipSpcCr(zms);
								if (*zms != ')') {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								zms++;
							}
							break;
						case '@':
							{
								DWORD dat;
								int err, i;
								ex_b = NULL;
								zms = getnum2(zms,&dat,&err);
								if (err < 0) {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								memcpy(cominf->opmtone + 55 - 9, default_opmtone + 55 - 9, sizeof(UBYTE) * 9);
								*trkdata[0].zmd++ = 0x1B;
								*trkdata[0].zmd++ = dat;
								for (i = 0 ; i < 55 ; i++) {
									zms = skipchr(zms," ,\t");
									zms = getnum2(zms,&dat,&err);
									if (err < 0) break;
									cominf->opmtone[i] = dat;
								}
								memcpy(trkdata[0].zmd, cominf->opmtone, sizeof(cominf->opmtone));
								trkdata[0].zmd += sizeof(cominf->opmtone);
								zms = skipSpcCr(zms);
								if (*zms != ')') {
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								zms++;
							}
							break;
/* FM/ADPCMsupport by Mamiya END) */
						default:
							ex_b = NULL;
							zmserror("UNKNOWN MML",linebuf,zms,0,1);
					}
				}
				
				break;
			case '/':
				zms = skipComment(zms);
				break;
			default:
				zms--;
				if (*zms != ' ' && *zms != '\t' && *zms != nativeCR && *zms != 0x1A) {
/*
					fprintf(stderr,"ERR! %.2X (%c)\n",*zms,*zms);
*/
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				zms++;
				break;
		}
/*
		if (stat) {
			break;
		}
*/
	}
	*zms2 = zms;
	trkdata[0].nowsize = trkdata[0].zmd - trkdata[0].zmdbuf;
	return trkdata;
}
void compressCommonTrkExclusive(TRKCHINF *trkdata,UBYTE **bpr1,UBYTE *bpr2)
{
	if (*bpr1) {
		UWORD	bytes1 = getWord(*bpr1);
		UWORD	bytes2 = getWord(bpr2);
		putWord(*bpr1, bytes1 + bytes2);
		memmove(bpr2 - 1, bpr2 + 2, sizeof(UBYTE) * bytes2);
		trkdata[0].zmd -= 3;
	} else {
		*bpr1 = bpr2;
	}
}
/* ===========================================
     exclusive w/o any parameters(except ID)
   =========================================== */
UBYTE *macroExclusive0(UBYTE *zms, BYTE e[], const DWORD elen,
						int idflag, int roland, UBYTE **ex_b, TRKCHINF *trkdata)
{
	int err = 0;
	DWORD ID;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	/* ex_b = trkdata[0].zmd + 1; */
	if (idflag) {
		zms = getnum3(zms,&ID,&err);
		if (err == -1) {
			ID = 0x10;
		} else if (err > 0) {
			zmserror("exclusive ID error.",linebuf,zms,0,1);
		} else if (ID < 0) {
			/* It is not to be error in V2, but.... */
		}
		e[2] = ID;
	}
	*trkdata[0].zmd++ = 0x18;
	putWord(trkdata[0].zmd, elen + 2);		/* +2: checksum,0xf7 */
	trkdata[0].zmd += 2;
	trkdata[0].zmd = setex(trkdata[0].zmd, e, elen, roland);
	*trkdata[0].zmd++ = 0xf7;
	compressCommonTrkExclusive(trkdata,ex_b,ex_b0);
	return zms;
}
/* ===========================================
     exclusive w/ many parameters(except ID)
        ex_macro id {n1,n2,...}
     sorry the usage has a little difference
      from macroExclusive0
   =========================================== */
UBYTE *macroExclusiveN(UBYTE *zms, BYTE e[], const DWORD elen,const DWORD zmdlen,
						int idflag, int roland, const UBYTE mdl,const int warnlvl,
						UBYTE *warn, UBYTE **ex_b, TRKCHINF *trkdata)
{
	DWORD dev;
	int err = 0;
	const int f0f7 = 1;
	DWORD zmsskip;
	UBYTE *zmd_ = trkdata[0].zmd;
	UBYTE *ex_b0 = trkdata[0].zmd + 1;
	if (idflag) {
		zms = getnum2(zms,&dev,&err);
		if (err == -1) {
			dev = 0x10;
		} else if (err > 0) {
			zmserror("SYNTAX ERROR",linebuf,zms,0,1);
		} else if (dev < 0) {
			/* It is not to be error in V2 */
		}
	}
	trkdata[0].zmd = exclusive(trkdata[0].zmd, zms, 
								f0f7, &zmsskip,roland,dev,mdl,
								elen,e,
								"{","}, \t\x0d\x0a");
	zms += zmsskip;
	if (trkdata[0].zmd - zmd_ != zmdlen) {		/* non FULL parameters */
		zmserror(warn,linebuf,zms,warnlvl,1);
	}
	compressCommonTrkExclusive(trkdata,ex_b,ex_b0);
	return zms;
}
UBYTE *getDevice(UBYTE *zms, DWORD *ch, COMMONINF *cominf)
{
	int err;
	zms = getnum2(zms,ch,&err);
	if (err > 0) {
		zmserror("illegal channel number is specified.",linebuf,zms,0,1);
	} else if (err < 0) {	/* (a????x,y) */
		int i,flg = -1;
		const char *base[3] = {"fm","adpcm","midi"};
		const int  bs[3]    = {0,8,9};
/*
		const char *base[] = {"fm","adpcm","midi1-","midi2-","midi3-","midi4-","midi"};
		const int  bs[7]   = {0,1, 0x8000,0x8001,0x8002,0x8003, 0xffff};
*/
		DWORD d;
		int b = 0, err;
		for (i = 0; i < 3; i++) {
			if (!stricmp2(zms,base[i])) {
				flg = i;
				b = bs[flg];
				zms += strlen(base[i]);
				break;
			}
		}
		zms = getnum2(zms,&d,&err);
		if (err < 0) {
			if (flg != 1) {		/* non adpcm && omit ch */
				zmserror("illegal channel-strings is specified.",linebuf,zms,0,1);
			} else {
/* (BEGIN FM/ADPCMsupport by Mamiya */
				if (cominf->polpcm++) {
					*ch = 25 + cominf->polpcm - 2;
				} else {
/* FM/ADPCMsupport by Mamiya END) */
					*ch = 8;
				}
			}
		} else if (err > 0) {
			zmserror("SYNTAX ERROR",linebuf,zms,0,1);
/* (BEGIN FM/ADPCMsupport by Mamiya */
		} else if (flg == 1) {	/* adpcm */
			*ch = (d == 1) ? 8 : (25 + d - 2);
/* FM/ADPCMsupport by Mamiya END) */
		} else {
			if (d <= 0) {
				zmserror("illegal channel number is specified.",linebuf,zms,0,1);
			}
			*ch = d + b - 1;
		}
	} else {		/* (ax,y) */
		(*ch)--;
		if (cominf->basech == 1) {
/* (BEGIN FM/ADPCMsupport by Mamiya */
			if (*ch < 16) {
				*ch += 9;
			} else if (*ch < 16 + 9) {
				*ch -= 16;
			}
/* FM/ADPCMsupport by Mamiya END) */
		}
	}
	return zms;
}
#ifdef AAA
UBYTE *mml_assign(UBYTE *zms, BYTE *trks, TRKCHINF *trkdata, COMMONINF *cominf)
{
	DWORD ch, trk;
	int err;
	zms = getDevice(zms,&ch,cominf);
	zms = skipchr(zms," ,\t");
	zms = getnum2(zms,&trk,&err);
	if (err) {
		zmserror("no track number is specified.",linebuf,zms,0,1);
	}
	trkdata[trk].ch = trkdata[trk].ch_ = ch;
	cominf->trkassign[*trks++] = trk;
	cominf->trkassign[*trks] = -1;
	zms = skipSpc(zms);
	if (*zms != ')') {
		zmserror("`)' is unbraced.",linebuf,zms,0,1);
	}
	zms++;
	return zms;
}
#endif
UBYTE *setTempo(UBYTE *zms, UBYTE **ex_b, char *endchar,
					TRKCHINF *trkdata,COMMONINF *cominf)
{
	int err;
	DWORD tempo;
	zms = getnum3(zms,&tempo,&err);
	if (err) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	}
	cominf->tempo = tempo;
	if (endchar) {
		zms = skiptochr(zms,endchar);
		zms++;
	}
	*trkdata[0].zmd++ = 0x05;
	putWord(trkdata[0].zmd,tempo);
	trkdata[0].zmd += 2;
	*ex_b = NULL;
	return zms;
}
UBYTE *initializeZMD(UBYTE *zms, UBYTE **ex_b, char *endchar)
{
	int err;
	DWORD num;
	zms = getnum3(zms,&num,&err);
	if (!err && num >= 3) {
		zmserror("V3-zms is not supported in zmc2.",linebuf,zms,3,1);
	}
	zms = skipSpc(zms);
	if (endchar && *zms++ != *endchar) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	}
	*ex_b = NULL;
	return zms;
}
UBYTE *setMasterClock(UBYTE *zms, UBYTE **ex_b, char *endchar,
						TRKCHINF *trkdata,COMMONINF *cominf)
{
	int err;
	DWORD div;
	DWORD bc;
	zms = getnum3(zms,&div,&err);
	if (err) {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	}
	cominf->div = div;
	if (endchar) {
		zms = skiptochr(zms,endchar);
		zms++;
	}
	*trkdata[0].zmd++ = 0x42;
	if (div > 0xFF) {
		*trkdata[0].zmd++ = 0x01;
		putDword(trkdata[0].zmd,div);
		*(trkdata[0].zmdbuf  + 7) = 0xF0;	/* non compatible ZMD */
		zmserror("The divisions over 255 can use only for V3 or for zmc2.",linebuf,zms,4,1);
	} else {
		bc = 1000 * 60000 / (div * 4);
		*trkdata[0].zmd++ = div;
		putDword(trkdata[0].zmd,bc);
	}
	trkdata[0].zmd += 4;
	*ex_b = NULL;
	return zms;
}