/* ==================================
     ZMS->ZMD playing track compile
   ================================== */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "switch.h"
#include "parsesub.h"
#include "makezmd.h"
#include "makezmd3.h"
#include "velo.h"
#include "etc.h"
#include "structs.h"
#include "structs2.h"
TRKCHINF *makeZmdMain(TRKCHINF *trkdata,UBYTE *zms, UBYTE **zms2,
						COMMONINF *cominf);
UBYTE *makeZmdNote(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf);
UBYTE *makeZmdNote1(UBYTE *zms, const int Trk,TRKINF *trkinf,BYTE *note);
UBYTE *getGate(UBYTE *zms, const int Trk,TRKINF *trkinf,UWORD step, UWORD *gate,int *err,
						COMMONINF *cominf);
/* UWORD getGate1(const BYTE target[],TRKINF *trkinf,int trk,UWORD Step); */
UBYTE *makePortChord(UBYTE *zms, const int Trk,
						TRKINF *trkinf,COMMONINF *cominf,
						const UBYTE endchar,/* char allowcamma, */
						VELOETCVAR v[],BYTE note[],int *notes,
						UWORD *step_, UWORD *gate_,WORD *delay);
extern char *linebuf;
extern LINEDATA *ld;
TRKCHINF *makeZmdMain(TRKCHINF *trkdata,UBYTE *zms, UBYTE **zms2,COMMONINF *cominf)
{
	int			i, stat = 0;
	BYTE		*target;
	TRKINF		*trkinf;
	int trk, err;
	DWORD tmpDWORD;
	UBYTE *zms_;
	UBYTE tmpUBYTE;
	char *linebuf_;
	LINEDATA *ld_;
	target = (BYTE*)emalloc(sizeof(BYTE) * cominf->maxtrk, "target");
	trkinf = (TRKINF*)emalloc(sizeof(TRKINF) * cominf->maxtrk, "trkinf");
	for (i = 1; i < cominf->maxtrk; i++) {
		initTrkInf(&trkinf[i], cominf);
		initTrkInf2(&trkinf[i]);
	}
	while (1) {
		zms = skipSpcCr(zms);
		/* data = data_; */
		zms_ = zms + 1;		/* cant write this line inner switch{} */
		linebuf_ = linebuf;
		ld_ = ld;
/*fprintf(stderr,"%c",*zms);*/
		switch(*zms++) {
			case 0xFF:									/* EOF */
				for (trk = 0; cominf->trkassign[trk] >= 0; trk++) {
					const int Trk = cominf->trkassign[trk];
					*trkdata[Trk].zmd++ = 0xFF;
				}
				stat = -1;
				break;
			case '\"':									/* @j old style || extended 8chord */
				zms = getnum2(zms, &tmpDWORD, &err);
				if (err < 0) {							/* no value -> extended chord*/
					zms = makeZmdChord(zms,trkdata,target,trkinf,1,cominf);
					zmserror("\"..\" can use only for zmc2.",linebuf_,zms,4,1);
				} else {								/* @j old style */
					for (trk = 0; target[trk] >= 0; trk++) {
						const int Trk = target[trk];
						*trkdata[Trk].zmd++ = 0xC5;
						*trkdata[Trk].zmd++ = tmpDWORD;
					}
				}
				break;
			case '|':									/* loop */
			case ':':
				zms = makeZmdLoop1(--zms,trkdata,target,trkinf);
				break;
			case '[':									/* [..] commands */
				zms = makeZmdCommand(zms,trkdata,target,trkinf,cominf);
				break;
			case 't':	case 'T':						/* tempo */
				zms = makeZmdTempo(zms,trkdata,target);
				break;
			case '=':									/* switches */
				zms = getnum2(zms,&tmpDWORD,&err);
				if (err < 0) {
					tmpDWORD = 0;
				}
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					*trkdata[Trk].zmd++ = 0xC7;
					*trkdata[Trk].zmd++ = tmpDWORD;
					trkinf[Trk].veloseqsw = (tmpDWORD & 0x10)? 1 : 0;
				}
				break;
			case '~':	case '_':						/* relative velocity up/down*/
				tmpUBYTE = *(zms - 1);					/* keep MML */
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					DWORD v;
					int err;
					ld = ld_;
					if (getSwitchVal('z') > 1) {
						zms = getnum2(zms_, &v, &err);
						if (!err) trkinf[Trk].relvol = v;
						v = 0;
						do {
							char *linebuf_2 ;
							LINEDATA *ld_2;
							DWORD tmp;
							v += trkinf[Trk].relvol;
							zms = skipSpc(zms);
							if (*zms != tmpUBYTE) break;
							ld_2 = ld;
							linebuf_2 = linebuf;
							getnum2(zms + 1, &tmp, &err); /* Check only */
							ld = ld_2;
							linebuf = linebuf_2;
						} while (err < 0 && ++zms);
					} else {
						zms = zms_ - 1;
						v = 0;
						do {
							DWORD vol;
							zms = getnum2(zms + 1, &vol, &err);
							if (!err) trkinf[Trk].relvol = vol;
							v += trkinf[Trk].relvol;
							zms = skipSpc(zms);
						} while (*zms == tmpUBYTE);
					}
/* (BEGIN FM/ADPCMsupport by Mamiya */
					if (checkInternalDevice(trkdata,Trk) & 1) {
						DWORD vol = v;
						vol *= cominf->fmvol;
						if (tmpUBYTE == '~')
							v = trkinf[Trk].velou.var[0] + v ;
						else
							v = trkinf[Trk].velou.var[0] - v ;
						v = (v < 0) ? 0 : ((v > 127) ? 127 : v) ;
						trkinf[Trk].velou.var[0] = v ;
						*trkdata[Trk].zmd++ = (tmpUBYTE == '~')? 0xAA : 0xAB;
						*trkdata[Trk].zmd++ = vol / 255;
					} else {
						*trkdata[Trk].zmd++ = (tmpUBYTE == '~')? 0xAA : 0xAB;
						*trkdata[Trk].zmd++ = v;
					}
/* FM/ADPCMsupport by Mamiya END) */
				}
				break;
			case '\\':									/* fadein/fadeout */
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					ld = ld_;
					zms = getnum2(zms_, &tmpDWORD, &err);
					if (err < 0) {
						tmpDWORD = 0;	/* trkinf[target[trk]].fadeout; */
					}
					if (tmpDWORD < -85 || 85< tmpDWORD) {
						zmserror("fadein/out parameter is out of range(-85 - 85)",linebuf_,zms_,0,1);
					}
					*trkdata[Trk].zmd++ = 0xA6;
					*trkdata[Trk].zmd++ = trkinf[Trk].fadeout = tmpDWORD;
				}
				break;
			case '<':	case '>':						/* octave up/down */
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					if (*(zms - 1) == '<') {
						trkinf[Trk].octave++;
					} else {
						trkinf[Trk].octave--;
					}
					if (trkinf[Trk].octave < -1 || 9 < trkinf[Trk].octave) {
						zmserror("octave parameter is out of range(-1 - 9)",linebuf,zms,0,1);
					}
				}
				break;
			case 'o':	case 'O':						/* octave set */
				zms = get1AbsPara(zms,&tmpDWORD,-1,9,
						"octave parameter is out of range(-1 - 9).",
						"`o'(octave set) must be followed to its parameter.");
				for (trk = 0; target[trk] >= 0; trk++) {
					trkinf[target[trk]].octave = tmpDWORD;
				}
				break;
			case 'k':	case 'K':						/* key transpose */
				zms = get1AbsPara(zms,&tmpDWORD,-128,127,
						"key transpose parameter is out of range(-128 - 127).",
						"`k'(key transpose) must be followed to its parameter.");
				for (trk = 0; target[trk] >= 0; trk++) {
					trkinf[target[trk]].transpose = tmpDWORD;
				}
				break;
			case 'n':	case 'N':						/* channel change */
				zms = get1AbsPara(zms,&tmpDWORD,1,32,
						"channel change parameter is out of range(1 - 32).",
						"`n'(channel change) must be followed to its parameter.");
				for (trk = 0; target[trk] >= 0; trk++) {
					BYTE ch = 0;
					const int Trk = target[trk];
					if (cominf->basech) {				/* (B1) MIDI mode */
						if (tmpDWORD <= 16) {
							ch = tmpDWORD + 8;
						} else if (tmpDWORD <= 25) {
							ch = tmpDWORD - 17;
/* (BEGIN debug??? by Mamiya */
						} else {
							ch = tmpDWORD - 1;
/* debug??? by Mamiya END) */
						}
					} else {
						ch = tmpDWORD - 1;
					}
					*trkdata[Trk].zmd++ = 0xA3;
					*trkdata[Trk].zmd++ = trkdata[Trk].ch = ch;
				}
				break;
			case 'p':	case 'P':						/* panpot set */
				zms = get1AbsPara(zms,&tmpDWORD,0,3,
						"panpot parameter is out of range(0-3).",
						"`p'(panpot set) must be followed to its parameter.");
				for (trk = 0; target[trk] >= 0; trk++) {
					*trkdata[target[trk]].zmd++ = 0xB0 + tmpDWORD;
				}
				break;
			case 'i':	case 'I':						/* bank select */
				zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
										0xD3, 0x00, 2, 1, 1,
										"i: too many parameters.",
										"i: can't use relational parameters.",
										"");
				break;
			case 'h':	case 'H':						/* wave-synchronous mode set */
				zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
										0x9C, 0xFF, 2, 1, 1,
										"i: too many parameters.",
										"i: can't use relational parameters.",
										"");
				break;
			case 'm':	case 'M':						/* MIDI pitch modulation mode set */
				zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
										0x99, 0xFF, 2, 1, 1,
										"m: too many parameters.",
										"m: can't use relational parameters.",
										"");
				break;
			case 's':	case 'S':						/* modulation wave pattern select */
				{
					UBYTE *zms_ = zms;
					UBYTE *zms__ = zms;
					DWORD tmp;
					int err, i;
				zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
										0x98, 0xFF, 2, 1, 1,
										"s: too many parameters.",
										"s: can't use relational parameters.",
										"");
					for (i = 0; i < 2; i++) {
						zms_ = getnum2(zms_,&tmp,&err);
						if (!err) {
							if ((tmp < 0) ||
								(8 <= tmp && tmp <= 31 && !cominf->usedwav[tmp - 8]) ||
								(31 < tmp)) {
								/* there is a value, but not set before */
								zmserror("Specified wave number is not defined.",linebuf,zms__,0,1);
							}
						}
						zms_ = skipSpc(zms_);
						if (*zms_ == ',') {
							zms_++;
						} else {
							break;
						}
					}
				}
				break;
			case 'x':	case 'X':						/* Roland exclusive */
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					UBYTE sum = 0;
					ld = ld_;
					*trkdata[Trk].zmd++ = 0xEA;
					zms = zms_ - 1;
					do {
						zms = getnum2(++zms,&tmpDWORD,&err);
						if (err >= 0) {
							*trkdata[Trk].zmd++ = tmpDWORD;
							sum -= tmpDWORD;
							zms = skipSpcCr(zms);
						} else {
							break;
						}
					} while(*zms == ',');
					*trkdata[Trk].zmd++ = sum & 0x7F;
					*trkdata[Trk].zmd++ = 0xFF;
				}
				break;
			case 'y':	case 'Y':						/* control change */
				zms = makeZmdCChange(zms,trkdata,target);
				break;
			case 'z':	case 'Z':						/* velocity sequence */
				zms = makeZmdVeloSeq(zms,trkdata,target,trkinf);
				break;
			case 'q':	case 'Q':						/* quantization */
				zms = makeZmdQuantize(zms,cominf->qmode,target,trkinf);
				break;
			case 'u':	case 'U':						/* velocity */
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					BYTE rel = 0;
					DWORD velo;
					int err;
					ld = ld_;
					zms = skipSpcCr(zms_);
					if (*zms == '+') {
						rel = 1;
					} else if (*zms == '-') {
						rel = -1;
					}
					zms = getnum2(zms, &velo, &err);
					zms = skipSpcCr(zms);
					if (*zms == ':' && *(zms + 1) != '|') {
						DWORD r = trkinf[Trk].velou.var[1];
						/* DWORD rp = (r)? rand2(r) : 0; */
						int err2;
						zms = skipSpcCr(zms + 1);
						zms = getnum2(zms, &r, &err2);
						r = abs(r);
						/* rp = (r && !err2)? rand2(r) : 0; */
						trkinf[Trk].velou.var[1] = r;
					}
					if (rel > 0) {
						*trkdata[Trk].zmd++ = 0xCA;
						*trkdata[Trk].zmd++ = velo;		/* + rp; */
					} else if (rel < 0) {
						*trkdata[Trk].zmd++ = 0xCB;
						*trkdata[Trk].zmd++ = -velo;	/* + rp; */
					} else {
						*trkdata[Trk].zmd++ = 0xB9;
						if (err < 0) {					/* only 'u' */
							*trkdata[Trk].zmd++
								= trkinf[Trk].velou.var[0];	/* + rp; */
						} else {
							*trkdata[Trk].zmd++ = velo;	/* + rp */;
							trkinf[Trk].velou.var[0] = velo;
						}
					}
					setVelocitySequenceMode(trkinf,Trk,0);
				}
				break;
			case 'v':	case 'V':						/* volume */
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					DWORD vol;	/* ,v = trkinf[Trk].vol; */
					int err;
					ld = ld_;
					zms = getnum2(zms_, &vol, &err);
					if (err < 0) {						/* only 'v' */
						zmserror("v must be followed to its parameter",linebuf,zms,0,1);
					} else {
						if (vol < 0 || vol > 16) {
							zmserror("volume parameter is out of range",linebuf,zms,0,1);
/* (BEGIN FM/ADPCMsupport by Mamiya */
						} else if (checkInternalDevice(trkdata,Trk) & 1) {
							const BYTE vtblFM[17] = {
								85,87,90,93,95,98,101,103,106,109,111,114,117,119,122,125,127
							};
							DWORD v = vtblFM[vol];
							v *= cominf->fmvol;
							*trkdata[Trk].zmd++ = 0xB6;
							*trkdata[Trk].zmd++ = 127 - v / 255;
							trkinf[Trk].velou.var[0] = vtblFM[vol];
/* FM/ADPCMsupport by Mamiya END) */
						} else {
							const BYTE vtbl[17] = {
								0,7,15,23,31,39,47,55,63,71,79,87,95,103,111,119,127
							};
							*trkdata[Trk].zmd++ = 0xB6;
							*trkdata[Trk].zmd++ = 127 - vtbl[vol];
							/* trkinf[Trk].vol = vtbl[vol]; */
						}
					}
				}
				break;
			case 'w':	case 'W':					/* send/receive track synchoronous*/
				zms = getnum2(zms_, &tmpDWORD, &err);
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					if (err < 0) {					/* w  */
						*trkdata[Trk].zmd++ = 0x83;
					} else {
						int i, f = 0;
						for (i = 0; i < cominf->maxtrk; i++) {
							if (cominf->trkassign[i] == tmpDWORD) {
								*trkdata[Trk].zmd++ = 0xAF;
								*trkdata[Trk].zmd++ = i;	/* - 1; */
								f = 1;
								break;
							}
						}
						if (!f) {
							zmserror("illegal track number",linebuf,zms,0,1);
						}
					}
				}
				break;
			case '`':								/* */
				for (trk = 0; target[trk] >= 0; trk++) {
					*trkdata[target[trk]].zmd++ = 0xBF;
				}
				break;
			case '@':
				zms = makeZmdAtmark(zms,trkdata,target,trkinf,cominf);
				break;
			case '{':									/* renpu start */
				zms = skipSpcCr(zms);
				if (*zms == '{') {						/*  */
					for (trk = 0; target[trk] >= 0; trk++) {
						const int Trk = target[trk];
						trkinf[Trk].s->next       = (CHKSTEP*)emalloc(sizeof(CHKSTEP) * 1, "trkinf[Trk].s->next");
						trkinf[Trk].s->next->prev = trkinf[Trk].s;
						trkinf[Trk].s             = trkinf[Trk].s->next;
						trkinf[Trk].s->next       = (CHKSTEP*)NULL;
						trkinf[Trk].s->step       = trkinf[Trk].total;	/*0;*/
					}
					zms++;
					zmserror("{{..}} can use only for zmc2",linebuf_,zms,4,1);
				} else {
					for (trk = 0; target[trk] >= 0; trk++) {
						if (trkinf[target[trk]].renpnotes) {
							zmserror("renpu{..} can't nest",linebuf,zms,0,1);
						}
						trkinf[target[trk]].renpnotes = 1;
					}
				}
				break;
			case '}':									/* renpu end */
				zms = skipSpcCr(zms);
				if (*zms == '}') {						/* }} */
					for (trk = 0; target[trk] >= 0; trk++) {
						const int Trk = target[trk];
						UWORD step_;
						UWORD usedstep = (UWORD)(trkinf[Trk].total - trkinf[Trk].s->step);
						int err;
						if (trkinf[Trk].s->prev == NULL) {
							zmserror("no {{  found",linebuf,zms,0,1);
						}
						ld = ld_;
						zms = getStep(zms + 1, &step_, trkinf[Trk].Step,&err,cominf);
						zms = skipSpcCr(zms);
						zms = set98Tie(zms,&step_,trkinf[Trk].Step,cominf,&err);
						if (step_ != usedstep) {	/* (UWORD)trkinf[Trk].s->step) { */
							char str[128];
							sprintf(str,"{{..}}: %d ticks are reserved, but %d are in use.",
										step_, usedstep);
							zmserror(str,linebuf_,zms_,2,1);
							zmserror("{{..}} can use only for zmc2",linebuf_,zms_,4,1);
						}
						trkinf[Trk].s = trkinf[Trk].s->prev;
						efree(trkinf[Trk].s->next, "trkinf[Trk].s->next");
						trkinf[Trk].s->next = NULL;
#ifdef AAA
						if (trkinf[Trk].s->prev) {
							trkinf[Trk].s->step += step_;
						}
#endif
					}
				} else {
					zms = makeRenpuStepGate(zms,target,trkdata,trkinf,cominf);
				}
				break;
			case 'r':	case 'R':
				for (trk = 0; target[trk] >= 0; trk++) {
					UWORD step,gate;
					int err,omitgate;
					const int Trk = target[trk];
					ld = ld_;
					zms = getStep(zms_, &step, trkinf[Trk].Step,&err,cominf);
					zms = getGate(zms,Trk,trkinf,step,&gate,&omitgate,cominf);
					zms = skipSpcCr(zms);
					if (*zms == ',') {							/* dummy velocity */
						zms = getnum2(zms + 1,&tmpDWORD,&err);
					}
					zms = setTie(zms, trkdata, Trk, trkinf,
									0x80, &step, &gate, 0, omitgate,
									trkinf[Trk].Step,cominf);
					incrementStepCounters(&trkinf[Trk],step);
#ifdef AAa
					if (!trkinf[Trk].renpnotes) {
						trkinf[Trk].total += step;
						if (trkinf[Trk].s->prev) {
							trkinf[Trk].s->step += step;
						}
					}
#endif
				}
				break;
			case 'a':	case 'A':						/* tone */
			case 'b':	case 'B':
			case 'c':	case 'C':
			case 'd':	case 'D':
			case 'e':	case 'E':
			case 'f':	case 'F':
			case 'g':	case 'G':
				/* [a-g](!+|[#+b-])*step,*gate,vel[&] */
				zms = makeZmdNote(zms,trkdata,target,trkinf,cominf);
				break;
			case 'l':	case 'L':						/* set default step */
				for (trk = 0; target[trk] >= 0; trk++) {
					UWORD step;
					int err;
					ld = ld_;
					zms = getStep(zms_, &step, trkinf[target[trk]].Step, &err,cominf);
					trkinf[target[trk]].Step = step;
				}
				break;
			case '\'':									/* chord */
				zms = makeZmdChord(zms,trkdata,target,trkinf,0,cominf);
				break;
			case '(':
				zms = skipSpc(zms);
				switch(*zms++) {
					case 'a':	case 'A':	case 'b':	case 'B':	/* portament */
					case 'c':	case 'C':	case 'd':	case 'D':
					case 'e':	case 'E':	case 'f':	case 'F':
					case 'g':	case 'G':	case 'o':	case 'O':
					case '<':	case '>':
						zms = makePortament(zms - 1,trkdata,target,trkinf,cominf);
						break;
					case 'p':	case 'P':						/* (P...) */
						zms = skiptochr(zms,")");				/* ignore */
						zms++;
						break;
					case 't':									/* (T...) */
					case 'T':
						do {
							int c = 0;
							DWORD trk;
							int err;
							while (*zms != ')') {
								int i = 0 - 1,chkflag = 0;
								char errstr[80];
								zms = getnum2(zms,&trk,&err);
								if (err && c == 0 && *zms == ')' ) {	/* (t) */
									zmserror("SYNTAX ERROR",linebuf,zms,0,1);
								}
								while (cominf->trkassign[++i] >= 0) {
									if (cominf->trkassign[i] == trk) {
										chkflag = 1;
										break;
									}
								}
								if (!chkflag) {
									sprintf(errstr,"trk %d is not assigned.",trk);
									zmserror(errstr,linebuf,zms,0,1);
								}
								while (trkdata[trk].backinuse >= 0) {
									trk = trkdata[trk].backinuse;
								}
								target[c++] = trk;
								target[c]   = -1;
								zms = skipSpc(zms);
								if (!strchr(",)", *zms)) {
									/* char str[128]; */
									/* sprintf(str,"%.2x illegal partion character.",*zms); */
									zmserror("illegal partition character",linebuf,zms,0,1);
								}
								if (*zms == ',') {
									zms++;
								} else if (*zms == 0xFF && *(zms + 1) == 0xFF) {	/* EOF */
									zmserror("unexpected EOF",linebuf,zms,0,1);
								}
							}
							zms++;
/*
							printf("Target:");
							for (trk = 0; target[trk] >= 0; trk++) {
								printf("%d,",target[trk]);
							}
							printf("\n");
*/
						} while (0);
						break;
					default:
						zmserror("UNKNOWN MML",linebuf,zms,0,1);
						break;
				}
				break;
			case '/':
				zms = skipComment(zms);
				break;
			case ']':			/* end of [back...] */
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk     = target[trk];
					const int fromtrk = cominf->fromtrk[Trk];
					/* trkdata[Trk].backinuse = -1; */
					if (fromtrk < 0) {
						zmserror("']' nest error.",linebuf,zms,0,1);
					}
					target[trk] = fromtrk;
					trkdata[fromtrk].backinuse = -1;
				}
				break;
/* (BEGIN FM/ADPCMsupport by Mamiya */
			case 'j':	case 'J':
				zms = getnum2(zms_, &tmpDWORD, &err);
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					if (err < 0) {
						zmserror("restart(`j') must be followed to its parameter",linebuf_,zms_,0,1);
					} else if (tmpDWORD < 1 || cominf->maxtrk <= tmpDWORD) {
						zmserror("track number is out of range",linebuf_,zms_,0,1);
					} else {
						int i, f = 0;
						for (i = 0; i < cominf->maxtrk; i++) {
							if (cominf->trkassign[i] == tmpDWORD) {
								*trkdata[Trk].zmd++ = 0xCE;
								*trkdata[Trk].zmd++ = i;	/* - 1; */
								f = 1;
								break;
							}
						}
						if (!f) {
							zmserror("illegal track number",linebuf_,zms_,0,1);
						} else {
							zmserror("restart(`j') will be ignored by many drivers",linebuf_,zms_ - 1,3,1);
						}
					}
				}
				break;
			case '?':
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					BYTE rel = 0;
					DWORD address;
					ld = ld_;
					zms = getnum2(zms_,&address,&err);
					if (err < 0) {
						zmserror("workarea control(`?') must be followed to its parameter",linebuf_,zms_,0,1);
					} else if (address < 0 || 255 < address) {
						zmserror("work address is out of range",linebuf_,zms_,0,1);
					}
					zms = skipSpcCr(zms);
					if (*zms != ',') {
						zmserror("workarea control(`?') must have 2 parameters",linebuf_,zms_,0,1);
					} else {
						zms = skipSpcCr(zms + 1);
					}
					if (*zms == '+' || *zms == '-') rel = 1;
					zms = getnum2(zms,&tmpDWORD,&err);
					if (err < 0) {
						zmserror("workarea control(`?') must have 2 parameters",linebuf_,zms_,0,1);
					} else {
						if (!rel) {
							*trkdata[Trk].zmd++ = 0xD5;
							*trkdata[Trk].zmd++ = address;
							*trkdata[Trk].zmd++ = tmpDWORD;
						} else if (tmpDWORD < 0) {
							*trkdata[Trk].zmd++ = 0xD8;
							*trkdata[Trk].zmd++ = address;
							*trkdata[Trk].zmd++ = -tmpDWORD;
						} else {
							*trkdata[Trk].zmd++ = 0xD7;
							*trkdata[Trk].zmd++ = address;
							*trkdata[Trk].zmd++ = tmpDWORD;
						}
						zmserror("workarea control(`?') will be ignored by many drivers",linebuf_,zms_ - 1,3,1);
					}
				}
				break;
			case ';':
				for (trk = 0; target[trk] >= 0; trk++) {
					const int Trk = target[trk];
					ld = ld_;
					zms = zms_ - 1;
					do {
						zms = getnum2(zms + 1,&tmpDWORD,&err);
						if (err < 0) break;
						*trkdata[Trk].zmd++ = tmpDWORD;
						zms = skipSpcCr(zms);
					} while(*zms == ',');
					zmserror("It's too dangerous to insert ZMD data directly",linebuf_,zms_ - 1,3,1);
				}
				break;
/* FM/ADPCMsupport by Mamiya END) */
			default:
				zms--;
				if (*zms != ' ' && *zms != '\t' && *zms != nativeCR && *zms != 0x1a && *zms != 0xff) {
					/* fprintf(stderr,"err! %.2X %c\n",*zms,*zms); */
					zmserror("unknown MML",linebuf,zms,2,1);
				}
				zms++;
				break;
		}
		if (stat) {
			break;
		} else {
			for (trk = 0; target[trk] >= 0; trk++) {		/* memory leak check */
				const int  Trk = target[trk];
				const DWORD bs = trkdata[Trk].zmd - trkdata[Trk].zmdbuf;
				if (bs > trkdata[Trk].bufsize - MTRK_OVERFLOW_RANGE) {
					trkdata[Trk].bufsize += FIRST_MTRK_SIZE;
					trkdata[Trk].zmdbuf = (UBYTE*)erealloc(trkdata[Trk].zmdbuf,sizeof(UBYTE) * trkdata[Trk].bufsize, "trkdata[Trk].zmdbuf");
					trkdata[Trk].zmd = trkdata[Trk].zmdbuf + bs;
				}
			}
		}
	}
	*zms2 = zms;
	for (i = 1; i < cominf->maxtrk; i++) {
		char errmes[80];
		trkdata[i].nowsize = trkdata[i].zmd - trkdata[i].zmdbuf;
		if (trkinf[i].renpnotes) {
			sprintf(errmes,"`}' is not closed in track %d.",i);
			zmserror(errmes,linebuf,zms,0,0);
			resetError();
		}
		if (trkinf[i].l->prev) {
			if (trkinf[i].l->loopmode >= 0) {
				sprintf(errmes,":| is not closed in track %d.",i);
				zmserror(errmes,linebuf,zms,3,0);
				resetError();
			}
			do {
				trkinf[i].l = trkinf[i].l->prev;
				efree(trkinf[i].l->next, "trkinf[i].l->next");
				trkinf[i].l->next = NULL;
			} while (trkinf[i].l->prev);
		}
		if (trkinf[i].d->looptime) {
			sprintf(errmes,"[do]`[loop] is not closed in track %d.",i);
			zmserror(errmes,linebuf,zms,3,0);
			resetError();
/*
			do {
				trkinf[i].d = trkinf[i].d->prev;
				free(trkinf[i].d->next);
				trkinf[i].d->next = NULL;
			} while (trkinf[i].d->prev);
*/
		}
		if (trkinf[i].s->prev) {
			sprintf(errmes,"`}}' is not closed in track %d.",i);
			zmserror(errmes,linebuf,zms,4,0);
			resetError();
			do {
				trkinf[i].s = trkinf[i].s->prev;
				efree(trkinf[i].s->next, "trkinf[i].s->next");
				trkinf[i].s->next = NULL;
			} while (trkinf[i].s->prev);
		}
		freeTrkInf(&trkinf[i]);
	}
	efree(trkinf, "trkinf");
	efree(target, "target");
	return trkdata;
}
UBYTE *makeZmdNote(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf)
{
	int	trk;
	char *zms_ = zms - 1;
	/* UBYTE *data_ = data; */
	LINEDATA	*ld_ = ld;
	VELOETCVAR v;
	int warnoct = 0;
	/* v = (VELOETCVAR*)emalloc(sizeof(VELOETCVAR) * 1); */
	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		BYTE	note,relvelo = 0;
		UWORD	step,gate;
		/* DWORD	velo; */
		int		err,omitgate = 0;
		BYTE	*qpos = &(trkinf[Trk].quantizepos);
		const int beforeOctave = trkinf[Trk].octave;
		UBYTE	*linebuf_;
		/* data = data_; */
		ld = ld_;
		/* note */
		zms = makeZmdNote1(zms_,Trk,trkinf,&note);
/* printf("(%.2x)",note); */
		zms = checkOctaveChange(zms,trkinf,Trk);
		/* step */
		zms = getStep(zms, &step, trkinf[Trk].Step,&err,cominf);
		zms = checkOctaveChange(zms,trkinf,Trk);
		/* gate */
		zms = getGate(zms,Trk,trkinf,step,&gate,&omitgate,cominf);
		zms = checkOctaveChange(zms,trkinf,Trk);
		/* velo */
		zms = getSpecialVelocity(zms,&v);
		setVelo0(trkdata,Trk,v,&relvelo,trkinf,cominf,step);
/*
		if (velo > 127) {
			velo = 127;
		} else if (velo < 0) {
			velo = 0;
		}
*/
		linebuf_ = linebuf;
		zms = setTie(zms, trkdata, Trk, trkinf,				/* TIE */
						note, &step, &gate, relvelo, omitgate,
						trkinf[Trk].Step,cominf);
		/* if (trkinf[Trk].quantize[++*qpos].relflg[0] < 0) { */
		if (++*qpos >= trkinf[Trk].quantizenum) {
			*qpos = 0;
		}
		if (gate == 0xFFFF && beforeOctave != trkinf[Trk].octave && !warnoct && step != 1) {
			zmserror("There is octave switch(es) between NOTE and TIE",linebuf_,zms_,3,2);
			warnoct = 1;
		}
		incrementStepCounters(&trkinf[Trk], step);
		if (trkinf[Trk].veloseqsw) {	/* add v1.27 */
			vSeqLoopChk(Trk,trkinf);
		}
#ifdef AAA
		if (!trkinf[Trk].renpnotes) {
			trkinf[Trk].total += step;
			if (trkinf[Trk].s->prev) {
				trkinf[Trk].s->step += step;
			}
		}
#endif
	}
	return zms;
}
/* ==================
     get tone (sub)
   ================== */
UBYTE *makeZmdNote1(UBYTE *zms, const int Trk,TRKINF *trkinf,BYTE *note)
{
	/* const int Trk = target[trk]; */
	const BYTE tonetbl[7] = { 0, 2, 4, 5, 7, 9, 11 };
	const char *dstr_ = "#+--!";
	BYTE	d[3] = { 0, 0, 0 };					/* number of #+,b-,! */
	char	*dstr;
	BYTE	note_bak;
	*note  = (*zms++ | 0x20) - 'a';
	*note -= 2;									/* c => 0 / a => -2 */
	if (*note < 0) {
		*note += 7;
	}
	*note = tonetbl[*note];						/* without #/b */
	note_bak = *note;							/* add v1.32 */
	*note += trkinf[Trk].ksign[*note % 12];		/* with KSIGN */
	zms = skipSpcCr(zms);
	while ( (dstr = strchr(dstr_,*zms)) != NULL) {
		const BYTE p = ((const char *)dstr - dstr_) / 2;
		d[p]++;
		/* if (d[2]) { */						/* delete v1.32 */
		if (p == 2) {							/* add v1.32 */
			if (d[2] > 1) {
				zmserror("too many natural(!)",linebuf,zms,0,1);
/*
			} else if (d[0] || d[1]) {
				zmserror("natural(!) must be on just after note",linebuf,zms,0,1);
*/												/* delete v1.32 */
			} else {	/* d[2] == 1 */			/* add v1.32 */
				*note = note_bak;
			}
		} else {		/* p == 0 || p == 1 */	/* add v1.32 */
			*note -= p * 2 - 1;		/* +1 || -1 */
		}
		zms = skipSpcCr(++zms);
	}
#ifdef aa			/* delete v1.32 */
	if (!d[2]) {
		*note += trkinf[Trk].ksign[*note % 12];	/* with KSIGN */
	}
	*note += d[0];
	*note -= d[1];								/* #/b is reflected */
#endif
	*note += trkinf[Trk].transpose;				/* transpose is reflected  */
	*note += (trkinf[Trk].octave + 1) * 12;
												/* #/b,transpose,octrave are reflected */
	return zms;
}
/* ======================
     get gate parameter
   ====================== */
UBYTE *getGate(UBYTE *zms, const int Trk,TRKINF *trkinf,UWORD step, UWORD *gate,int *err,
				COMMONINF *cominf)
{
	/* const int Trk = target[trk]; */
	if (*zms == ',') {
		zms = getStep(++zms, gate, trkinf[Trk].Step,
						err,cominf);
		if (*err == 2) {						/* if gate is omitted */
			*gate = getGate1(Trk,trkinf,step);
		}
	} else {
		*err = 2;
		*gate = getGate1(Trk,trkinf,step);
	}
	if ((step < *gate) && step) {
		zmserror("step < gate",linebuf,zms,3,1);
	}
	return zms;
}
/* ==
     portament/chord
*/
UBYTE *makePortChord(UBYTE *zms, const int Trk,
						TRKINF *trkinf,COMMONINF *cominf,
						const UBYTE endchar,/* char allowcamma, */
						VELOETCVAR v[],BYTE note[],int *notes,
						UWORD *step_, UWORD *gate_,WORD *delay)
{
	char *zms_ = zms - 1;
	char *linebuf_ = linebuf;
	/* LINEDATA	*ld_ = ld; */
	/* const int Trk = target[trk]; */
	UWORD step;
	int i,err,steps = 0;
	int beforeOctave = trkinf[Trk].octave;
	DWORD tmpDWORD;
	const UWORD Step = trkinf[Trk].Step;
	*notes = 0;
	*step_ = trkinf[Trk].Step;
	*gate_ = getGate1(Trk,trkinf,*step_);
	/* *delay = trkinf[Trk].pdelay; */
	for (i = 0; (i < 8 + 1 && !(*notes)); ) {
		/* UBYTE *tmpzms; */
		zms = skipSpc(zms);
		switch (*zms) {
			case 'a':	case 'A':	case 'b':	case 'B':
			case 'c':	case 'C':	case 'd':	case 'D':
			case 'e':	case 'E':	case 'f':	case 'F':
			case 'g':	case 'G':
				err = 0;
				zms = makeZmdNote1(zms,Trk,trkinf,&note[i]);
				zms = getStep(zms, &step,Step,&err,cominf);
				if (err != 2) {
					*gate_ = getGate1(Trk,trkinf,step);
				}
			/*	if (endchar == '\"') { */
			/*	if (endchar != ')') { */
				{
					int omitgate1, omitgate2;
					int err98;
					/*UWORD gate;*/
					UWORD newgate1, newgate2;
					v[i].var[0] = 0;
					v[i].relflg[0] = 2;
					zms = getGate(zms,Trk,trkinf,step,&newgate1,&omitgate1,cominf);
					zms = getSpecialVelocity(zms,&v[i]);
/*
					if (omitgate != 2) {
						*gate_ = newgate;
					}
*/
					/* tmpzms = */ zms = skipSpc(zms);
					zms = set98Tie(zms,&step,Step,cominf, &err98);
				/*if (endchar != ')') {*/
					/*UWORD gate;*/
					/*int omitgate;*/
					/*UWORD newgate;*/
					/*v[i].var[0] = 0;*/
					v[i].relflg[0] = 2;
					zms = getGate(zms,Trk,trkinf,step,&newgate2,&omitgate2,cominf);
					zms = getSpecialVelocity(zms,&v[i]);
					if (err != 2 || err98 != 2) {
									/* err == 0: there is parameter */
									/*     == 1: only dot(.) there */
									/*     == 2: omit all parameters */
						if (++steps > 1 && *step_ != step) {
							zmserror("too many steps or gates in a chord/portament",linebuf,zms,0,1);
						} else {
							*step_ = step;
							if (omitgate2 == 2 && omitgate1 == 2) {
								*gate_ = getGate1(Trk,trkinf,*step_);
							} else {
								if (omitgate1 != 2) {
									*gate_ = newgate1;
								} else {
									*gate_ = newgate2;
								}
							}
						/* *gate_ = getGate1(Trk,trkinf,*step_); */
						}
					}
				}
				i++;
				break;
			case 'o':
				zms = get1AbsPara(++zms,&tmpDWORD,-1,9,
						"octave parameter is out of range(-1 - 9).",
						"'o'(octave set) must be followed to its parameter.");
				trkinf[Trk].octave = tmpDWORD;
				break;
			case '<':	case '>':
				zms = checkOctaveChange(zms,trkinf,Trk);
				break;
			case ',':
#ifdef A
				if (allowcamma) {
					zms++;
				} else {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
#endif
				zms++;
				break;
			case '\'':
			case ')':
			case '\"':
				if (*zms == endchar) {
					*notes = i;
					zms++;
				} else {
					zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				}
				break;
			default:
				zmserror("SYNTAX ERROR",linebuf,zms,0,1);
				break;
		}
	}
	if (endchar == '\'' || endchar == '\"') {
		trkinf[Trk].octave = beforeOctave;
	} else {
		beforeOctave = trkinf[Trk].octave;
	}
	zms = getnum2(zms,&tmpDWORD,&err);
	if (err >= 0) {							/* there is a (ticked)step parameter */
		*step_ = tmpDWORD;
		*gate_ = getGate1(Trk,trkinf,*step_);
	} else 	if (*zms == '*') {
		zms = getnum2(++zms,&tmpDWORD,&err);
		if (err >= 0) {						/* there is a (ticked)step parameter */
			*step_ = tmpDWORD;
			*gate_ = getGate1(Trk,trkinf,*step_);
		}
	}
	zms = checkOctaveChange(zms,trkinf,Trk);
	if (*zms == ',') {
		zms = skipSpcCr(zms + 1);
		if (*zms == '*') {
			zms++;
		}
		zms = getnum2(zms,&tmpDWORD,&err);
		if (err) {
			zmserror("no delay parameter is specified",linebuf,zms,0,1);
		}
		*delay = tmpDWORD;
	}
	zms = checkOctaveChange(zms,trkinf,Trk);
	zms = skipSpcCr(zms);
	zms = set98Tie(zms,step_,Step,cominf,&err);
	/* *gate_ = getGate1(Trk,trkinf,*step_); */
	zms = skipSpcCr(zms);
	if (*zms == '&') {			/* tie */
		*gate_ = 0xFFFF;
		if (beforeOctave != trkinf[Trk].octave) {
			zmserror("There is octave switch(es) between NOTE and TIE",linebuf,zms,3,1);
		}
		zms++;
	}
	if (*delay > *gate_) {
/* fprintf(stderr,"[g=%d/d=%d]",*gate_, *delay); */
		zmserror("delay must be less than the gate",linebuf_,zms_,0,1);
	}
	if (*step_ == 1 && cominf->l1tie) {		/* gate is *1 */
		*gate_ = 0xFFFF;
	}
	return zms;
}