/* ==========================================
     @ series (@v, @b, @r, ... ) conversion
     and... many subroutines
   ========================================== */
#include <stdio.h>
#include <stdlib.h>
#include "switch.h"
#include "etc.h"
#include "makezmd2.h"
#include "parsesub.h"
#include "velo.h"
#include "68lib.h"
#include "structs.h"
#include "structs2.h"
int checkInternalDevice(TRKCHINF *trkdata, BYTE Trk);
void initTrkInf(TRKINF *trkinf, COMMONINF *cominf);
void initTrkInf2(TRKINF *trkinf);
void freeTrkInf(TRKINF *trkinf);
UBYTE *makeZmdAtmark(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf);
UBYTE *makeZmdLoop1(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf);
UBYTE *makeZmdCommand(UBYTE *zms,TRKCHINF *trkdata, BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf);
UBYTE *makeZmdEigDepthSub(UBYTE *zms,
						VELOETCVAR *vv, BYTE *pos,BYTE *num,BYTE supplementmode);
UBYTE *makeZmdVeloSeq(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf);
UBYTE *makeZmdQuantize(UBYTE *zms, int mode, const BYTE target[],
						TRKINF *trkinf);
UBYTE *makeZmdManyParas(UBYTE *zms,TRKCHINF *trkdata,const BYTE target[],
						char *linebuf,
						UBYTE com, UBYTE omitcode,BYTE maxparas,
						BYTE parabytes,BYTE omitflg,
						char *errmes1, char *errmes2,char *errmes3);
UBYTE *makeZmdTempo(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[]);
UBYTE *makeZmdCChange(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[]);
UBYTE *makeZmdChord(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
					TRKINF *trkinf,char extmode,COMMONINF *cominf);
UBYTE *makePortament(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf);
int checkCommonCommand(UBYTE *zms_,int notes,BYTE note[],UWORD step_,
						char *linebuf_, COMMONINF *cominf);
extern char *linebuf;
extern LINEDATA *ld;
int checkInternalDevice(TRKCHINF *trkdata, BYTE Trk) {	/* thanks to Mamiya */
	if (0 <= trkdata[Trk].ch && trkdata[Trk].ch <= 7) return 1;		/* OPM */
	if (trkdata[Trk].ch == 8) return 2;								/* ADPCM */
	if (25 <= trkdata[Trk].ch && trkdata[Trk].ch <= 31) return 2;	/* PCM8 */
	return 0 ;
}
void initTrkInf(TRKINF *trkinf, COMMONINF *cominf)
{
	int j;
	trkinf->total = 0;
	trkinf->velocity = emalloc(sizeof(VELOETCVAR) * 1, "trkinf->velocity");
	trkinf->velocity[0].var[0] = 127;
	trkinf->velocity[0].var[1] = 0;
	trkinf->velozpos = 0;
	trkinf->veloznum = 0;
	trkinf->velou.var[0] = 127;
	trkinf->velou.var[1] = 0;
	trkinf->velou.relflg[0] = 0;	/* velocity sequences flag: 1:now on use 0: non use */
	trkinf->relvelo = 0;
	trkinf->nowvelo = 127;
	trkinf->veloseqsw = 1;
	trkinf->quantize = emalloc(sizeof(VELOETCVAR) * 1, "trkinf->quantize");
	trkinf->quantize[0].var[0] = cominf->gtreso;
	trkinf->quantize[0].var[1] = 0;
	trkinf->quantize[0].relflg[0] = 0;
	trkinf->quantize[0].relflg[1] = -1;
	trkinf->quantizepos = 0;
	trkinf->quantizenum = 1;
	trkinf->mod[0].var[0] = 0;
	trkinf->mod[0].relflg[0] = 0;
	trkinf->arcc[0].var[0] = 127;
	trkinf->arcc[0].relflg[0] = 0;
	trkinf->octave = 4;
	trkinf->Step = 48;
	trkinf->laststep = 48;
	trkinf->modpos = 0;
	trkinf->modnum = 0;
	trkinf->arccpos = 0;
	trkinf->arccnum = 0;
	/* trkinf->vol = 64; */
	trkinf->relvol = 1;
	trkinf->randvelotype  = 0;
	trkinf->randvelopower = 0;
	for (j = 0; j < 12; j++) {
		trkinf->ksign[j] = 0;
	}
	trkinf->transpose = 0;
	trkinf->fadeout = 0;
	trkinf->abdelay = 0;
	trkinf->pdelay = 0;
	trkinf->cdelay = 0;
	trkinf->spvelomode = 0;
	trkinf->renpnotes = 0;
	trkinf->cominf = cominf;
	trkinf->back_repeat = 0;
}
void initTrkInf2(TRKINF *trkinf)
{
		trkinf->l = (LOOPDATA*)emalloc(sizeof(LOOPDATA) * 1, "trkinf->l");
		trkinf->d = (LOOPDATA*)emalloc(sizeof(LOOPDATA) * 1, "trkinf->d");
		trkinf->r = (RENP*)emalloc(sizeof(RENP) * 1, "trkinf->r");
		trkinf->s = (CHKSTEP*)emalloc(sizeof(CHKSTEP) * 1, "trkinf->s");
/*
		trkinf->b = (BACK*)emalloc(sizeof(BACK) * 1);
		trkinf->e = (EVENT*)emalloc(sizeof(EVENT) * 1);
*/
		trkinf->l->next = trkinf->l->prev = NULL;
		trkinf->l->loopmode = 0;
		trkinf->d->next = trkinf->d->prev = NULL;
		trkinf->d->looptime = 0;
		trkinf->r->next = trkinf->r->prev = NULL;
		trkinf->s->next = trkinf->s->prev = NULL;
/*
		trkinf->b->next = trkinf->b->prev = NULL;
		trkinf->e->next = trkinf->e->prev = NULL;
*/
		trkinf->r->step = -1;
		trkinf->r->pflg = 0;
		trkinf->s->step = 0;
/*
		trkinf->e->code = 0;
*/
}
void freeTrkInf(TRKINF *trkinf)
{
	efree(trkinf->velocity, "trkinf->velocity");
	efree(trkinf->quantize, "trkinf->quantize");
	efree(trkinf->l, "trkinf->l");
	efree(trkinf->d, "trkinf->d");
	efree(trkinf->r, "trkinf->r");
	efree(trkinf->s, "trkinf->s");
/*
	free(trkinf->b);
	free(trkinf->e);
*/
}
void copyTrkInf(TRKINF *des, TRKINF *src)
{
	int i;
	BYTE num;
	efree(des->velocity, "des->velocity");
	efree(des->quantize, "des->quantize");
	{
		LOOPDATA *l, *d;
		RENP *r;
		CHKSTEP *s;
		l = des->l;
		d = des->d;
		r = des->r;
		s = des->s;
		*des = *src;
		des->l = l;
		des->d = d;
		des->r = r;
		des->s = s;
	}
	num = des->veloznum ? des->veloznum : 1;
	des->velocity = emalloc(sizeof(VELOETCVAR) * num, "des->velocity");
	for (i = 0; i < num; i++) {
		des->velocity[i] = src->velocity[i];
	}
	num = des->quantizenum ? des->quantizenum : 1;
	des->quantize = emalloc(sizeof(VELOETCVAR) * num, "des->quantize");
	for (i = 0; i < num; i++) {
		des->quantize[i] = src->quantize[i];
	}
}
UBYTE *makeZmdAtmark(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf)
{
	UBYTE *zms_ = zms + 1;
	DWORD tmpDWORD;
	int trk,err;
	LINEDATA *ld_ = ld;
	char *linebuf_ = linebuf;
	switch (*zms++) {
		case 'm':	case 'M':				/* @m */
			for (trk = 0; target[trk] >= 0; trk++) {
				int i;
				VELOETCVAR v[17];
				UBYTE flg = 0;
				const int Trk = target[trk];
				ld = ld_;
				zms = makeZmdEigDepthSub(zms_,
											v,&trkinf[Trk].modpos,
											&trkinf[Trk].modnum,1);
				if (trkinf[Trk].modnum == 0) {
					*trkdata[Trk].zmd++ = 0xBB;	/* mod sw off */
					*trkdata[Trk].zmd++ = 0x00;
				} else if (trkinf[Trk].modnum == 1) {
					if (v[0].var[0] == 0) {
						*trkdata[Trk].zmd++ = 0xBB;	/* mod sw off */
						*trkdata[Trk].zmd++ = 0x00;
					} else {
						*trkdata[Trk].zmd++ = 0xE6;	/* mod single */
						putWord(trkdata[Trk].zmd, v[0].var[0]);
						trkdata[Trk].zmd += 2;
					}
				} else {								/* mod dep1/8 */
					UBYTE *zmd__;
					*trkdata[Trk].zmd++ = 0xEE;
					zmd__ = trkdata[Trk].zmd;
					trkdata[Trk].zmd++;
					for (i = 0; i < trkinf[Trk].modnum; i++) {
						trkinf[Trk].mod[i].var[0]    = v[i].var[0];
						trkinf[Trk].mod[i].relflg[0] = v[i].relflg[0];
						putWord(trkdata[Trk].zmd,v[i].var[0]);
						trkdata[Trk].zmd += 2;
						flg >>= 1;
						if (v[i].relflg[0] != 2) {
							flg |= 0x80;
						}
					}
					for (i = trkinf[Trk].modnum; i < 8; i++) {
						trkinf[Trk].mod[i].var[0]    = 0;
						trkinf[Trk].mod[i].relflg[0] = 2;
						putWord(trkdata[Trk].zmd,0);
						trkdata[Trk].zmd += 2;
						flg >>= 1;
						flg &= 0x7F;
					}
					*zmd__ = flg;
				}
			}
			break;
		case 'a':	case 'A':				/* @a */
			for (trk = 0; target[trk] >= 0; trk++) {
				int i;
				VELOETCVAR v[17];
				UBYTE flg = 0;
				const int Trk = target[trk];
				ld = ld_;
				zms = makeZmdEigDepthSub(zms_,
											v,&trkinf[Trk].arccpos,
											&trkinf[Trk].arccnum,1);
				if (trkinf[Trk].arccnum == 0) {
					*trkdata[Trk].zmd++ = 0xBC;	/* arcc sw off */
					*trkdata[Trk].zmd++ = 0x00;
				} else if (trkinf[Trk].arccnum == 1) {
					if (v[0].var[0] == 0) {
						*trkdata[Trk].zmd++ = 0xBC;	/* arcc sw off */
						*trkdata[Trk].zmd++ = 0x00;
					} else {
						*trkdata[Trk].zmd++ = 0xAE;	/* arcc single */
						*trkdata[Trk].zmd++ = v[0].var[0];
					}
				} else {								/* arcc dep1/8 */
					UBYTE *zmd__;
					*trkdata[Trk].zmd++ = 0xEF;
					zmd__ = trkdata[Trk].zmd;
					trkdata[Trk].zmd++;
					for (i = 0; i < trkinf[Trk].arccnum; i++) {
						trkinf[Trk].arcc[i].var[0]    = v[i].var[0];
						trkinf[Trk].arcc[i].relflg[0] = v[i].relflg[0];
						*trkdata[Trk].zmd++ = (v[i].relflg[0] != 2)? v[i].var[0] : 0;
						flg >>= 1;
						if (v[i].relflg[0] != 2 && (!i || (i > 0 && v[i].var[0] != v[i - 1].var[0]))) {
							flg |= 0x80;
						}
					}
					for (i = trkinf[Trk].arccnum; i < 8; i++) {
						trkinf[Trk].arcc[i].var[0]    = 0;
						trkinf[Trk].arcc[i].relflg[0] = 2;
						*trkdata[Trk].zmd++ = 0;
						flg >>= 1;
						flg &= 0x7F;
					}
					*zmd__ = flg;
				}
			}
			break;
		case 'b':	case 'B':				/* @b */
		case 'k':	case 'K':				/* @k */
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				UBYTE mml = *(zms_ - 1);
				ld = ld_;
				zms = getnum2(zms_, &tmpDWORD, &err);
				if (err < 0) {								/* autobend sw off */
					*trkdata[Trk].zmd++ = 0xBD;
					*trkdata[Trk].zmd++ = 0x00;
				} else {
					zms = skipSpc(zms);
					if (*zms == ',') {						/* @bnnn,NNN */
						DWORD tmpDWORD2, delay;
						int st = (mml == 'b' || mml == 'B')? 4 : 0;
						zms = getnum2(++zms, &tmpDWORD2, &err);
						if (err < 0) {						/* @bnnn,NNN */
							zmserror("@b/@k can't omit 2nd parameter when it means autobend.",linebuf_,zms_,0,1);
						} else {
							zms = skipSpc(zms);
							if (*zms == ',') {				/* @bnnn,NNN(,zzz) */
								zms = getnum2(++zms, &delay, &err);
								trkinf[Trk].abdelay = delay;
								if (err < 0) {				/* @bnnn,NNN, */
									zmserror("@b/@k can't omit delay parameter when you want to set.",linebuf_,zms_,0,1);
								}
							} else {
								delay = trkinf[Trk].abdelay;
							}
						}
						*trkdata[Trk].zmd++ = 0xE1;
						/* tmpDWORD2 -= tmpDWORD; */
						putWord(trkdata[Trk].zmd + st    , tmpDWORD );
						putWord(trkdata[Trk].zmd + st + 2, tmpDWORD2 - tmpDWORD);
						if (st) {
							tmpDWORD  <<= 6;
							tmpDWORD  /= 683;
							tmpDWORD2 <<= 6;
							tmpDWORD2 /= 683;
						} else {
							tmpDWORD  *= 683;
							tmpDWORD  >>= 6;
							tmpDWORD2 *= 683;
							tmpDWORD2 >>= 6;
						}
						putWord(trkdata[Trk].zmd + (4 - st)    ,tmpDWORD );
						putWord(trkdata[Trk].zmd + (4 - st) + 2,tmpDWORD2 - tmpDWORD);
						putWord(trkdata[Trk].zmd + 8,delay);
						trkdata[Trk].zmd += 10;
						*trkdata[Trk].zmd++ = (tmpDWORD2 - tmpDWORD >= 0)? 1 : 0xFF;
					} else {								/* @bnnn */
						int st = (mml == 'b' || mml == 'B')? 2 : 0;
						*trkdata[Trk].zmd++ = 0xD1;
						putWord(trkdata[Trk].zmd + st, tmpDWORD);
						if (st) {
							tmpDWORD <<= 6;
							tmpDWORD /= 683;
						} else {
							tmpDWORD *= 683;
							tmpDWORD >>= 6;
						}
						putWord(trkdata[Trk].zmd + (2 - st), tmpDWORD);
						trkdata[Trk].zmd += 4;
					}
				}
			}
			break;
		case 'x':	case 'X':				/* @x */
			for (trk = 0; target[trk] >= 0; trk++) {
				UBYTE *zmd_;
				UWORD bytes = 0;
				const int Trk = target[trk];
				ld = ld_;
				*trkdata[Trk].zmd++ = 0xEC;
				zmd_ = trkdata[Trk].zmd;
				trkdata[Trk].zmd += 2;
				zms = zms_ - 1;
				do {
					zms = getnum2(++zms,&tmpDWORD,&err);
					if (err >= 0) {
						*trkdata[Trk].zmd++ = tmpDWORD;
						bytes++;
						zms = skipSpcCr(zms);
					} else {
						break;
					}
				} while(*zms == ',');
				putWord(zmd_, bytes);
			}
			break;
		case 'w':	case 'W':				/* @w */
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				UWORD step;
				int err;
				ld = ld_;
				zms = getStep(zms_, &step, trkinf[Trk].Step, &err,cominf);
/*
				if (step > 254) {
					zmserror("@w's parameter(ticks) is out of range(1 - 254).",linebuf_,zms_,0,1);
				}
*/
				if (step < 255) {
					*trkdata[Trk].zmd++ = 0xD0;
					*trkdata[Trk].zmd++ = step;
					zms = skipSpcCr(zms);
					if (*zms == '&') {			/* @w with TIE */
						zms++;
						*trkdata[Trk].zmd++ = 0xFF;
					} else {
						*trkdata[Trk].zmd++ = 0x00;
					}
				} else {
					*trkdata[Trk].zmd++ = 0xFE;
					*trkdata[Trk].zmd++ = 0xD0;
					putWord(trkdata[Trk].zmd, step);
					zms = skipSpcCr(zms);
					if (*zms == '&') {			/* @w with TIE */
						zms++;
						putWord(trkdata[Trk].zmd + 2, 0xFFFF);
					} else {
						putWord(trkdata[Trk].zmd + 2, 0x0000);
					}
					trkdata[Trk].zmd += 4;
				}
				incrementStepCounters(&trkinf[Trk], step);
#ifdef AAA
				if  (!trkinf[Trk].renpnotes) {
					trkinf[Trk].total += step;
					if (trkinf[Trk].s->prev) {
						trkinf[Trk].s->step += step;
					}
				}
#endif
			}
			break;
		case 'l':	case 'L':				/* @l */
			zms = getnum2(zms_, &tmpDWORD, &err);
			if (err < 0) {
				zmserror("@l can't omit its parameter.",linebuf_,zms_,0,1);
			}
			for (trk = 0; target[trk] >= 0; trk++) {
				trkinf[target[trk]].Step = tmpDWORD;
			}
			break;
		case 'n':	case 'N':						/* @n : channel change */
			zms = getnum2(zms, &tmpDWORD, &err);
			if (err < 0) {
				zmserror("@n can't omit its parameter.",linebuf_,zms_,0,1);
			}
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				*trkdata[Trk].zmd++ = 0xA3;
				*trkdata[Trk].zmd++ = trkdata[Trk].ch = tmpDWORD - 1;
			}
			break;
		case 'd':	case 'D':						/* @d */
			zms = getnum2(zms, &tmpDWORD, &err);
			if (err < 0) {
				tmpDWORD = 0;
			}
			for (trk = 0; target[trk] >= 0; trk++) {
				*trkdata[target[trk]].zmd++ = 0xA7;
				*trkdata[target[trk]].zmd++ = (tmpDWORD)? 127 : 0;
			}
			break;
		case 'g':	case 'G':						/* @g */
			zms = getnum2(zms, &tmpDWORD, &err);
			if (err < 0) {
				zmserror("@g can't omit its parameter.",linebuf_,zms_,0,1);
			}
			for (trk = 0; target[trk] >= 0; trk++) {
				*trkdata[target[trk]].zmd++ = 0xA8;
				*trkdata[target[trk]].zmd++ = tmpDWORD;
			}
			break;
		case 'j':	case 'J':				/* @j */
			zms = getnum2(zms, &tmpDWORD, &err);
			if (err < 0) {
				tmpDWORD = 0;
			}
			for (trk = 0; target[trk] >= 0; trk++) {
				*trkdata[target[trk]].zmd++ = 0xC5;
				*trkdata[target[trk]].zmd++ = tmpDWORD;
			}
			break;
		case 'r':	case 'R':				/* @r */
			zms = getnum2(zms, &tmpDWORD, &err);
			if (err < 0) {
				tmpDWORD = 0;
			} else if (tmpDWORD) {
				tmpDWORD = 0xFF;
			}
			for (trk = 0; target[trk] >= 0; trk++) {
				*trkdata[target[trk]].zmd++ = 0xAC;
				*trkdata[target[trk]].zmd++ = tmpDWORD;
			}
			break;
		case 'v':	case 'V':				/* @v */
			zms_ = zms;
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				BYTE rel = 0;
				DWORD vol;	/* ,v = trkinf[target[trk]].vol; */
				int err;
				ld = ld_;
				zms = skipSpcCr(zms_);
				if (*zms == '+') {
					rel = 1;
				} else if (*zms == '-') {
					rel = -1;
				}
				zms = getnum2(zms, &vol, &err);
				if (err < 0) {				/* only '@v' */
					zmserror("@v must be followed to its parameter.",linebuf_,zms_,0,1);
				} else {
					if (rel) {
						if (vol > 0) {
							*trkdata[Trk].zmd++ = 0xAA;
							*trkdata[Trk].zmd++ = vol;
/* (BEGIN FM/ADPCMsupport by Mamiya */
							if (checkInternalDevice(trkdata,Trk) & 1) {
								DWORD v = trkinf[Trk].velou.var[0];
								v += vol ;
								v = (v < 0) ? 0 : ((v > 127) ? 127 : v) ;
								trkinf[Trk].velou.var[0] = v ;
							}
/* FM/ADPCMsupport by Mamiya END) */
						} else {
							*trkdata[Trk].zmd++ = 0xAB;
							*trkdata[Trk].zmd++ = -vol;
/* (BEGIN FM/ADPCMsupport by Mamiya */
							if (checkInternalDevice(trkdata,Trk) & 1) {
								DWORD v = trkinf[Trk].velou.var[0];
								v += vol ;
								v = (v < 0) ? 0 : ((v > 127) ? 127 : v) ;
								trkinf[Trk].velou.var[0] = v ;
							}
/* FM/ADPCMsupport by Mamiya END) */
						}
						zmserror("@v is used relatively.",linebuf_,zms_,4,1);
					} else {
						if (vol < 0 || vol > 127) {
							zmserror("volume parameter is out of range.",linebuf_,zms_,0,1);
						} else {
/* (BEGIN FM/ADPCMsupport by Mamiya */
							if (checkInternalDevice(trkdata,Trk) & 1) {
								DWORD v = vol;
								trkinf[Trk].velou.var[0] = vol;
								v *= cominf->fmvol;
								*trkdata[Trk].zmd++ = 0xB6;
								*trkdata[Trk].zmd++ = 127 - v / 255;
							} else {
								*trkdata[Trk].zmd++ = 0xB6;
								*trkdata[Trk].zmd++ = 127 - vol;
							}
/* FM/ADPCMsupport by Mamiya END) */
						}
					}
					/* trkinf[Trk].vol = v; */
				}
			}
			break;
		case 'u':	case 'U':				/* @u */
			zms = setMMLatU(zms,trkdata,trkinf,target);
			break;
		case 'p':	case 'P':				/* @p */
			zms_ = zms;
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				BYTE rel = 0;
				DWORD vol;	/* ,v = trkinf[Trk].vol; */
				int err;
				ld = ld_;
				zms = skipSpcCr(zms_);
				if (*zms == '+') {
					rel = 1;
				} else if (*zms == '-') {
					rel = -1;
				}
				zms = getnum2(zms, &vol, &err);
				if (err < 0) {				/* only '@p' */
					zmserror("@p must be followed to its parameter.",linebuf_,zms_,0,1);
				} else {
					if (rel) {
						if (vol > 0) {
							*trkdata[Trk].zmd++ = 0xC8;
							*trkdata[Trk].zmd++ = vol;
						} else {
							*trkdata[Trk].zmd++ = 0xC9;
							*trkdata[Trk].zmd++ = -vol;
						}
					} else {
						if (vol < 0 || vol > 127) {
							zmserror("panpot parameter is out of range(0-127).",linebuf_,zms_,0,1);
						} else {
							*trkdata[Trk].zmd++ = 0xB4;
							*trkdata[Trk].zmd++ = vol;
						}
					}
					/* trkinf[Trk].vol = v; */
				}
			}
			break;
		case 'q':	case 'Q':				/* @q */
			zms = makeZmdQuantize(zms, 0, target, trkinf);
			break;
		case 'i':	case 'I':				/* @i */
			zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
									0xEB, 0xFF, 3, 1, 0,
									"@i must have 3 parameters(maker id,device id,model id).",
									"@i can't omit 3 parameters(maker id,device id,model id).",
									"@i can't use relational parameters.");
			break;
		case 'e':	case 'E':				/* @e */
			zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
									0xED, 0xFF, 3, 1, 1,
									"@e: too many parameters.",
									"@e can't use relational parameters.",
									"");
			break;
		case 'c':	case 'C':				/* @c */
			zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
									0x9A, 0xFF, 3, 1, 1,
									"@c: too many parameters.",
									"@c can't use relational parameters.",
									"");
			break;
		case 'h':	case 'H':				/* @h */
			zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
									0xE8, 0xFF, 2, 2, 1,
									"@h: too many parameters.",
									"@h can't use relational parameters.",
									"");
			break;
		case 's':	case 'S':				/* @s */
			zms = makeZmdManyParas(zms,trkdata,target,linebuf_,
									0xD6, 0x00, 2, 2, 1,
									"@s: too many parameters.",
									"@s can't use relational parameters.",
									"");
			break;
		case 'y':	case 'Y':				/* @y */
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				UWORD bytes = 0;
				ld = ld_;
				*trkdata[Trk].zmd++ = 0xD2;
				zms = zms_ - 1;
				do {
					zms = getnum2(++zms,&tmpDWORD,&err);
					if (err >= 0) {
						if (tmpDWORD >= 0x80) {
							*trkdata[Trk].zmd++ = tmpDWORD & 0x7F;
							*trkdata[Trk].zmd++ = tmpDWORD >> 7;
							bytes += 2;
						} else {
							*trkdata[Trk].zmd++ = tmpDWORD;
							bytes++;
						}
						zms = skipSpcCr(zms);
					} else {
						break;
					}
				} while(*zms == ',');
				if (bytes < 3) {
					zmserror("NRPN must have address(2 bytes) and data(1 or 2 bytes.)",linebuf,zms,0,1);
				} else {
					int i;
					for (i = bytes; i < 4; i++) {
						*trkdata[Trk].zmd++ = 0xFF;
					}
				}
			}
			break;
		case 'z':	case 'Z':				/* @z */	/* thanks to Mamiya */
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				int i = 0 ;
				DWORD z = trkinf[Trk].velou.var[0];
				ld = ld_;
				zms = getnum2(zms_, &tmpDWORD, &err);
				/*zms = skipSpc(zms);*/
				if (err < 0 && *zms != ',') {
					*trkdata[Trk].zmd++ = 0xBE;
					*trkdata[Trk].zmd++ = 0x00;
					continue;
				}
				*trkdata[Trk].zmd++ = 0xE3;
				ld = ld_;
				zms = zms_ - 1 ;
				do {
					int r = 0 ;
					zms = skipSpcCr(zms + 1);
					if (*zms == '+' || *zms == '-') r = 1 ;
					zms = getnum2(zms, &tmpDWORD, &err);
					if (err < 0) {
						*trkdata[Trk].zmd++ = -1 ;
					} else if (r) {
						z += tmpDWORD ;
						z = (z < 0) ? z : ((z > 127) ? 127 : z) ;
						*trkdata[Trk].zmd++ = z;
					} else {
						*trkdata[Trk].zmd++ = z = tmpDWORD;
					}
					/*zms = skipSpc(zms);*/
				} while (++i < 8 && *zms == ',') ;
				while (i++ < 8) *trkdata[Trk].zmd++ = -1;
				if (*zms == ',') {
					zmserror("@z: too many ','.",linebuf_,zms,2,1);
					zms++ ;
				}
			}
			break;
/* (BEGIN FM/ADPCMsupport by Mamiya */
		case 't':	case 'T':				/* @t */
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				BYTE rel = 0;
				ld = ld_;
				zms = skipSpcCr(zms_);
				if (*zms == '+' || *zms == '-') rel = 1;
				zms = getnum2(zms, &tmpDWORD, &err);
				if (err < 0) {
					zmserror("@t must be followed to its parameter.",linebuf_,zms_,0,1);
				} else {
					if (!rel) {
						*trkdata[Trk].zmd++ = 0x90;
					} else if (tmpDWORD < 0) {
						*trkdata[Trk].zmd++ = 0x93;
						tmpDWORD = -tmpDWORD;
					} else {
						*trkdata[Trk].zmd++ = 0x92;
					}
					putWord(trkdata[Trk].zmd, tmpDWORD);
					trkdata[Trk].zmd += 2;
					zmserror("@t will be ignored by many drivers.",linebuf_,zms_ - 1,3,1);
				}
			}
			break;
		case 'o':	case 'O':				/* @o */
			zms = getnum2(zms, &tmpDWORD, &err);
			for (trk = 0; target[trk] >= 0; trk++) {
				if (err < 0) {
					*trkdata[target[trk]].zmd++ = 0x82;
				} else {
					*trkdata[target[trk]].zmd++ = 0xA5;
					*trkdata[target[trk]].zmd++ = 128 + tmpDWORD ;
				}
			}
			break;
		case 'f':	case 'F':				/* @f */
			zms = getnum2(zms, &tmpDWORD, &err);
			if (err < 0) {
				zmserror("@f can't omit its parameter.",linebuf_,zms_,0,1);
			}
			for (trk = 0; target[trk] >= 0; trk++) {
				*trkdata[target[trk]].zmd++ = 0xA9;
				*trkdata[target[trk]].zmd++ = tmpDWORD ;
			}
			break;
/* FM/ADPCMsupport by Mamiya END) */
		default:
			zms_ = --zms;
			/* ld_ = ld; */
			linebuf_ = linebuf;
			zms = getnum2(zms,&tmpDWORD,&err);
			if (!err) {					/* @NUM means PROGRAM CHANGE */
				int trk;
				for (trk = 0; target[trk] >= 0; trk++) {
					*trkdata[target[trk]].zmd++ = 0xA0;
					*trkdata[target[trk]].zmd++ = tmpDWORD;
				}
				break;
			} else {
				zmserror("`@'(program set) must be followed to its parameter.",linebuf_,zms_,0,1);
			}
			break;
	}
	return zms;
}
UBYTE *makeZmdLoop1(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf)
{																/* |: |n | */
	int trk;
	UBYTE *zms_ = zms;
	LINEDATA *ld_ = ld;
	char *linebuf_ = linebuf;
	switch (*zms++) {
		case '|':
			if (*zms == ':') {								/* |: */
				DWORD looptime;
				int err;
				zms = getnum2(++zms,&looptime,&err);
				ld_ = ld;
				if (err < 0) {
					looptime = 2;
				} else if (looptime <= 0) {
					zmserror("illegal looptime.",linebuf_,zms_,0,1);
				}
				for (trk = 0; target[trk] >= 0; trk++) {
					int Trk = target[trk];
					do {
						ld  = ld_;
						recoverSpecialVelocity(trkinf, trkdata, Trk);
						if (trkinf[Trk].l->loopmode < 0) {	/* |n .. :| .. |: */
														/* loopmode<0 means "|n ..:| parsed" */
														/* new loop begins */
							trkinf[Trk].l = trkinf[Trk].l->prev;
							efree(trkinf[Trk].l->next, "trkinf[Trk].l->next");
							trkinf[Trk].l->next = NULL;
						}
						*trkdata[Trk].zmd++ = 0xC1;
						trkinf[Trk].l->next       = (LOOPDATA*)emalloc(sizeof(LOOPDATA) * 1, "trkinf[Trk].l->next");
						trkinf[Trk].l->next->prev = trkinf[Trk].l;
						trkinf[Trk].l             = trkinf[Trk].l->next;
						trkinf[Trk].l->next       = (LOOPDATA*)NULL;
						trkinf[Trk].l->loopstart  = trkdata[Trk].zmd - trkdata[Trk].zmdbuf;
						trkinf[Trk].l->loopskip   = 0;	/* (UBYTE*)NULL; */
						*trkdata[Trk].zmd++ = 0xCF;
						*trkdata[Trk].zmd++ = trkinf[Trk].l->looptime = looptime;
						trkinf[Trk].l->looptime2 = 0;
						trkinf[Trk].l->loopmode   = 0;
						trkinf[Trk].l->totalstart = trkinf[Trk].total;
						trkinf[Trk].l->totalmode  = -1;
						/* totalmode: -1= no |,|n  0 = | 1 = |n */
					} while (trkinf[Trk].back_repeat && (Trk = trkinf[Trk].cominf->backtrk[Trk]) != -1);
				}
			} else {										/* |... */
				DWORD tmpDWORD;
				int err;
				for (trk = 0; target[trk] >= 0; trk++) {
					int Trk = target[trk];
					do {
						if (trkinf[Trk].l->totalmode == -1) {
							trkinf[Trk].total +=
								(trkinf[Trk].total - trkinf[Trk].l->totalstart) *
								(trkinf[Trk].l->looptime - 1);
						}
						trkinf[Trk].l->totalstart = trkinf[Trk].total;
					} while (trkinf[Trk].back_repeat && (Trk = trkinf[Trk].cominf->backtrk[Trk]) != -1);
				}
				zms = getnum2(zms,&tmpDWORD,&err);
				ld = ld_;
				if (!err) {									/* |n */
					if (tmpDWORD <= 0) {
						zmserror("illegal looptime.",linebuf_,zms_,0,1);
					}
					for (trk = 0; target[trk] >= 0; trk++) {
						int Trk = target[trk];
						do {
							ld = ld_;
							if (tmpDWORD > trkinf[Trk].l->looptime) {
								zmserror("n is too large in |n.",linebuf_,zms_,0,1);
							}
							*trkdata[Trk].zmd++ = 0xC3;
							*trkdata[Trk].zmd++ = tmpDWORD;
							if (trkinf[Trk].l->loopskip) {
								zmserror("illegal |n.",linebuf_,zms_,0,1);
							} else {
								trkinf[Trk].l->loopskip   = trkdata[Trk].zmd - trkdata[Trk].zmdbuf;
								putWord(trkdata[Trk].zmd, 0);
								trkdata[Trk].zmd += 2;
								trkinf[Trk].l->loopmode = tmpDWORD;
							}
							trkinf[Trk].l->totalmode = 1;
						} while (trkinf[Trk].back_repeat && (Trk = trkinf[Trk].cominf->backtrk[Trk]) != -1);
					}
				} else if (err < 0) {						/* |  */
					for (trk = 0; target[trk] >= 0; trk++) {
						int Trk = target[trk];
						do {
							ld = ld_;
							if (trkinf[Trk].l->prev == NULL ||
								(trkinf[Trk].l->prev->prev == NULL && trkinf[Trk].l->loopmode < 0) ) {
								zmserror("illegal |.",linebuf_,zms_,3,1);
								/* BUG: ZMUSIC.X output noneffective `|'command. */
								if (getSwitchVal('z') > 1) {
									*trkdata[Trk].zmd++ = 0xC4;
									putWord(trkdata[Trk].zmd, 0);
									trkdata[Trk].zmd += 2;
								}
							} else {
								*trkdata[Trk].zmd++ = 0xC4;
								if (trkinf[Trk].l->loopskip) {
									zmserror("illegal |.",linebuf_,zms_,0,1);
								} else {
									trkinf[Trk].l->loopskip   = trkdata[Trk].zmd - trkdata[Trk].zmdbuf;
									putWord(trkdata[Trk].zmd, 0);
									trkdata[Trk].zmd += 2;
									trkinf[Trk].l->loopmode = 0;
								}
							}
							trkinf[Trk].l->totalmode = 0;
						} while (trkinf[Trk].back_repeat && (Trk = trkinf[Trk].cominf->backtrk[Trk]) != -1);
					}
				}
			}
			break;
		case ':':
			if (*zms++ == '|') {						/* :| */
				for (trk = 0; target[trk] >= 0; trk++) {
					int Trk = target[trk];
					do {
						DWORD tmpDWORD;
						int i, level = 0;
						/* UBYTE *ls; */
						DWORD ls;
						switch (trkinf[Trk].l->totalmode) {
							case -1:	/* w/o | |n */
								trkinf[Trk].total +=
									(trkinf[Trk].total - trkinf[Trk].l->totalstart) *
									(trkinf[Trk].l->looptime - 1);
								break;
							case 0:		/* w/ | */
								trkinf[Trk].total +=
									(trkinf[Trk].total - trkinf[Trk].l->totalstart) *
									(trkinf[Trk].l->looptime - 2);
								break;
							case 1:		/* w/ |n */
								/* no need to add any values */
								break;
						}
						ld = ld_;
						if (trkinf[Trk].l->prev == NULL ||
							(trkinf[Trk].l->prev->prev == NULL && trkinf[Trk].l->loopmode < 0) ) {
							zmserror("too many :| .",linebuf_,zms_,0,1);
						}
						ls = (trkinf[Trk].l->loopmode < 0)?		/* |n .. :| :| ? */
										trkinf[Trk].l->prev->loopstart :
										trkinf[Trk].l->loopstart;
						*trkdata[Trk].zmd++ = 0xC2;
						trkdata[Trk].zmd += 2;
						/* tmpDWORD = trkdata[Trk].zmd - ls; */	/* trkinf[Trk].l->loopstart; */
						tmpDWORD = trkdata[Trk].zmd - trkdata[Trk].zmdbuf - ls;
																/* trkinf[Trk].l->loopstart; */
						/* trkdata[Trk].zmd -= 2; */
						putWord(trkdata[Trk].zmd - 2, tmpDWORD);
						/* trkdata[Trk].zmd += 2; */
						if (trkinf[Trk].l->loopskip) {	/* exist | or |n ? */
							putWord(trkdata[Trk].zmdbuf + trkinf[Trk].l->loopskip,
									(trkdata[Trk].zmd - trkdata[Trk].zmdbuf) - trkinf[Trk].l->loopskip - 2);
							trkinf[Trk].l->loopskip = 0;
							if (trkinf[Trk].l->loopmode) {	/* |n? */
								level = 0;					/* |n ... :| */
/* add v1.21 */					if (++trkinf[Trk].l->looptime2 == trkinf[Trk].l->looptime) {
									level = 1;
								}
							} else {						/* | ... :| */
								level = 1;
							}
						} else if (trkinf[Trk].l->loopmode == 0) {		/* normal loop :| */
							level = 1;
						} else if (trkinf[Trk].l->loopmode < 0) {		/* |n .. :| .. :| */
							level = 2;
						}
						for (i = 0; i < level; i++) {
							trkinf[Trk].l = trkinf[Trk].l->prev;
							efree(trkinf[Trk].l->next, "trkinf[Trk].l->next");
							trkinf[Trk].l->next = NULL;
						}
											/* loop is end if it's not | or |n after |n... :| */
						if (level == 0) {									/* |n .. :|  */
							trkinf[Trk].l->loopmode = -trkinf[Trk].l->loopmode;
						} else {									/* lev == 1: normal :| */
							/* trkinf[Trk].l->loopmode = 0; */			/* lev == 2: |n ... :| .. :| */
						}
					} while (trkinf[Trk].back_repeat && (Trk = trkinf[Trk].cominf->backtrk[Trk]) != -1);
				}
			} else {
				zmserror("SYNTAX ERROR",linebuf_,zms_,0,1);
			}
			break;
	}
	return zms;
}
UBYTE *makeZmdCommand(UBYTE *zms,TRKCHINF *trkdata, BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf)
{																/* |: |n | */
	int trk,i;
	UBYTE *zms_ = zms;
	LINEDATA *ld_ = ld;
	const char *comtbl1[] =
	{
		"d.c.]","segno]","$]","d.s.]","coda]","tocoda]","*]",
		"fine]","^]","do]","loop]","!]","@]","end]","k.sign",
		"velocity.","back",
		NULL
	};
	for (i = 0;;i++) {
		if (!comtbl1[i]) {
			i = -1;
			break;
		} else if (!stricmp2(zms,comtbl1[i])) {
			break;
		}
	}
	switch (i) {
		case 0:												/* [d.c.] */
			zms += 5;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x03;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 1:												/* [segno] */
			zms += 6 - 2;
		case 2:												/* [$] */
			zms += 2;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x04;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 3:												/* [d.s.] */
			zms += 5;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x05;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 4:												/* [coda] */
			zms += 5;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x06;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 5:												/* [tocoda] */
			zms += 7 - 2;
		case 6:												/* [*] */
			zms += 2;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x07;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 7:												/* [fine] */
			zms += 5 - 2;
		case 8:												/* [^] */
			zms += 2;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x08;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 9:												/* [do] */
			zms += 3;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					recoverSpecialVelocity(trkinf, trkdata, Trk);
					trkinf[Trk].d->looptime = 1;
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x09;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 10:											/* [loop] */
			zms += 5;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					trkinf[Trk].d->looptime = 0;
					*trkdata[Trk].zmd++ = 0xC0;
					*trkdata[Trk].zmd++ = 0x0A;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 11:											/* [!] */
			zms += 2;
			if (cominf->debug) {
				for (trk = 0; target[trk] >= 0; trk++) {
					int Trk = target[trk];
					do {
						*trkdata[Trk].zmd++ = 0xC0;
						*trkdata[Trk].zmd++ = 0x0B;
					} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
				}
			} else {
				zmserror("debug command [!] is still existing.",linebuf,zms_,3,1);
			}
			break;
		case 12:											/* [@] */
			zms += 2;
			if (cominf->debug) {
				for (trk = 0; target[trk] >= 0; trk++) {
					int Trk = target[trk];
					do {
						*trkdata[Trk].zmd++ = 0xC0;
						*trkdata[Trk].zmd++ = 0x0C;
					} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
				}
			} else {
				zmserror("debug command [@] is still existing.",linebuf,zms_,2,1);
			}
			break;
		case 13:											/* [end] */
			zms += 4;
			for (trk = 0; target[trk] >= 0; trk++) {
				int Trk = target[trk];
				do {
					*trkdata[Trk].zmd++ = 0xFF;
				} while (trkinf[Trk].back_repeat && (Trk = cominf->backtrk[Trk]) != -1);
			}
			break;
		case 14:											/* [k.sign */
			zms += 6;
			zms_ = zms;
			for (trk = 0; target[trk] >= 0; trk++) {
				int i,kp = 0,kpflg = 0;
				zms = skipSpcCr(zms_);
				ld = ld_;
				for (i = 0; i < 12; i++) {
					trkinf[target[trk]].ksign[i] = 0;
				}
				while (*zms != ']') {
					int note;
					const BYTE tonetbl[7] = { 0, 2, 4, 5, 7, 9, 11 };
					zms = skipSpcCr(zms);
					switch(*zms++) {
						case '#':
						case '+':
							if (kpflg) {
								kp = 1;
								kpflg = 0;
							} else {
								kp++;
							}
							break;
						case '-':
							if (kpflg) {
								kp = -1;
								kpflg = 0;
							} else {
								kp--;
							}
							break;
						case 'a':	case 'A':	case 'b':	case 'B':
						case 'c':	case 'C':	case 'd':	case 'D':
						case 'e':	case 'E':	case 'f':	case 'F':
						case 'g':	case 'G':
							kpflg = 1;
							note = (*(zms  - 1) | 0x20) - 'a';
							note -= 2;
							if (note < 0) {
								note += 7;
							}
							trkinf[target[trk]].ksign[tonetbl[note]] = kp;
							break;
						case ',':
							break;
						default:
							zmserror("ksign error.",linebuf,zms,0,1);
							break;
					}
					zms = skipSpcCr(zms);
				}
				zms++;			/* skip ']' */
			}
			break;
		case 15:											/* [velocity. */
			zms += 9;
			zms_ = zms;
			for (trk = 0; target[trk] >= 0; trk++) {
				ld = ld_;
				zms = skipSpc(zms_);
				if (!stricmp2(zms,"revise")) {				/* [velocity.revise */
					zms = makeZmdRandVelo(zms + 6, target[trk], trkinf);
				}
			}
			zmserror("[velocity.revise] can use only for zmc2.",linebuf,zms_,4,1);
			break;
		case 16:											/* [back */
			zms += 4;
			zms_ = zms;
			for (trk = 0; target[trk] >= 0; trk++) {
				const int Trk = target[trk];
				DWORD	backtrk;
				zms = zms_;
				ld = ld_;
				if (!stricmp2(zms,".repeat")) {	/* [back.repeat  */
					int repeat_sw = 1;
					zms = skipSpc(zms + 7);
					if (!stricmp2(zms,"on")) {
						zms += 2;
					} else if (!stricmp2(zms,"off")) {
						zms += 3;
						repeat_sw = 0;
					} else if (*zms == '1') {
						zms++;
					} else if (*zms == '0') {
						zms++;
						repeat_sw = 0;
					}
					trkinf[Trk].back_repeat = repeat_sw;
				}
				if (cominf->backtrk[Trk] < 0) {		/* 1st time to use [back] in this trk */
					int i, trks;
					for (i = 1; i < cominf->maxtrk; i++) {
						if (trkdata[i].ch < 0) break;
					}
					if (i >= cominf->maxtrk) {
						zmserror("Sorry too many [back]. (however it will be modified soon)",linebuf,zms,0,1);
					}
					cominf->backtrk[Trk] = backtrk = i;
					cominf->fromtrk[i] = Trk;
					cominf->backtrk[i] = -1;
					trkdata[i].zmdbuf  = (UBYTE*)emalloc(sizeof(UBYTE) * 8192, "trkdatai[i].zmdbuf");
					trkdata[i].bufsize = 8192;
					trkdata[i].zmd     = trkdata[i].zmdbuf;
					trkdata[i].nowsize = 0;
					for (trks = 0; trks < cominf->maxtrk; trks++) {
						if (cominf->trkassign[trks] < 0) {
							cominf->trkassign[trks] = backtrk;
							cominf->trkassign[trks + 1] = -1;
							break;
						}
					}
				} else {
					backtrk = cominf->backtrk[Trk];
					if (trkinf[backtrk].total > trkinf[Trk].total) {
						zmserror("Previous [back] sequence has not finished yet.",linebuf,zms,2,1);
					}
				}
				copyTrkInf(&trkinf[backtrk], &trkinf[Trk]);		/* copy current track setting */
				trkdata[backtrk].ch  = trkdata[Trk].ch;
				trkdata[backtrk].ch_ = trkdata[Trk].ch_;
				trkdata[backtrk].backinuse = -1;
				zms = skipSpc(zms);
				if (*zms == ']') {
					zms++;
					continue;
				}
				*trkdata[backtrk].zmd++ = 0x83;	/* receiving sync. signal */
				for (i = 0; i < cominf->maxtrk; i++) {
					if (cominf->trkassign[i] == backtrk) {
						*trkdata[Trk].zmd++ = 0xAF;
						*trkdata[Trk].zmd++ = i;	/* - 1; */
						break;
					}
				}
				if (i >= cominf->maxtrk) {
					zmserror("illegal track number.",linebuf,zms,0,1);
				}
#ifdef AAa
				*trkdata[Trk].zmd++ = 0xAF;		/* sending synchronous signal */
				*trkdata[Trk].zmd++ = backtrk - 1;
#endif
				trkdata[Trk].backinuse = backtrk;
				target[trk] = backtrk;
				zmserror("[back] can use only for zmc2.",linebuf,zms,4,1);
			}
	}
	return zms;
}
UBYTE *makeZmdEigDepthSub(UBYTE *zms,
						VELOETCVAR *vv, BYTE *pos,BYTE *num,BYTE supplementmode)
{
	int i, paras;
	VELOETCVAR v[17];
	const BYTE lastvpos = *num;
	*pos = 0;
	zms = getpara(zms, v, &paras);
	if (v[0].relflg[0] == 2) {			/* omit 1st parameter */
		if (paras) {				/* continues... */
			vv[0].var[0]    = (supplementmode)? vv[lastvpos].var[0] : 0;
		} else {					/* that's all */
			*pos = *num = 0;
		}
	} else {						/* 1st parameter is there */
		WORD velo = v[0].var[0];
#ifdef A
		if (v[0].relflg[0] == 1 && supplementmode) {		/* relative */
			velo += vv[lastvpos].var[0];
		}
#endif
/*
printf("[V=%d]",velo);
*/
		vv[0].var[0] = velo;
	}
	vv[0].relflg[0] = v[0].relflg[0];
	for (i = 1; i < paras; i++) {	/* next... */
		if (v[i].relflg[0] == 2) {		/* omit Nth parameter */
			vv[i].var[0] = (supplementmode)? vv[i - 1].var[0] : 0;
		} else {
			WORD velo = v[i].var[0];
			if (v[i].relflg[0] == 1 && supplementmode) {
				velo += vv[i - 1].var[0];
			}
/*
printf("[V=%d]",velo);
*/
			vv[i].var[0] = velo;
		}
		vv[i].relflg[0] = v[i].relflg[0];
	}
	*num = paras;
	return zms;
}
UBYTE *makeZmdVeloSeq(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf)
{
	int trk;
	char *zms_ = zms;
	LINEDATA *ld_ = ld;
	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		int i, paras;
		VELOETCVAR *v;
		const BYTE lastvpos = trkinf[Trk].veloznum - 1;
		const VELOETCVAR lastv = (lastvpos == -1) ? trkinf[Trk].velou : trkinf[Trk].velocity[lastvpos];
		ld = ld_;
		zms = getvpara(zms_, &v, &paras);
		trkinf[Trk].velozpos = 0;
		trkinf[Trk].veloseqsw = 1;
		if (paras) {
			trkinf[Trk].velocity = erealloc(trkinf[Trk].velocity, sizeof(VELOETCVAR) * paras, "trkinf[Trk].velocity");
			trkinf[Trk].veloznum = paras;
			for (i = 0; i < paras; i++) {
				if (v[i].relflg[0] == 2) {	/* omit the 1st/Xth value */
					if (i > 0) {
						trkinf[Trk].velocity[i] = trkinf[Trk].velocity[i - 1];
					} else {
						trkinf[Trk].velocity[i] = lastv;
					}
				} else {						/* 1st/Xth value is there */
					WORD velo = v[i].var[0];
					if (v[i].relflg[0] == 1) {
						if (i > 0) {
							velo += trkinf[Trk].velocity[i - 1].var[0];
						} else {
							velo += lastv.var[0];
						}
						if (velo > 127) {
							velo = 127;
						} else if (velo < 0) {
							velo = 0;
						}
					}
					trkinf[Trk].velocity[i].var[0] = velo;
					trkinf[Trk].velocity[i].var[1] = v[i].var[1];
				}
			}
			if (paras == 1) {
				int velo    = trkinf[Trk].velocity[0].var[0];
				const int r = trkinf[Trk].velocity[0].var[1];
				trkinf[Trk].velou.var[0] = velo;
				trkinf[Trk].velou.var[1] = r;
				if (r) {
					velo += rand2(r);
				}
				if (velo > 127) {
					velo = 127;
				} else if (velo < 0) {
					velo = 0;
				}
				*trkdata[Trk].zmd++ = 0xB9;
				*trkdata[Trk].zmd++ = velo;
			}
		}
		setVelocitySequenceMode(trkinf,Trk,(paras > 1));
		efree(v, "v");
	}
	return zms;
}
UBYTE *makeZmdQuantize(UBYTE *zms, int mode, const BYTE target[],
						TRKINF *trkinf)
{
	int trk;
	char *zms_ = zms;
	LINEDATA *ld_ = ld;
	char *linebuf_ = linebuf;
	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		int i, paras;
		VELOETCVAR *v;
		const BYTE lastvpos = trkinf[Trk].quantizenum - 1;
		const VELOETCVAR lastv = (lastvpos == -1) ? trkinf[Trk].quantize[0] : trkinf[Trk].quantize[lastvpos];
		ld = ld_;
		zms = getvpara(zms_, &v, &paras);
		trkinf[Trk].quantizepos = 0;
		if (paras == 0) paras = 1;
		trkinf[Trk].quantize = erealloc(trkinf[Trk].quantize, sizeof(VELOETCVAR) * paras, "trkinf[Trk].quantize");
		trkinf[Trk].quantizenum = paras;
		for (i = 0; i < paras; i++) {	/* next.. */
			if (v[i].relflg[0] == 2) {	/* omit Nth parameter */
				if (i == 0) {
					trkinf[Trk].quantize[i] = lastv;
				} else {
					trkinf[Trk].quantize[i] = trkinf[Trk].quantize[i - 1];
				}
			} else {
				trkinf[Trk].quantize[i] = v[i];
				if (mode == 0) {					/* @q... */
					trkinf[Trk].quantize[i].relflg[0] = 1;
				} else {							/* q... */
					if (trkinf[Trk].quantize[i].var[0] < 0) {
						trkinf[Trk].quantize[i].var[0] = -trkinf[Trk].quantize[i].var[0];
						switch (mode) {
							case 1:					/* zmc2old -v1.16 */
								trkinf[Trk].quantize[i].relflg[0] = 3;
								break;
							case 2:					/* zmc2 v1.17 */
								break;
							case 3:					/* V3 compatible */
								if (trkinf[Trk].quantize[i].relflg[0] == 3) {
									trkinf[Trk].quantize[i].relflg[0] = 1;
								} else {
									trkinf[Trk].quantize[i].relflg[0] = 0;
									trkinf[Trk].quantize[i].var[0] += 8;
								}
								break;
						}
					}
				}
			}
		}
		if (paras > 1) {
			zmserror("quantize sequence can use only for zmc2.",linebuf_,zms_,4,1);
		}
		efree(v, "v");
	}
	return zms;
}
UBYTE *makeZmdManyParas(UBYTE *zms,TRKCHINF *trkdata,const BYTE target[],
						char *linebuf_,
						UBYTE com, UBYTE omitcode,BYTE maxparas,
						BYTE parabytes,BYTE omitflg,
						char *errmes1, char *errmes2,char *errmes3)
{
	VELOETCVAR v[17];
	UBYTE *zms_ = zms;
	int tmpINT;
	zms = getpara(zms,v,&tmpINT);
	if (tmpINT > maxparas || (!omitflg && tmpINT != maxparas)) {
		zmserror(errmes1,linebuf_,zms_,0,1);
	} else {
		int trk;
		for (trk = 0; target[trk] >= 0; trk++) {
			int i;
			const int Trk = target[trk];
			*trkdata[Trk].zmd++ = com;
			for (i = 0; i < tmpINT; i++) {
				if (v[i].relflg[0] == 2) {		/* omit Nth parameter */
					if (omitflg) {
						*trkdata[Trk].zmd++ = omitcode;
						if (parabytes == 2) {
							*trkdata[Trk].zmd++ = omitcode;
						}
					} else {
						zmserror(errmes3,linebuf_,zms_,0,1);
					}
				} else {
					if (v[i].relflg[0] == 1) {	/* relative */
						zmserror(errmes2,linebuf_,zms_,0,1);
					} else {
						if (parabytes == 2) {
							putWord(trkdata[Trk].zmd, v[i].var[0]);
							trkdata[Trk].zmd += 2;
						} else {
							*trkdata[Trk].zmd++ = v[i].var[0];
						}
					}
				}
			}
			for (i = tmpINT; i < maxparas; i++) {
				*trkdata[Trk].zmd++ = omitcode;
				if (parabytes == 2) {
					*trkdata[Trk].zmd++ = omitcode;
				}
			}
		}
	}
	return zms;
}
UBYTE *makeZmdTempo(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[])
{
	UBYTE *zms_ = zms;
	int trk;
	char *linebuf_ = linebuf;
	LINEDATA *ld_ = ld;
	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		int err, rel = 0;
		DWORD vol;
		ld = ld_;
		zms = skipSpcCr(zms_);
		if (*zms == '+') {
			rel = 1;
		} else if (*zms == '-') {
			rel = -1;
		}
		zms = getnum2(zms, &vol, &err);
		if (err < 0) {				/* only '@v' */
			zmserror("tempo must be followed to its parameter.",linebuf_,zms_,0,1);
		} else {
			if (rel) {
				if (vol > 0) {
					*trkdata[Trk].zmd++ = 0x94;
					putWord(trkdata[Trk].zmd, vol);
					trkdata[Trk].zmd += 2;
				} else {
					*trkdata[Trk].zmd++ = 0x95;
					putWord(trkdata[Trk].zmd, -vol);
					trkdata[Trk].zmd += 2;
				}
			} else {
				if (vol < 20 || 300 < vol) {
					zmserror("tempo parameter is out of range(20 - 300).",linebuf_,zms_,0,1);
				} else {
					*trkdata[Trk].zmd++ = 0x91;
					putWord(trkdata[Trk].zmd, vol);
					trkdata[Trk].zmd += 2;
				}
			}
		}
	}
	return zms;
}
UBYTE *makeZmdCChange(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[])
{
	int trk;
	DWORD tmpDWORD;
	UBYTE *zms_ = zms;
	LINEDATA *ld_ = ld;
	for (trk = 0; target[trk] >= 0; trk++) {
		int i;
/* (BEGIN FM/ADPCMsupport by Mamiya */
		if (checkInternalDevice(trkdata,target[trk])) {
			int err ;
			DWORD reg, dat ;
			ld = ld_;
			zms = getnum2(zms_, &reg, &err) ;
			if (err < 0) {
				zmserror("control change must have 2 parameters.",linebuf,zms,0,1);
				continue;
			}
			zms = skipSpcCr(zms);
			if (*zms != ',') {
				zmserror("control change must have 2 parameters.",linebuf,zms,0,1);
				continue;
			}
			zms = getnum2(zms + 1, &dat, &err) ;
			if (err < 0) {
				zmserror("control change must have 2 parameters.",linebuf,zms,0,1);
				continue;
			}
			if (reg < 0x38 && reg == 0x30 + trkdata[target[trk]].ch) {
				*trkdata[target[trk]].zmd++ = 0xD1;
				dat >>= 2;
				putWord(trkdata[target[trk]].zmd, dat);
				dat *= 683;
				dat >>= 6;
				putWord(trkdata[target[trk]].zmd + 2, dat);
				trkdata[target[trk]].zmd += 4;
				continue;
			}
			switch (reg) {
				case 2:
					dat &= 511 ;
					*trkdata[target[trk]].zmd++ = 0x9B;
					putWord(trkdata[target[trk]].zmd, dat);
					trkdata[target[trk]].zmd += 2 ;
					break ;
				case 3:
					*trkdata[target[trk]].zmd++ = 0xB7;
					*trkdata[target[trk]].zmd++ = dat & 3;
					break ;
				case 13:
					*trkdata[target[trk]].zmd++ = 0xA2;
					*trkdata[target[trk]].zmd++ = dat & 7;
					break ;
				case 14:
					*trkdata[target[trk]].zmd++ = 0xB8;
					*trkdata[target[trk]].zmd++ = dat & 1;
					break ;
				case 15:
					if (dat == 0) {
						*trkdata[target[trk]].zmd++ = 0x82;
					} else {
						*trkdata[target[trk]].zmd++ = 0xA5;
						*trkdata[target[trk]].zmd++ = dat;
					}
					break ;
				default:
					*trkdata[target[trk]].zmd++ = 0xB5;
					*trkdata[target[trk]].zmd++ = reg;
					*trkdata[target[trk]].zmd++ = dat;
					break ;
			}
			continue ;
		}
/* FM/ADPCMsupport by Mamiya END) */
		*trkdata[target[trk]].zmd++ = 0xB5;
		zms = zms_ - 1;
		ld = ld_;
		for (i = 0; i < 2; i++) {
			zms = get1AbsPara(++zms,&tmpDWORD,0,127,
					"control change parameter is out of range(0-127).",
					"'y'(control change) must be followed to its parameter.");
			*trkdata[target[trk]].zmd++ = tmpDWORD;
			zms = skipSpcCr(zms);
			if (i != 2 - 1 && *zms != ',') {
				zmserror("control change must have 2 parameters.",linebuf,zms,0,1);
			}
		}
	}
	return zms;
}
UBYTE *makeZmdChord(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
					TRKINF *trkinf,char extmode,COMMONINF *cominf)
{
	int trk;
	UBYTE *zms_ = zms;
	LINEDATA *ld_ = ld;
	UBYTE *linebuf_ = linebuf;
	const char sepchr = (extmode)? '\"' : '\'';
	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		BYTE note[9];
		VELOETCVAR v[9];
		UWORD step_;	/*  = trkinf[Trk].Step; */
		UWORD gate_;	/*  = getGate1(target,trkinf,trk,step_); */
		WORD delay = trkinf[Trk].cdelay;
		int i,notes;
		BYTE *qpos = &(trkinf[Trk].quantizepos);
		/* const BYTE vnum = trkinf[Trk].veloznum; */
		/* const BYTE oct = trkinf[Trk].octave; */
		ld = ld_;
		zms = makePortChord(zms_,Trk,trkinf,cominf,
							sepchr,/*0,*/v,note,&notes,&step_,&gate_,&delay);
		/* trkinf[Trk].octave = oct; */			/* restore octave */
		incrementStepCounters(&trkinf[Trk], step_);
#ifdef AAA
		if (!trkinf[Trk].renpnotes) {
			trkinf[Trk].total += step_;
			if (trkinf[Trk].s->prev) {
				trkinf[Trk].s->step += step_;		/* {{..}} */
			}
		}
#endif
		trkinf[Trk].cdelay = delay;
		if (delay < 0) {								/* reverse chord pattern */
			int i;
			for (i = 0; i < notes / 2; i++) {
				BYTE temp = note[i];
				note[i] = note[notes - i - 1];
				note[notes - i - 1] = temp;
			}
			delay = -delay;
			zmserror("delay under 0 can use only for zmc2.",linebuf_,zms,4,1);
		}
		if (delay) {									/* check delay parameter */
			const DWORD delayall = (notes - 1) * (delay - 1);
			if (delayall > step_) {
				zmserror("chord's delay is too large (for steptime).",linebuf_,zms_,2,1);
			} else if (delayall > gate_) {
				zmserror("chord's delay is too large (for gatetime).",linebuf_,zms_,3,1);
			}
		}
		if (!extmode) {									/* normal chord */
			setVelo(trkdata,Trk,trkinf,cominf,step_);	/* velocity set */
			/* vSeqLoopChk(Trk,trkinf); */				/* del v1.30 */
			*trkdata[Trk].zmd++ = 0xE2;
			putWord(trkdata[Trk].zmd, step_);
			putWord(trkdata[Trk].zmd + 2, gate_);
			if (step_) {								/* { .. } */
				checkRenpu(trkdata,Trk,trkinf,2);
			}
			trkdata[Trk].zmd += 4;
			*trkdata[Trk].zmd++ = delay;				/* delay */
			for (i = 0; i < notes; i++) {
				*trkdata[Trk].zmd++ = note[i];
			}
			for (i = notes; i < 8; i++) {
				*trkdata[Trk].zmd++ = 0xFF;
			}
			if (trkinf[Trk].veloseqsw) {		/* add v1.27 */
				vSeqLoopChk(Trk,trkinf);
			}
		} else {										/* extended chord */
			BYTE relvelo = 0;
			/* relvelo,omitgate,Step */
			for (i = 0; i < notes - 1; i++) {
				UWORD dummystep = 0;
				/* set "velocity sequence" or "special velocity" */
				setVelo0(trkdata,Trk,v[i],&relvelo,trkinf,cominf,step_);
				/* vSeqLoopChk(Trk,trkinf); */		/* velo.seq loop check */
				if (trkinf[Trk].veloseqsw) {	/* add v1.27 */
					vSeqLoopChk(Trk,trkinf);
				}
				/* set tonename with "*0&" */
				zms = setTie2(zms,trkdata,Trk,trkinf,note[i],&dummystep,0xFFFF,relvelo,cominf);
				/* set "@w" */
				if (i < notes - 1 && delay) {
					*trkdata[Trk].zmd++ = 0xD0;
					*trkdata[Trk].zmd++ = delay;		/* 1 <= delay <= 255 */
					*trkdata[Trk].zmd++ = 0x00;
					step_ -= delay;
					if (gate_ != 0xFFFF) {
						gate_ -= delay;
					}
				}
			}
			if (gate_ <= 0) {
				gate_ = 1;
			}
			setVelo0(trkdata,Trk,v[notes - 1],&relvelo,trkinf,cominf,step_);
			/* vSeqLoopChk(Trk,trkinf); */			/* velo.seq loop check */
			if (trkinf[Trk].veloseqsw) {	/* add v1.30 */
				vSeqLoopChk(Trk,trkinf);
			}
			zms = setTie2(zms,trkdata,Trk,trkinf,note[notes - 1],&step_,gate_,relvelo,cominf);
		}
		if (++*qpos >= trkinf[Trk].quantizenum) {
			*qpos = 0;
		}
	}
	return zms;
}
UBYTE *makePortament(UBYTE *zms,TRKCHINF *trkdata, const BYTE target[],
						TRKINF *trkinf,COMMONINF *cominf)
{
	LINEDATA *ld_ = ld;
	UBYTE *linebuf_ = linebuf;
	UBYTE *zms_ = zms;
	int trk;
	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		BYTE note[9];
		VELOETCVAR v[9];
		UWORD step_, gate_;
		WORD delay = trkinf[Trk].pdelay;
		BYTE *qpos = &(trkinf[Trk].quantizepos);
		int notes;
		WORD br,add,cor;
		/* const BYTE vnum = trkinf[Trk].veloznum; */
		const WORD pdata[25]={ -8192,-7513,-6830,-6147,-5464,-4781,
								-4098,-3415,-2732,-2049,-1366,-683,
								0,683, 1366, 2049, 2732, 3415, 4098,
								 4781, 5464, 6147, 6830, 7513, 8191 };
		ld = ld_;
		zms = makePortChord(zms_,Trk,trkinf,cominf,
					')',/*1,*/v,note,&notes,&step_,&gate_,&delay);
		if (notes != 2) {
			/* zmserror("portament requires 2 tones.",linebuf_,zms_,0,1); */
			if (checkCommonCommand(zms_,notes,note,step_,linebuf_,cominf)) {
				return zms;		/* if (d0) || (d1), return at once */
			}
		} else if (delay < 0) {
			zmserror("delay must not be under zero.",linebuf_,zms_,0,1);
		} else if (!step_) {
			zmserror("illegal step length.",linebuf_,zms,0,1);
		}
		{	/* add v1.25 */
			int i, p = -1;
			for (i = 0; i < 2; i++) {
				if (v[i].relflg[0] != 2) {
					p = i;
					break;
				}
			}
			if (p == -1) {
				setVelo(trkdata,Trk,trkinf,cominf,step_);		/* velocity set */
			} else {
				BYTE relvelo = 0;
				setVelo0(trkdata,Trk,v[p],&relvelo,trkinf,cominf,step_);
			}
		}
		vSeqLoopChk(Trk,trkinf);
		*trkdata[Trk].zmd++ = 0xE0;
		*trkdata[Trk].zmd++ = note[0];

		/* add v1.33 */
		if (abs(note[1] - note[0]) > 12) {		/* portament over an octave */
			int tmp;
			zmserror("Portament over an octave doesn't work well.",linebuf_,zms_,2,1);
			if (note[1] > note[0]) {
				tmp = note[0] + 12;
				if (tmp > 127) {
					tmp = 127;
				}
			} else {
				tmp = note[0] - 12;
				if (tmp < 0) {
					tmp = 0;
				}
			}
			note[1] = tmp;
		}

		putWord(trkdata[Trk].zmd, step_);
		if (step_) {
			checkRenpu(trkdata,Trk,trkinf,1);
		}
		incrementStepCounters(&trkinf[Trk], step_);
#ifdef AAA
		if (!trkinf[Trk].renpnotes) {
			trkinf[Trk].total += step_;
			if (trkinf[Trk].s->prev) {
				trkinf[Trk].s->step += step_;
			}
		}
#endif
		trkdata[Trk].zmd += 2;
		putWord(trkdata[Trk].zmd, gate_);
		trkdata[Trk].zmd += 2;
		putWord(trkdata[Trk].zmd, delay);
		trkdata[Trk].zmd += 2;
		trkinf[Trk].pdelay = delay;
		step_ -= delay;
		/* br  = (note[1] - note[0]) * 683; */		/* bend range */
/* (BEGIN FM/ADPCMsupport by Mamiya */
		if (checkInternalDevice(trkdata,Trk) & 1) {
			br  = (((int)note[1]) - ((int)note[0])) << 6 ;
		} else {
			br  = pdata[note[1] - note[0] + 12];	/* bend range */
		}
/* FM/ADPCMsupport by Mamiya END) */
		makePortBresemhamPara(br,&add,&cor,step_);
			putWord(trkdata[Trk].zmd, add);
		trkdata[Trk].zmd += 2;
		*trkdata[Trk].zmd++ = cor & 0xFF;
		*trkdata[Trk].zmd++ = (add >= 0)? 1 : 0xFF;
/*
		if (vnum > 0 && ++(trkinf[Trk].velozpos) >= vnum) {
			trkinf[Trk].velozpos = 0;
		}
*/
		/* if (trkinf[Trk].quantize[++*qpos].relflg[0] < 0) { */
		if (++*qpos >= trkinf[Trk].quantizenum) {
			*qpos = 0;
		}
	}
	return zms;
}
int checkCommonCommand(UBYTE *zms_,int notes,BYTE note[],UWORD step_,
						char *linebuf_, COMMONINF *cominf)
{
	int ret = 0;
	if (notes == 1 && (note[0] % 12) == 2) {
		if (step_ == 0 || step_ == cominf->div) {	/* (d0) || (d1) */
			cominf->debug = (step_)? 1 : 0;
			ret = 1;
		} else {
			zmserror("portament requires 2 tones.",linebuf_,zms_,0,1);
		}
	} else {
		zmserror("portament requires 2 tones.",linebuf_,zms_,0,1);
	}
	return ret;
}