#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "parsesub.h"
#include "etc.h"


#include "structs.h"
#include "structs2.h"
UBYTE *getSpecialVelocity(UBYTE *zms,VELOETCVAR *v);
void setVelo0(TRKCHINF *trkdata, const int Trk,VELOETCVAR v,BYTE *relvelo,TRKINF *trkinf,
				COMMONINF *cominf,UWORD step);
int setVelo(TRKCHINF *trkdata, const int Trk,TRKINF *trkinf,COMMONINF *cominf,UWORD step);
void vSeqLoopChk(const int Trk,TRKINF *trkinf);
UBYTE *setMMLatU(UBYTE *zms,TRKCHINF *trkdata,TRKINF *trkinf,const BYTE target[]);
inline DWORD rand2(DWORD r);
UBYTE *makeZmdRandVelo(UBYTE *zms, const int Trk, TRKINF *trkinf);
int setVeloRevise(TRKINF *trkinf, const int Trk,COMMONINF *cominf,UWORD step);


extern char *linebuf;
extern LINEDATA *ld;




/* ===============================================
     get Special Velocity from MML, if there is.
   =============================================== */

UBYTE *getSpecialVelocity(UBYTE *zms,VELOETCVAR *v)
{
	v->relflg[0] = 2;		/* 0:abs 1:rel 2:omit -1:guardian */

	if (*zms == ',') {
		DWORD velo;
		int err;

		zms = skipSpcCr(++zms);
		if (*zms == '+') {
			v->relflg[0] = 1;
		} else if (*zms == '-') {
			v->relflg[0] = -1;
		}
		zms = getnum2(zms, &velo, &err);
		if (err < 0) {		/* no value */
							/* put error */
		} else {
			if (v->relflg[0] == 2) {
				v->relflg[0] = 0;
			}
			if (v->relflg[0] < 0) {
				v->relflg[0] = 1;
				v->var[0] = velo;	/* -velo; */
			} else {
				v->var[0] = velo;
			}
		}
	}
	return zms;
}


/* set special velocity */

void setVelo0(TRKCHINF *trkdata, const int Trk,VELOETCVAR v,BYTE *relvelo,TRKINF *trkinf,
				COMMONINF *cominf,UWORD step)
{
	/* const int Trk = target[trk]; */

	/* zms = getSpecialVelocity(zms,v); */
	if (v.relflg[0] != 2) {			/* special velocity is there */
		BYTE *vpos = &(trkinf[Trk].velozpos);		/* calc random parameter */
		const WORD rvar = trkinf[Trk].velocity[*vpos].var[1];
		const DWORD r = trkinf[Trk].velou.var[1];
		WORD vrvar = 0;

		if ( trkinf[Trk].velocity[*vpos].var[1] ) {		/* random? */
			vrvar = rvar;
		} else if (r) {
			vrvar = r;
		}
		if (vrvar) {
			vrvar = rand2(vrvar);
		}
		if (v.relflg[0] == 1) {
			if (v.var[0] >= 0) {
				*trkdata[Trk].zmd++ = 0xDA;
				*trkdata[Trk].zmd++ = v.var[0] + vrvar;
			} else {
				*trkdata[Trk].zmd++ = 0xDB;
				*trkdata[Trk].zmd++ = -v.var[0] + vrvar;
			}
		} else {
			*trkdata[Trk].zmd++ = 0xD9;
			*trkdata[Trk].zmd++ = v.var[0] + vrvar;
		}
/* printf("[vv=%d]",v->var); */
		*relvelo = trkinf[Trk].spvelomode = 1;
	} else {
		if (setVelo(trkdata,Trk,trkinf,cominf,step)) {
			*relvelo = trkinf[Trk].spvelomode = 1;
		}
	}
/*
	if (trkinf[Trk].veloseqsw) {
		vSeqLoopChk(Trk,trkinf);
	}
*/
}



/* =======================
     set normal velocity
     (velocity sequence)
     return 1, if random pattern(special velocity) is used.
   ======================= */

int setVelo(TRKCHINF *trkdata, const int Trk,TRKINF *trkinf,COMMONINF *cominf,UWORD step)
{
	BYTE *vpos = &(trkinf[Trk].velozpos);
	WORD vvar = 0;
	const WORD rvar = trkinf[Trk].velocity[*vpos].var[1];
	/* const BYTE vnum = trkinf[Trk].veloznum; */
	const DWORD r = trkinf[Trk].velou.var[1];
	int ret = 0;

	recoverSpecialVelocity(trkinf, trkdata, Trk);
	if ( trkinf[Trk].velou.relflg[0] && trkinf[Trk].veloseqsw) {
														/* Z  velocity */
														/* veloz[1].relflg[0] is set
														 * by setVelocitySequenceMode */
		*trkdata[Trk].zmd++ = 0xB9;
		*trkdata[Trk].zmd++ = trkinf[Trk].velocity[*vpos].var[0];
		if ( rvar ) {		/* random? */
/* printf("#%d",trkinf[Trk].veloz[*vpos].var[1]); */
			vvar = rand2(rvar);
			ret = 1;
		}
		/* *velo = vvar; */
	} else if (r) {										/* random parameter */
		vvar = rand2(r);
		ret = 1;
	}
	if (trkinf[Trk].randvelopower) {
		vvar += -setVeloRevise(trkinf,Trk,cominf,step);
		ret = 1;
	}

	if (ret) {
		*trkdata[Trk].zmd++ = (vvar >= 0)? 0xDA : 0xDB;
		*trkdata[Trk].zmd++ = (vvar >= 0)? vvar : -vvar;
	}
	/* vSeqLoopChk(Trk,trkinf); */

	return ret;
}


void vSeqLoopChk(const int Trk,TRKINF *trkinf)
{
	/* BYTE *vpos = &(trkinf[Trk].velozpos); */
	const BYTE vnum = trkinf[Trk].veloznum;

	/* if (vnum > 0) { */
	if (trkinf[Trk].velou.relflg[0]) {
		if (++(trkinf[Trk].velozpos) >= vnum) {
			trkinf[Trk].velozpos = 0;
		}
	}
}


UBYTE *setMMLatU(UBYTE *zms,TRKCHINF *trkdata,TRKINF *trkinf,const BYTE target[])
{
	UBYTE *zms_ = zms;
	int trk;

	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		BYTE rel = 0;
		DWORD velo,v = trkinf[Trk].velou.var[0];
		DWORD r = trkinf[Trk].velou.var[1];
		DWORD rp = (r)? rand2(r) : 0;
		int err;
		/*	line = line_; */
		zms = skipSpcCr(zms_);
		if (*zms == '+') {
			rel = 1;
		} else if (*zms == '-') {
			rel = -1;
		}
		zms = getnum2(zms, &velo, &err);

		zms = skipSpcCr(zms);
		if (*zms == ':' && *(zms + 1) != '|') {
			int err2;
			zms = skipSpcCr(zms + 1);
			zms = getnum2(zms, &r, &err2);
			r = abs(r);
			rp = (r && !err2)? rand2(r) : 0;
			trkinf[Trk].velou.var[1] = r;
		}
		if (err < 0) {				/* only '@u' */
			if (trkinf[Trk].relvelo != 0) {	/*relational value */
				v += trkinf[Trk].relvelo;
			} else {						/* absolute value */
				v = trkinf[Trk].velou.var[0];
			}
		} else {
			if (rel) {
				v += velo;
				trkinf[Trk].relvelo = rel * velo;
			} else {
				v = velo;
				trkinf[Trk].relvelo = 0;
			}
			v += rp;
			if (v > 127) {
				v = 127;
			} else if (v < 0) {
				v = 0;
			}
			trkinf[Trk].velou.var[0] = v;
		}
		*trkdata[Trk].zmd++ = 0xB9;
		*trkdata[Trk].zmd++ = v;
		/* trkinf[Trk].veloznum = 0; */
		setVelocitySequenceMode(trkinf,Trk,0);
	}
	return zms;
}



/* ===================================
     get random number: -r <= x <= r
   =================================== */

inline DWORD rand2(DWORD r)
{
	return (rand() % (r * 2 + 1)) - r;
}




UBYTE *makeZmdRandVelo(UBYTE *zms, const int Trk, TRKINF *trkinf)
{
	DWORD randvelotype,randvelopower;
	int err;

	zms = skipSpc(zms);
	zms = getnum2(zms,&randvelotype,&err);
	trkinf[Trk].randvelotype = (err)? 0 : randvelotype;


	zms = skipSpc(zms);
	if (*zms != ',') {
		if (*zms != ']') {
			zmserror("SYNTAX ERROR.",linebuf,zms,0,1);
		} else {
			return zms;
		}
	}
	zms = skipSpc(zms + 1);
	zms = getnum2(zms,&randvelopower,&err);
	trkinf[Trk].randvelopower = (err)? 0 : randvelopower;

	zms = skipSpc(zms);
	if (*zms != ']') {
		zmserror("SYNTAX ERROR.",linebuf,zms,0,1);
	}

	return zms + 1;		/* skip ] */
}



/* ========================
     returns revise value
   ======================== */
int setVeloRevise(TRKINF *trkinf, const int Trk,COMMONINF *cominf,UWORD step)
{
/*
|@@@[VELOCITY.REVISE type,power] ƂƁAuZȂ
|@@Ȃقǃ}CiXɃxVeB_␳v悤
|@@ȂBpower␳̋(0ŕ␳It)Atype␳Ȑw
|@@(0=logȐ␳ 1=`␳1 2=`␳2 ...)B
|@@@ftHgł͕␳ItB
*/
	int ret = 0;
	const int randvelotype = trkinf[Trk].randvelotype;

	switch(randvelotype) {
		case 16:
		case 24:
			if (trkinf[Trk].laststep >= step * 2) {
				break;
			}
			/* NO BREAK */
		case  0:		/* log */
		case  8:
			{
				int div1,div2,temp;

				for (div1 = 0, temp = cominf->div; temp; div1++, temp /= 2) {
				}
				for (div2 = 0, temp = step;        temp; div2++, temp /= 2) {
				}
				if ((randvelotype / 8) & 1) {
					div1 -= 2;
				}
				ret = trkinf[Trk].randvelopower * (div1 - div2);
			}
			break;
		case 1:		/* linear1 */
			ret = trkinf[Trk].randvelopower * (cominf->div / step);
			break;
		case 2:		/* linear2 */
			ret = (cominf->div / step) / trkinf[Trk].randvelopower;
			break;
		default:
			return 0;
	}

	trkinf[Trk].laststep = step;
	return ret;
}


