/* ======================================
     ZMC2.{X,EXE} ... ZMS->ZMD compiler
     for non X680x0 architectures
   ====================================== */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "config.h"
#ifdef UNIXY_OS
	#define inpEXT ".zms"
	#define outEXT ".zmd"
#else
	#define inpEXT ".ZMS"
	#define outEXT ".ZMD"
#endif
/* ryk ==> */
#ifdef ZMC2_STATIC_LIB	/* Static lib */
	#include "setjmp.h"
	#include "etc.h"
	int ZMC2Main(int , char **);
	extern jmp_buf g_zmc2mark;
#endif
/* <== ryk */
#ifndef UNIXY_OS					/* for setmode() */
	#include <fcntl.h>
	#include <io.h>
	#ifdef X68000
		#include <unistd.h>
	#endif
#endif
#include "switch.h"
#include "readfile.h"
#include "makezmd.h"
#include "etc.h"
void help(int exitcode,int helpmode);
void convertCR(char *p);
void checkSwitch(void);
#ifndef EXIT_SUCCESS
	#define EXIT_SUCCESS	0
#endif
/* ryk ==> */
#ifdef ZMC2_STATIC_LIB	/* Static lib */
int ZMC2Main(int argc,char *argv[])
#else
int main(int argc,char *argv[])
#endif
/* <== ryk */
{
	UBYTE		*zmsbuf;
	TRKCHINF	*trkdata;
	COMMONINF	cominf;
	int i;
/* ryk ==> */
#ifdef ZMC2_STATIC_LIB	/* Static lib */
	int			result;
	extern jmp_buf g_zmc2mark;
	result = setjmp(g_zmc2mark);
	if(result != 0) {
		return(result);
	}
#endif
/* <== ryk */
	initMemMaster();				/* initialize emalloc/efree entry */
	srand(time(NULL));
	i = getSwitch(argc,argv);					/* get switches/sourcefilename/dest.file */
	/* setvbuf(stderr,NULL,_IONBF,0); */		/* no output buffering */
	ZMC2FormatMessage(stderr,"ZMS to ZMD(V2) compiler version 1.35, by Mamiya / YokoMuMu / Y.Yagi,\n");
	ZMC2FormatMessage(stderr,"from Z-MUSIC UNIVERSAL VERSION 2.08 (C) ZENJI SOFT\n");
	if (i) {									/* bootup without any arguments */
		help(0,0);
	}
	checkSwitch();
	if (!getInFile()[0]) {
#ifdef UNIXY_OS
		setInFile("-");
#else
		fatal(FILENOTFOUND,"Error: source file is not specified.\n");
#endif
	}
	zmsbuf = readFile(getInFile(),getOutFile(),inpEXT,outEXT);
	convertCR(zmsbuf);							/* convert CR code */
	trkdata = makeZmd(zmsbuf,getInFile(),&cominf);
	do {										/* file write */
		int trks = 0;
		FILE *fp;
		DWORD bytes;
		DWORD offset;
		UBYTE tmp[6];
		int stdoutflg = 0;
		if (getSwitchVal('c') != RES_VAL) {		/* use stdout */
			stdoutflg = 1;
		}
		if (stdoutflg) {
#ifndef UNIXY_OS								/* set stdout to binary mode (MS-DOS only) */
	#if defined (X68000) && defined (XCLIB)
		fmode(stdout, _IOBINARY);				/* for X68000(XC) */
	#elif defined (TOWNS)
		_setmode(stdout, _BINARY);				/* for TOWNS(High-C) */
	#else
		setmode(fileno(stdout),O_BINARY);		/* for Win32/16, DOS, OS/2, X680x0(libc) */
	#endif
#endif	/* UNIXY_OS */
			fp = stdout;
		} else {
			fp = fopen(getOutFile(),"wb");
			if (fp == (FILE*)NULL) {
				fatal(1,"%s\tError: destination file can't open.",getOutFile());
			}
		}
		/* hedder part1 */
		bytes = fwrite(trkdata[0].zmdbuf,sizeof(UBYTE),trkdata[0].nowsize,fp);
		if (!stdoutflg && bytes < trkdata[0].nowsize) {
			fatal(1,"%s\tError: destination file can't write.",getOutFile());
		}
		efree(trkdata[0].zmdbuf, "trkdata[0].zmdbuf");
		for (i = 0; cominf.trkassign[i] >= 0;) {
			if (getSwitchVal('z') > 2) {
				/* Compatible with ZMUSIC.X -c(optimize mode) */
				if (trkdata[cominf.trkassign[i]].nowsize <= 1) {
					memcpy(cominf.trkassign + i, cominf.trkassign + i + 1, (80 - i) * sizeof(cominf.trkassign[0]));
					/*cominf.trkassign[80] = -1;*/
					continue;
				}
			}
			i++;
			trks++;
		}
/* printf("trks=%d\n",trks); */
		putWordAlign(tmp,trks);
		bytes = fwrite(tmp,sizeof(UBYTE),2,fp);
		if (!stdoutflg && bytes < 2) {
			fatal(1,"%s\tError: destination file can't write.",getOutFile());
		}
		offset = trks * 6 - 4;
		/* hedder part2 */
		for (i = 0; i < trks; i++) {
			/* putDwordAlign(tmp,offset); */
			putDword(tmp,offset);
			*(tmp + 4) = (trkdata[cominf.trkassign[i]].ch_ == 8) ? 0x80 : 0;
			*(tmp + 5) = trkdata[cominf.trkassign[i]].ch_;
			bytes = fwrite(tmp,sizeof(UBYTE),6,fp);
			if (!stdoutflg && bytes < 6) {
				fatal(1,"%s\tError: destination file can't write.",getOutFile());
			}
			offset += trkdata[cominf.trkassign[i]].nowsize;
			offset -= 6;
		}
		/* data */
		for (i = 0; i < trks; i++) {
			bytes = fwrite(trkdata[cominf.trkassign[i]].zmdbuf,sizeof(UBYTE),
							trkdata[cominf.trkassign[i]].nowsize,fp);
			if (!stdoutflg && bytes < trkdata[cominf.trkassign[i]].nowsize) {
				fatal(1,"%s\tError: destination file can't write.",getOutFile());
			}
			efree(trkdata[cominf.trkassign[i]].zmdbuf, "trkdata[cominf.trkassign[i]].zmdbuf");
		}
		if (!stdoutflg) {
			fclose(fp);
		}
	} while (0);
	efree(trkdata, "trkdata");
	/* free(zmsbuf); */		/* already free-ed  in v3macro.c */
	#ifdef MEMDEBUG
		memdebug();
	#endif
	
	efreeAll();
	return	EXIT_SUCCESS;
}
/* ================
       put usage
   ================ */
void help(int exitcode,int helpmode)
{
	const char *helpmes[] = {
#ifdef UNIXY_OS
		"usage: zmc2 [-switches] source[.zms] [-o destination[.zmd]] [-e errfile]",
#else
		"usage: zmc2 [-switches] source[.ZMS] [-o destination[.ZMD]] [-e errfile]",
#endif
#if WARNLVL == 1
		"switch: -Wnum        warning level(1=none(default), 2=as V2(traditional),",
		"                                   3=as V3, 4=most strict)",
#elif WARNLVL == 2
		"switch: -Wnum        warning level(1=none, 2=as V2(traditional,default),",
		"                                   3=as V3(default), 4=most strict)",
#elif WARNLVL == 3
		"switch: -Wnum        warning level(1=none, 2=as V2(traditional),",
		"                                   3=as V3(default), 4=most strict)",
#else
		"switch: -Wnum        warning level(1=none, 2=as V2(traditional),",
		"                                   3=as V3, 4=most strict(default))",
#endif
		"        -Rnum        warning level(regard as error; stop compiling immediately)",
		"        -Znum        compatible level(1=normal(default), 2=ZMUSIC.X -C,",
		"                                      3=ZMUSIC.X -c)",
		"        -            use standard input",
		"        -c           use standard output",
		"        -e errfile   redirect stderr to specified file",
		"        -l           change warning/error message pattern",
		"        -o destname  specify ZMD filename",
		"        -h           show this help messages",
		/* "", */
		/* "Some FM/ADPCM MMLs will be ignored. (however to be supported)", */
		/* "FM/ADPCM MMLs will be ignored.", */
/*
		"",
		"If you want to show TIPS, type; zmc2 -h1 | more",
*/
		NULL,
		"zmc2 tips",
		"  When warning level is 1 or 2, zmc2-extended-MML will be warned.",
		"e.g. YAMAHA-exclusive, portament MML at begining of line",
		"",
		"You can get the latest version at http://www2s.biglobe.ne.jp/~yyagi/",
		NULL
	};
	char **str = (char**)helpmes;
	if (helpmode) {
		while (*str++ != NULL)
			;
	}
	do {
/*		fputs(*str++,stderr); */
/*		fputs("\n",stderr); */
		ZMC2AddMessage(stderr, *str++);		/* ryk */
		ZMC2AddMessage(stderr, "\n");		/* ryk */
	} while (*str != NULL);
		terminateProgram(exitcode);
/* ryk ==> */
#ifdef ZMC2_STATIC_LIB	/* Static lib */
		longjmp(g_zmc2mark, exitcode);
#endif
/* <== */
}


/* ===================
     convert CR code
   =================== */
void convertCR(char *p)
{
	--p;
	while (*++p != (char)0xFF) {		/* until gurdian-code comes... */
		if (*p == ignoreCR) {	/* ignoreCR: 0x0D for unix/DOS, 0x0A for Mac. */
			*p = SPACE;
		}
	}
}

/* ==================
     check switches
   ================== */
void checkSwitch(void)
{
	int tmp;
	tmp = getSwitchVal('h');
	if (tmp == 1) {
		help(0,1);
	} else if (tmp != RES_VAL) {
		help(0,0);
	}
	if (getOutFile()[0] && getSwitchVal('c') != RES_VAL) {
		fatal(TOOMANYFILES,"You cannot use both -c and -o.\n");
	}
	if (getSwitchVal('w') == SET_VAL) {
		fatal(SWERR,"You cannot omit -w's parameter.\n");
	}
}